%o 5000
%{
#include<string.h>
#include"inf.tab.h"
#undef ECHO
#define ECHO {}

extern YYSTYPE yylval ;
extern int infParseLine  ;

%}

%%
[ \t]+  {;}
[\n]+  {infParseLine++;}
^[#]+.*         {ECHO;}
[eE][nN][dD]            {ECHO;return(T_END);} ;
[iI][nN][fF][oO]        {ECHO;return(T_HELP_S);} ;
[hH][eE][lL][pP][_][sS]    {ECHO;return(T_HELP_S);};
[rR][eE][nN][aA][mM][eE] {ECHO;return(T_RENOM);} ;
[cC][oO][nN][sS][tT][rR][aA][iI][nN][tT] {/* MODIF PAYAM */ ECHO;return(T_CONSTRAINT);} ;
[bB][yY][pP][aA][sS][sS] {ECHO;return(T_BYPASS);} ;
[pP][rR][eE][cC][hH][aA][rR][gG][eE]     {ECHO;return(T_PRECHARGE);} ;
[aA][lL][iI][mM]        {ECHO;return(T_ALIM);};
[iI][nN][oO][uU][tT]    {ECHO;return(T_INOUT);} ;
[iI][nN]                {ECHO;return(T_IN);} ;
[oO][uU][tT]            {ECHO;return(T_OUT);} ;
[mM][uU][tT][eE][xX]    {ECHO;return(T_MUTEX);};
[mM][uU][xX][uU][pP]    {ECHO;return(T_MUXU);};
[mM][uU][xX][dD][nN]    {ECHO;return(T_MUXD);};
[cC][mM][pP][uU][pP]    {ECHO;return(T_CMPU);};
[cC][mM][pP][dD][nN]    {ECHO;return(T_CMPD);};
[^ \t\n;:{},~<>]*         {ECHO; strcpy(yylval.istr,yytext); return(T_NAME);} ;
[;]         {ECHO; return(*yytext) ; } ; 
[:]         {ECHO; return(*yytext) ; } ; 
[{]         {ECHO; return(*yytext) ; } ; 
[}]         {ECHO; return(*yytext) ; } ; 
[,]         {ECHO; return(*yytext) ; } ; 
[~]         {ECHO; return(*yytext) ; } ; 
[<]         {ECHO; return(*yytext) ; } ; 
[>]         {ECHO; return(*yytext) ; } ; 
%%

static int yywrap()
{
return(1);
}

