/*********************************************************************\

    File        :    dpr.h

    Date        :   30-06-94
    Version     :   1

    Auteur      :   BEAURIN oliver

\*********************************************************************/

#ifndef DPP_H
#define DPP_H

/*---------------------------------------------------------\
                    defines
\---------------------------------------------------------*/
#define VERBOSE_NORMAL 1
#define VERBOSE_ALL    2

/*---------------------------------------------------------\
                     structures
\---------------------------------------------------------*/
/*
 * PATCH AsGa : Parametrage de la technologie.
 */

typedef struct {
	char  LAYER_ALIM;  /* Layer des alimentations.   */
	long   TOP_TRACK;  /* Derniere piste (sous VDD). */
	long   BOT_TRACK;  /* Premiere piste (sur  VSS). */
	} DPR_Var_t;

/*---------------------------------------------------------\
                     externs
\---------------------------------------------------------*/
extern char verbose_mode;
extern char debug_mode;
extern DPR_Var_t  DPR_Var;

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/
#ifdef __STDC__

extern void savephfig     ( void * );
extern void savelofig     ( void * );
extern void unflattenlofig( void *, char *, char *, void * );
extern void rflattenphfig ( void *, char, char );

#else

extern void savephfig     ( );
extern void savelofig     ( );
extern void unflattenlofig( );
extern void rflattenphfig ( );

#endif

#define TRUE  1
#define FALSE 0

#endif
