/*********************************************************************\

    File        :   placer_utils.h

    Date        :   27-09-94
    Version     :   1

    Auteur      :   BEAURIN oliver

\*********************************************************************/

#ifndef PLACER_UTILS_H
#define PLACER_UTILS_H

/*---------------------------------------------------------\
                     includes
\---------------------------------------------------------*/
#include MLO_H
#include MPH_H

#include "placer_structure.h"

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/
#ifdef __STDC__

extern void  freelofigchain            ( lofig_list * );
extern long  nbcells_of_lofig          ( char * );
extern long  YtoSlice                  ( placement *, column *, con_EW * );
extern char *getonemorelevelconname    ( char *, lofig_list *, char * );
extern char *get_con_name_from_ref_name( char * );
extern long  getindex                  ( char * );
extern int   isindexed                 ( char * );
extern char  islogic_column            ( char *, long );

#else

extern void  freelofigchain            ( );
extern long  nbcells_of_lofig          ( );
extern long  YtoSlice                  ( );
extern char *getonemorelevelconname    ( );
extern char *get_con_name_from_ref_name( );
extern long  getindex                  ( );
extern int   isindexed                 ( );
extern char  islogic_column            ( );

#endif

#endif /* PLACER_UTILS_H */
