/*********************************************************************\

    File        :    placer_create_grid.h

    Date        :    27-09-1994
    Version     :    1.0

    Auteur      :    BEAURIN oliver

\*********************************************************************/

#ifndef PLACER_CREATE_GRID
#define PLACER_CREATE_GRID

/*---------------------------------------------------------\
                     includes
\---------------------------------------------------------*/
#include MUT_H
#include MLO_H
#include MPH_H

#include "placer_structure.h"

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/

#ifdef __STDC__

extern alim   *create_alim_list_from_connectors( phcon_list * );
extern alim   *create_alim_list_two_levels     ( char * );
extern slice  *create_slice_list               ( slice *, char *, char *, long, char );
extern slice  *create_slice_list_for_glue      ( char *, char *, long );
extern column *create_column_one_level         ( column *, char *, char *, char );
extern void    create_column_two_level         ( column *, char * );

#else

extern alim   *create_alim_list_from_connectors( );
extern alim   *create_alim_list_two_levels     ( );
extern slice  *create_slice_list               ( );
extern slice  *create_slice_list_for_glue      ( );
extern column *create_column_one_level         ( );
extern void    create_column_two_level         ( );

#endif

#endif /* PLACER_CREATE_GRID */
