#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "drucompi.yac"
#include <stdio.h>
#include MPH_H
#include MUT_H
#include RDS_H
#include RUT_H
#include RTL_H
#include RWI_H
#include RFM_H
#include RPR_H
#include "drucutil.h"
#include "drucompi.h"

/*------------------------------------------------------------\
|                                                             |
|                  Druc MODIFICATIONS                         |
|                                                             |
|  Patrick: 07/03/94                                          |
|    Ajouter DRUC_FRONTALE et DRUC_LATERALE_MIN               |
|    qui etaient oublies dans les derivations                 |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                  Druc Variables LEX/YACC                    |
|                                                             |
\------------------------------------------------------------*/
extern int   yylineno;
extern FILE *yyin;
       int   DrucIndexMesure;
       int   DrucInputEntier;
       float DrucInputFloat;
       char  DrucInputChaine[DRUC_MAX_STRING_BUFFER + 1];
#line 39 "y.tab.c"
#define DRUC_REGLES 257
#define DRUC_FIN 258
#define DRUC_REGLE 259
#define DRUC_DEFINE 260
#define DRUC_UNDEFINE 261
#define DRUC_CARACTERISE 262
#define DRUC_RELATION 263
#define DRUC_LAYER 264
#define DRUC_NOM 265
#define DRUC_UNION 266
#define DRUC_EXCLUSION 267
#define DRUC_ENVELOPPE 268
#define DRUC_MARGE 269
#define DRUC_CROIX 270
#define DRUC_INTERSECT 271
#define DRUC_EXTENSION 272
#define DRUC_INCLUSION 273
#define DRUC_DISTANCE 274
#define DRUC_SURFACE_INTER 275
#define DRUC_LONG_INTER 276
#define DRUC_LARGE_INTER 277
#define DRUC_PENET_INTER 278
#define DRUC_PARAL_INTER 279
#define DRUC_PERPEN_INTER 280
#define DRUC_FRONTALE 281
#define DRUC_LATERALE_MIN 282
#define DRUC_LATERALE_MAX 283
#define DRUC_LARGEUR_MIN 284
#define DRUC_LARGEUR_MAX 285
#define DRUC_LONGUEUR_MIN 286
#define DRUC_LONGUEUR_MAX 287
#define DRUC_SUP 288
#define DRUC_INF 289
#define DRUC_AXIALE 290
#define DRUC_GEODESIQUE 291
#define DRUC_SURFACE 292
#define DRUC_LONGUEUR 293
#define DRUC_LARGEUR 294
#define DRUC_MIN 295
#define DRUC_MAX 296
#define DRUC_INFEQ 297
#define DRUC_SUPEQ 298
#define DRUC_DIFF 299
#define DRUC_NOTCH 300
#define DRUC_ENTIER 301
#define DRUC_FLOAT 302
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    2,    3,    6,    0,    1,    1,    8,    9,    7,    4,
    4,   10,   10,   10,   10,   15,   17,   18,   11,   16,
   16,   16,   16,   19,   12,   20,   13,   21,   21,   23,
   24,   27,   22,   28,   29,   30,   14,   31,   31,   33,
   34,   37,   32,   35,   35,   35,   35,   35,   35,   35,
   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
   36,   36,   36,   36,   36,   36,   36,   25,   25,   25,
   25,   25,   25,   25,   26,   26,   26,   26,   26,   26,
   26,   26,    5,
};
short yylen[] = {                                         2,
    0,    0,    0,    9,    2,    1,    0,    0,    6,    2,
    1,    1,    1,    1,    1,    0,    0,    0,   11,    1,
    1,    1,    1,    0,    4,    0,    7,    2,    1,    0,
    0,    0,   10,    0,    0,    0,   11,    2,    1,    0,
    0,    0,   11,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,
};
short yydefred[] = {                                      1,
    0,    0,    0,    0,    6,    7,    0,    5,    0,    0,
    8,    0,    0,    0,   34,    0,   11,   12,   13,   14,
   15,    0,   16,   24,   26,    0,    0,   10,    9,    0,
    0,    0,   35,    3,    0,   25,    0,    0,   83,   20,
   22,   21,   23,    0,   30,    0,   29,    0,    4,   17,
    0,    0,   28,   36,    0,   31,   27,    0,    0,    0,
    0,   18,    0,   40,    0,   39,    0,   72,   73,   74,
   68,   69,   70,   71,    0,    0,    0,   38,   19,   75,
   76,   77,   78,   82,   81,   79,   80,    0,   41,   37,
   32,    0,    0,    0,   33,   48,   49,   50,   45,   46,
   47,   44,    0,   51,   52,   53,   54,   55,   56,   61,
   62,   63,   59,   60,   57,   58,   64,   65,   66,   67,
    0,    0,   42,    0,   43,
};
short yydgoto[] = {                                       1,
    4,    2,    7,   16,   49,   39,    5,    9,   22,   17,
   18,   19,   20,   21,   30,   44,   55,   67,   31,   32,
   46,   47,   51,   60,   75,   88,   93,   26,   38,   58,
   65,   66,   76,   92,  103,  121,  124,
};
short yysindex[] = {                                      0,
    0, -254, -253, -254,    0,    0, -246,    0, -288, -235,
    0, -248, -236, -210,    0, -242,    0,    0,    0,    0,
    0,   -3,    0,    0,    0, -208, -199,    0,    0,   -2,
    1,   21,    0,    0, -258,    0, -197,   19,    0,    0,
    0,    0,    0, -201,    0,  -38,    0, -200,    0,    0,
 -234,    7,    0,    0,   24,    0,    0,   29, -195,   13,
 -187,    0, -270,    0,  -37,    0,   14,    0,    0,    0,
    0,    0,    0,    0,  -60, -227,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -226,    0,    0,
    0,   20,   18, -220,    0,    0,    0,    0,    0,    0,
    0,    0, -244,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -60, -223,    0,   22,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0, -177,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,   78,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   38,    0,    0,    0,  -36,    0,    0,    0,    0,
    0,   23,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 239
short yytable[] = {                                      86,
   85,   87,   52,   77,   68,   69,   70,   40,   41,    3,
   10,    6,   42,   11,   43,   27,   23,   12,   13,   14,
   15,   71,   72,   73,   12,   13,   14,   15,   24,   74,
  104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,   96,   97,   98,
   99,  100,  101,  102,   25,   29,   33,   34,   35,   36,
   37,   45,   48,   50,   54,   57,   56,   59,   61,   62,
   63,   64,   79,   89,   90,   91,   95,   94,  123,    2,
  125,    8,   28,   53,  122,    0,    0,   78,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,   64,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   80,   81,   82,   83,   84,
};
short yycheck[] = {                                      60,
   61,   62,   41,   41,  275,  276,  277,  266,  267,  264,
  257,  265,  271,  302,  273,  258,  265,  260,  261,  262,
  263,  292,  293,  294,  260,  261,  262,  263,  265,  300,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  268,  269,  270,
  271,  272,  273,  274,  265,   59,  265,  257,   61,   59,
   40,  259,   44,  265,  265,   59,  301,   44,   40,  265,
   58,  259,   59,  301,   59,  302,   59,   58,  302,  257,
   59,    4,   16,   46,  121,   -1,   -1,   65,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  259,  259,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  295,  296,  297,  298,  299,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 302
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'","';'","'<'",
"'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"DRUC_REGLES","DRUC_FIN","DRUC_REGLE","DRUC_DEFINE","DRUC_UNDEFINE",
"DRUC_CARACTERISE","DRUC_RELATION","DRUC_LAYER","DRUC_NOM","DRUC_UNION",
"DRUC_EXCLUSION","DRUC_ENVELOPPE","DRUC_MARGE","DRUC_CROIX","DRUC_INTERSECT",
"DRUC_EXTENSION","DRUC_INCLUSION","DRUC_DISTANCE","DRUC_SURFACE_INTER",
"DRUC_LONG_INTER","DRUC_LARGE_INTER","DRUC_PENET_INTER","DRUC_PARAL_INTER",
"DRUC_PERPEN_INTER","DRUC_FRONTALE","DRUC_LATERALE_MIN","DRUC_LATERALE_MAX",
"DRUC_LARGEUR_MIN","DRUC_LARGEUR_MAX","DRUC_LONGUEUR_MIN","DRUC_LONGUEUR_MAX",
"DRUC_SUP","DRUC_INF","DRUC_AXIALE","DRUC_GEODESIQUE","DRUC_SURFACE",
"DRUC_LONGUEUR","DRUC_LARGEUR","DRUC_MIN","DRUC_MAX","DRUC_INFEQ","DRUC_SUPEQ",
"DRUC_DIFF","DRUC_NOTCH","DRUC_ENTIER","DRUC_FLOAT",
};
char *yyrule[] = {
"$accept : drc",
"$$1 :",
"$$2 :",
"$$3 :",
"drc : $$1 list_layer $$2 DRUC_REGLES list_bloc DRUC_FIN DRUC_REGLES $$3 list_comment",
"list_layer : list_layer layer",
"list_layer : layer",
"$$4 :",
"$$5 :",
"layer : DRUC_LAYER DRUC_NOM $$4 DRUC_FLOAT $$5 ';'",
"list_bloc : list_bloc bloc",
"list_bloc : bloc",
"bloc : define",
"bloc : undefine",
"bloc : caracter",
"bloc : relation",
"$$6 :",
"$$7 :",
"$$8 :",
"define : DRUC_DEFINE DRUC_NOM $$6 '=' compose DRUC_NOM $$7 ',' DRUC_NOM $$8 ';'",
"compose : DRUC_UNION",
"compose : DRUC_INTERSECT",
"compose : DRUC_EXCLUSION",
"compose : DRUC_INCLUSION",
"$$9 :",
"undefine : DRUC_UNDEFINE DRUC_NOM $$9 ';'",
"$$10 :",
"caracter : DRUC_CARACTERISE DRUC_NOM $$10 '(' lst_rgl_1 ')' ';'",
"lst_rgl_1 : lst_rgl_1 regle_1",
"lst_rgl_1 : regle_1",
"$$11 :",
"$$12 :",
"$$13 :",
"regle_1 : DRUC_REGLE $$11 DRUC_ENTIER $$12 ':' mesure compar DRUC_FLOAT $$13 ';'",
"$$14 :",
"$$15 :",
"$$16 :",
"relation : DRUC_RELATION $$14 DRUC_NOM $$15 ',' DRUC_NOM $$16 '(' lst_rgl_2 ')' ';'",
"lst_rgl_2 : lst_rgl_2 regle_2",
"lst_rgl_2 : regle_2",
"$$17 :",
"$$18 :",
"$$19 :",
"regle_2 : DRUC_REGLE $$17 DRUC_ENTIER $$18 ':' config mesure_rel compar DRUC_FLOAT $$19 ';'",
"config : DRUC_DISTANCE",
"config : DRUC_INTERSECT",
"config : DRUC_EXTENSION",
"config : DRUC_INCLUSION",
"config : DRUC_ENVELOPPE",
"config : DRUC_MARGE",
"config : DRUC_CROIX",
"mesure_rel : DRUC_SURFACE_INTER",
"mesure_rel : DRUC_LONG_INTER",
"mesure_rel : DRUC_LARGE_INTER",
"mesure_rel : DRUC_PENET_INTER",
"mesure_rel : DRUC_PARAL_INTER",
"mesure_rel : DRUC_PERPEN_INTER",
"mesure_rel : DRUC_LONGUEUR_MIN",
"mesure_rel : DRUC_LONGUEUR_MAX",
"mesure_rel : DRUC_LARGEUR_MIN",
"mesure_rel : DRUC_LARGEUR_MAX",
"mesure_rel : DRUC_FRONTALE",
"mesure_rel : DRUC_LATERALE_MIN",
"mesure_rel : DRUC_LATERALE_MAX",
"mesure_rel : DRUC_SUP",
"mesure_rel : DRUC_INF",
"mesure_rel : DRUC_AXIALE",
"mesure_rel : DRUC_GEODESIQUE",
"mesure : DRUC_SURFACE",
"mesure : DRUC_LONGUEUR",
"mesure : DRUC_LARGEUR",
"mesure : DRUC_NOTCH",
"mesure : DRUC_SURFACE_INTER",
"mesure : DRUC_LONG_INTER",
"mesure : DRUC_LARGE_INTER",
"compar : DRUC_MIN",
"compar : DRUC_MAX",
"compar : DRUC_INFEQ",
"compar : DRUC_SUPEQ",
"compar : '<'",
"compar : '>'",
"compar : '='",
"compar : DRUC_DIFF",
"list_comment :",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 285 "drucompi.yac"

#line 361 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 90 "drucompi.yac"
{ DrucInitCompiler () ;}
break;
case 2:
#line 91 "drucompi.yac"
{ DrucStoreRdsLayer () ; }
break;
case 3:
#line 95 "drucompi.yac"
{ DrucEndRulesCompiler () ; }
break;
case 4:
#line 96 "drucompi.yac"
{ DrucCloseCompiler () ;}
break;
case 7:
#line 104 "drucompi.yac"
{ DrucInitRdsLayerName ( DrucInputChaine ) ;}
break;
case 8:
#line 105 "drucompi.yac"
{ DrucInitRdsLayerDef ( RprTranslateParam ( DrucInputFloat ) );}
break;
case 12:
#line 114 "drucompi.yac"
{ DrucStoreInstructionDefine () ;}
break;
case 13:
#line 115 "drucompi.yac"
{ DrucStoreInstructionUndefine () ;}
break;
case 14:
#line 116 "drucompi.yac"
{ DrucStoreInstructionRegle () ;}
break;
case 15:
#line 117 "drucompi.yac"
{ DrucStoreInstructionRegle () ;}
break;
case 16:
#line 121 "drucompi.yac"
{ DrucInitDefineLayerDest ( DrucInputChaine ) ;}
break;
case 17:
#line 124 "drucompi.yac"
{ DrucInitDefineLayerA ( DrucInputChaine ) ;}
break;
case 18:
#line 126 "drucompi.yac"
{ DrucInitDefineLayerB ( DrucInputChaine ) ;}
break;
case 20:
#line 130 "drucompi.yac"
{ DrucStructDefineOpCompose( DRUC_COMPOSE_UNION );}
break;
case 21:
#line 131 "drucompi.yac"
{ DrucStructDefineOpCompose( DRUC_COMPOSE_INTERSECT );}
break;
case 22:
#line 132 "drucompi.yac"
{ DrucStructDefineOpCompose( DRUC_COMPOSE_EXCLUSION );}
break;
case 23:
#line 133 "drucompi.yac"
{ DrucStructDefineOpCompose( DRUC_COMPOSE_INCLUSION );}
break;
case 24:
#line 137 "drucompi.yac"
{ DrucInitUndefineUserLayer ( DrucInputChaine ) ;}
break;
case 26:
#line 142 "drucompi.yac"
{ DrucInitRegleLayerA ( DrucInputChaine ) ;
                               DrucInitRegleInstruction ( DRUC_INSTR_CARACTERISE ) ;
                               DrucIndexMesure = -1 ;}
break;
case 30:
#line 156 "drucompi.yac"
{ DrucIndexMesure ++ ;}
break;
case 31:
#line 157 "drucompi.yac"
{ DrucInitRegleNumero ( DrucInputEntier,
                                                     DrucIndexMesure) ;}
break;
case 32:
#line 162 "drucompi.yac"
{ DrucInitRegleValeur ( RprTranslateParam ( DrucInputFloat ),
                                                     DrucIndexMesure );}
break;
case 34:
#line 167 "drucompi.yac"
{ DrucInitRegleInstruction ( DRUC_INSTR_RELATION ) ;}
break;
case 35:
#line 168 "drucompi.yac"
{ DrucInitRegleLayerA ( DrucInputChaine ) ;}
break;
case 36:
#line 170 "drucompi.yac"
{ DrucInitRegleLayerB ( DrucInputChaine ) ;
                               DrucIndexMesure = -1 ; }
break;
case 40:
#line 183 "drucompi.yac"
{ DrucIndexMesure ++ ;}
break;
case 41:
#line 184 "drucompi.yac"
{ DrucInitRegleNumero ( DrucInputEntier,
                                                     DrucIndexMesure ) ;}
break;
case 42:
#line 190 "drucompi.yac"
{ DrucInitRegleValeur ( RprTranslateParam ( DrucInputFloat ),
                                                     DrucIndexMesure );}
break;
case 44:
#line 195 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_DISTANCE,
                                                      DrucIndexMesure );}
break;
case 45:
#line 197 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_INTERSECTION,
                                                      DrucIndexMesure );}
break;
case 46:
#line 199 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_EXTENSION,
                                                      DrucIndexMesure );}
break;
case 47:
#line 201 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_INCLUSION,
                                                      DrucIndexMesure );}
break;
case 48:
#line 203 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_ENVELOPPE,
                                                      DrucIndexMesure );}
break;
case 49:
#line 205 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_MARGE,
                                                      DrucIndexMesure );}
break;
case 50:
#line 207 "drucompi.yac"
{ DrucInitRegleRelation( DRUC_RELATION_CROIX,
                                                      DrucIndexMesure );}
break;
case 51:
#line 211 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_SURFACE_INTER,
                                                    DrucIndexMesure );}
break;
case 52:
#line 213 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_INTER,
                                                    DrucIndexMesure );}
break;
case 53:
#line 215 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LARGEUR_INTER,
                                                    DrucIndexMesure );}
break;
case 54:
#line 217 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_PENETRE_INTER,
                                                    DrucIndexMesure );}
break;
case 55:
#line 219 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_PARALEL_INTER,
                                                    DrucIndexMesure );}
break;
case 56:
#line 221 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_PERPEND_INTER,
                                                    DrucIndexMesure );}
break;
case 57:
#line 223 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_MIN,
                                                    DrucIndexMesure );}
break;
case 58:
#line 225 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_MAX,
                                                    DrucIndexMesure );}
break;
case 59:
#line 227 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LARGEUR_MIN,
                                                    DrucIndexMesure );}
break;
case 60:
#line 229 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LARGEUR_MAX,
                                                    DrucIndexMesure );}
break;
case 61:
#line 231 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_FRONTALE,
                                                    DrucIndexMesure );}
break;
case 62:
#line 233 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LATERALE_MIN,
                                                    DrucIndexMesure );}
break;
case 63:
#line 235 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LATERALE_MAX,
                                                    DrucIndexMesure );}
break;
case 64:
#line 237 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_SUP,
                                                    DrucIndexMesure );}
break;
case 65:
#line 239 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_INF,
                                                    DrucIndexMesure );}
break;
case 66:
#line 241 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_AXIALE,
                                                    DrucIndexMesure );}
break;
case 67:
#line 243 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_GEODESIQUE,
                                                    DrucIndexMesure );}
break;
case 68:
#line 247 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_SURFACE,
                                                    DrucIndexMesure );}
break;
case 69:
#line 249 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LONGUEUR,
                                                    DrucIndexMesure );}
break;
case 70:
#line 251 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LARGEUR,
                                                    DrucIndexMesure );}
break;
case 71:
#line 253 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_NOTCH,
                                                    DrucIndexMesure );}
break;
case 72:
#line 255 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_SURFACE_INTER,
                                                    DrucIndexMesure );}
break;
case 73:
#line 257 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_INTER,
                                                    DrucIndexMesure );}
break;
case 74:
#line 259 "drucompi.yac"
{ DrucInitRegleMesure( DRUC_MESURE_LARGEUR_INTER,
                                                    DrucIndexMesure );}
break;
case 75:
#line 263 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_MIN,
                                                        DrucIndexMesure );}
break;
case 76:
#line 265 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_MAX,
                                                        DrucIndexMesure );}
break;
case 77:
#line 267 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_INFEQ,
                                                        DrucIndexMesure );}
break;
case 78:
#line 269 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_SUPEQ,
                                                        DrucIndexMesure );}
break;
case 79:
#line 271 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_INF,
                                                        DrucIndexMesure );}
break;
case 80:
#line 273 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_SUP,
                                                        DrucIndexMesure );}
break;
case 81:
#line 275 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_EQUAL,
                                                        DrucIndexMesure );}
break;
case 82:
#line 277 "drucompi.yac"
{ DrucInitRegleOpCompare ( DRUC_OPERATION_DIFF,
                                                        DrucIndexMesure );}
break;
case 83:
#line 281 "drucompi.yac"
{ DrucStoreComment (); }
break;
#line 819 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
