

/* ********************* Interface of Module "UtBase" ********************* */


#define           TRUE                 1
#define           FALSE                0
#define           EOL                  ((char*)NULL)
#define    C_SUPP_MaxLenString         16384
#define    C_SUPP_MBKSZNAME            64
#define    F_GfpUT_ModuleAdd           1
#define    F_GfpUT_ModuleGet           2
#define    C_GfpUT_ModuleMaxNB         32
#define    C_GfpUT_ArgLcNB             32
#define    C_GfpUT_ArgLcPosUnknow      33
#define    C_UtBas_ErrorModeExit       0
#define    C_UtBas_ErrorModeKill       1


#ifndef  ANSI_PROTO

extern long  GfpUT_GetModuleId();
extern void  GfpUT_AddError();
extern void  GfpUT_PrintError();
extern void  UtBas_SetErrorMode();
extern void  GfpUT_AddWarng();
extern void  GfpUT_PrintWarng();
extern void  UtBas_Init();

extern void  GfpUT_InitArgLc();
extern char *GfpUT_GetArgLcByPos();
extern long  GfpUT_GetArgLcByName();
extern char *GfpUT_GetArgLcRemain();

extern long  UtBas_PrintFMark();
extern long  UtBas_PrintFClear();
extern char *UtBas_PrintF();
extern char *UtBas_PrintFAdd();
extern char *UtBas_vPrintFAdd();

#else

extern long  GfpUT_GetModuleId(char *aName);
extern void  GfpUT_AddError(long  aModuleId, long  aCode, long  aForm);
extern void  GfpUT_PrintError(va_alist);
extern void  UtBas_SetErrorMode( long aMode );
extern void  GfpUT_AddWarng(long  aModuleId, long  aCode, long  aForm);
extern void  GfpUT_PrintWarng(va_alist);
extern void  UtBas_Init(void);

extern void  GfpUT_InitArgLc(int  aArgC, char *aArgV[]);
extern char *GfpUT_GetArgLcByPos(long  aPos, long *aPtGetNB);
extern long  GfpUT_GetArgLcByName(char *aName, long *aPtGetNB);
extern char *GfpUT_GetArgLcRemain(void);

extern long  UtBas_PrintFMark(void);
extern long  UtBas_PrintFFree(long aMark);
extern char *UtBas_PrintF(va_alist);
extern char *UtBas_PrintFAdd( va_alist );
extern char *UtBas_vPrintFAdd( char *aStr, va_list ArgList );

#endif


