

/* ************* Interface of Module "UtHierarchy" ************** */


#define    C_UtHir_TypeOperatorRouted         2
#define    C_UtHir_TypeOperatorPlaced         3
#define    C_UtHir_TypeOperatorUser           4
#define    C_UtHir_TypeOperatorSubDP          5


#ifdef  MLO
#ifndef  ANSI_PROTO

extern       void  UtHir_Init();
extern       long  UtHir_GetOperatorType();
extern       long  UtHir_GetModelType();
extern       void  UtHir_HierarchCheck();
extern       void  UtHir_HierarchFlattenLo();
extern       void  UtHir_rFlattenCatalPhFig();
extern       void  UtHir_rFlattenCatalLoFig();
extern lofig_list *UtHir_LoadLoFig();

#else

extern       void  UtHir_Init(void);
extern       long  UtHir_GetOperatorType(lofig_list *aLoFig);
extern       long  UtHir_GetModelType(char *aModelName)
extern       void  UtHir_HierarchCheck(lofig_list *ptlofig);
extern       void  UtHir_HierarchFlattenLo(lofig_list *aLoFig);
extern       void  UtHir_rFlattenCatalPhFig(phfig_list *aPhFig);
extern       void  UtHir_rFlattenCatalLoFig(lofig_list *aLoFig);
extern lofig_list *UtHir_LoadLoFig(char *aModelName);

#endif
#endif
