

/* *************** Interface of Module "UtUser" ***************** */


#define    F_GfpUT_UserCreat           1
#define    F_GfpUT_UserGet             0
#define    F_GfpUT_UserNoFlags         0

#define    C_GfpUT_UserSigType         1
#define    C_GfpUT_UserLoConPlace      2
#define    C_GfpUT_UserLoFigAB         3
#define    C_GfpUT_UserLoFigPower      4
#define    C_GfpUT_UserLoFigGlue       5
#define    C_GfpUT_UserLoFigFlags      6
#define    C_GfpUT_UserLoInsPower      7
#define    C_GfpUT_UserPhFigXYFlat     8
#define    C_GfpUT_UserPhFigPowBar     9
#define    C_GfpUT_UserTypeOperator   10
#define    C_GfpUT_UserMaxTdupl       10


#ifndef  ANSI_PROTO

extern       void  UtUsr_Init();

#ifdef  MUTL
extern ptype_list *GfpUT_GetUser();
extern ptype_list *GfpUT_DelUser();
extern       long  GfpUT_SetDupUser();
extern       void  GfpUT_DupUser();
#endif

#else

extern       void  UtUsr_Init(void);

#ifdef  MUTL
extern ptype_list *GfpUT_GetUser(ptype_list **aPPtHead,
									   long   aType   ,
									   long   aFlags  );
extern ptype_list *GfpUT_DelUser(ptype_list **aPPtHead,
									   long   aType   ,
									   long   aFlags  );
extern       long  GfpUT_SetDupUser(long    aType   ,
									void *(*aFunc)());
extern       void  GfpUT_DupUser(ptype_list **aPPtUserSrc ,
								 ptype_list **aPPtUserDest);
#endif

#endif
