
/*****************************************************/
/*****  Fonction permettant de creer une Befig.  *****/
/*** Ce fichier est genere par le ~luc/luc/GEN/gen ***/
/**** qui prend en entree un .vbe et qui le parse ****/
/****            batch macrogenere                ****/
/***       fichier compile : cm8a.vbe    ***/
/**********************************************/

#include <stdio.h>
#include MUT_H
#include LOG_H
#include BEH_H

befig_list *cm8a()
{
befig_list *befigAux;
chain_list *abl;
begen_list *genAux = NULL;
int *pentier;
befigAux = beh_addbefig(NULL,namealloc("cm8a"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("b1"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("b0"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("a1"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("a0"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("sb"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("sa"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("s1"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("s0"));
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("y"),'O','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("b1"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("b0"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("a1"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("a0"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("sb"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("sa"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("s1"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("s0"),'I','B');
befigAux->BEPOR = (bepor_list *)reverse((chain_list *)befigAux->BEPOR);
abl = charToExpr("(or (and (not (or s0 s1)) (or (and (not sa) a0) (and sa a1))) (and (or s0 s1) (or (and (not sb) b0) (and sb b1))))");
befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("y"),abl,NULL);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_b1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_b1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_b1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_b1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_b1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_b0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_b0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_b0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_b0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_b0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_a1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_a1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_a1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_a1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_a1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_a0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_a0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_a0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_a0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_a0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_sb","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_sb","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_sb","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_sb","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_sb","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_sa","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_sa","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_sa","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_sa","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_sa","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_s1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_s1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_s1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_s1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_s1","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_s0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_s0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_s0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_s0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_s0","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1;
genAux = beh_addbegen(genAux,"area","natural",(void *)pentier);
befigAux->BEGEN = genAux;
befigAux->CIRCUI = NULL;
befigAux->NEXT = NULL;

return befigAux;
}


/*****************************************************/
/*****  Fonction permettant de creer une Befig.  *****/
/*** Ce fichier est genere par le ~luc/luc/GEN/gen ***/
/**** qui prend en entree un .vbe et qui le parse ****/
/****            batch macrogenere                ****/
/***       fichier compile : inv.vbe    ***/
/**********************************************/


befig_list *inv()
{
befig_list *befigAux;
chain_list *abl;
begen_list *genAux = NULL;
int *pentier;
befigAux = beh_addbefig(NULL,namealloc("inv"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("a"));
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("y"),'O','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("a"),'I','B');
befigAux->BEPOR = (bepor_list *)reverse((chain_list *)befigAux->BEPOR);
abl = charToExpr("(not a)");
befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("y"),abl,NULL);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_a","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tplh_a","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_a","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1000;
genAux = beh_addbegen(genAux,"tphl_a","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_a","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1;
genAux = beh_addbegen(genAux,"area","natural",(void *)pentier);
befigAux->BEGEN = genAux;
befigAux->CIRCUI = NULL;
befigAux->NEXT = NULL;

return befigAux;
}


/*****************************************************/
/*****  Fonction permettant de creer une Befig.  *****/
/*** Ce fichier est genere par le ~luc/luc/GEN/gen ***/
/**** qui prend en entree un .vbe et qui le parse ****/
/****            batch macrogenere                ****/
/***       fichier compile : dl1.vbe    ***/
/**********************************************/


befig_list *dl1()
{
befig_list *befigAux;
chain_list *abl;
begen_list *genAux = NULL;
int *pentier;
biabl_list *biabl = NULL;
chain_list *cndabl = NULL;
chain_list *valabl = NULL;
befigAux = beh_addbefig(NULL,namealloc("dl1"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("mpx_s"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("g"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("d"));
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("q"),'O','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("g"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("d"),'I','B');
befigAux->BEPOR = (bepor_list *)reverse((chain_list *)befigAux->BEPOR);
abl = charToExpr("mpx_s");
befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("q"),abl,NULL);
valabl = charToExpr("d");
cndabl = charToExpr("g");
biabl = beh_addbiabl(biabl,"label0", cndabl, valabl);
biabl->USER = NULL;
befigAux->BEREG = beh_addbereg(befigAux->BEREG,namealloc("mpx_s"),biabl,NULL);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_g","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_d","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_g","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_g","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown_d","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup_d","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 1;
genAux = beh_addbegen(genAux,"area","natural",(void *)pentier);
befigAux->BEGEN = genAux;
befigAux->CIRCUI = NULL;
befigAux->NEXT = NULL;

return befigAux;
}

/*****************************************************/
/*****  Fonction permettant de creer une Befig.  *****/
/*** Ce fichier est genere par le ~luc/luc/GEN/gen ***/
/**** qui prend en entree un .vbe et qui le parse ****/
/****            batch macrogenere                ****/
/***       fichier compile : df1.vbe    ***/
/**********************************************/


befig_list *df1()
{
befig_list *befigAux;
chain_list *abl;
begen_list *genAux = NULL;
int *pentier;
biabl_list *biabl = NULL;
chain_list *cndabl = NULL;
chain_list *valabl = NULL;
befigAux = beh_addbefig(NULL,namealloc("df1"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("mpx_s"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("ck"));
befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("d"));
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("q"),'O','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("ck"),'I','B');
befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("d"),'I','B');
befigAux->BEPOR = (bepor_list *)reverse((chain_list *)befigAux->BEPOR);
abl = charToExpr("mpx_s");
befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("q"),abl,NULL);
valabl = charToExpr("d");
cndabl = charToExpr("ck");
biabl = beh_addbiabl(biabl,"label0", cndabl, valabl);
biabl->USER = NULL;
biabl->USER = addptype(biabl->USER,0,0);
befigAux->BEREG = beh_addbereg(befigAux->BEREG,namealloc("mpx_s"),biabl,NULL);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_ck","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 50;
genAux = beh_addbegen(genAux,"cin_d","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rdown","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 3000;
genAux = beh_addbegen(genAux,"rup","natural",(void *)pentier);
pentier = (int *) mbkalloc(sizeof(int));
*pentier = 2;
genAux = beh_addbegen(genAux,"area","natural",(void *)pentier);
befigAux->BEGEN = genAux;
befigAux->CIRCUI = NULL;
befigAux->NEXT = NULL;

return befigAux;
}
