
/*  A Bison parser, made from d_dbx.yac with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	SYMBOL	258
#define	INTEGER	259
#define	FLAG	260

#line 1 "d_dbx.yac"

/* dbx syntax parser : Frederic Petrot, december 91 */
/* version 1.0 written in C and failed because of my lack of knowledge */
/* in writting recursive grammar parsers */
/* lexical analyser in C, very context dependant */
/* rules analyse, yacc */
/* syntax extracted from a sample of outputs of C headers and files */
/* thru the use of gcc -S -g */
#include <stdio.h>
#include <string.h>
#include MUT_H
#include "d_dbx.h"

#define TERMINAL    0
#define STRUCTURE   1 /* also good for union, only fields address change */
#define TYPEDEF     4
#define POINTER     8
#define ARRAY       16
#define FUNCTION    32
#define ENUMERATION 64
#define XREF        128

static char *dbx_line; /* dbx line to be analyzed, not splitted by '\\' */

PTVARIABLE firstVariable = NULL; /* list of variables */
PTSTRUCT firstStruct = NULL; /* list of structures */
static PTSTRUCT gst; /* current global structure to work on */
static PTSTRUCT ost; /* previous global structure to work on */
static PTSTRUCT fst; /* previous global structure to work on */
static PTVARIABLE gv; /* current global variable to work on */
static PTELEMENT elm, e; /* current element */

static char *name; /* current structure/variable name */
static int varAddress;
static int varClass;
static PTELEMENT create_element();
static PTSTRUCT create_struct();
static void delete_struct();
static PTVARIABLE create_variable();
static void fill_dbx_info();
static int yylex();

#line 44 "d_dbx.yac"
typedef union {
	int integer;
	char string[255]; /* why 255? Good question! */
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		52
#define	YYFLAG		-32768
#define	YYNTBASE	17

#define YYTRANSLATE(x) ((unsigned)(x) <= 260 ? yytranslate[x] : 26)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     8,     2,    16,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     6,    11,     2,
     7,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    15,     2,     2,     2,
    10,     9,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,    13,     2,    14,     2,     2,    12,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     5,    11,    12,    14,    16,    21,    26,
    32,    38,    44,    50,    60,    62,    65,    74,    84,    86,
    89
};

static const short yyrhs[] = {    18,
     0,     3,     0,     0,     3,    19,     6,    20,    21,     0,
     0,     5,     0,     4,     0,     4,     7,     8,    21,     0,
     4,     7,     9,    21,     0,     4,     7,    10,    24,    11,
     0,     4,     7,    12,     3,     6,     0,     4,     7,    13,
     4,    22,     0,     4,     7,    14,     4,    22,     0,     4,
     7,    15,    11,     4,    11,     4,    11,    21,     0,    23,
     0,    23,    22,     0,     3,     6,    21,    16,     4,    16,
     4,    11,     0,     3,     6,    21,    16,     4,    16,     4,
    11,    11,     0,    25,     0,    25,    24,     0,     3,     6,
     4,    16,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    56,    57,    60,    60,    77,    78,    82,    88,   102,   116,
   121,   126,   143,   160,   176,   177,   180,   192,   206,   207,
   210
};

static const char * const yytname[] = {   "$","error","$illegal.","SYMBOL","INTEGER",
"FLAG","':'","'='","'*'","'f'","'e'","';'","'x'","'s'","'u'","'a'","','","dbx",
"line","@1","class","type","fields","field","lists","list",""
};
#endif

static const short yyr1[] = {     0,
    17,    17,    19,    18,    20,    20,    21,    21,    21,    21,
    21,    21,    21,    21,    22,    22,    23,    23,    24,    24,
    25
};

static const short yyr2[] = {     0,
     1,     1,     0,     5,     0,     1,     1,     4,     4,     5,
     5,     5,     5,     9,     1,     2,     8,     9,     1,     2,
     4
};

static const short yydefact[] = {     0,
     2,     1,     0,     5,     6,     0,     7,     4,     0,     0,
     0,     0,     0,     0,     0,     0,     8,     9,     0,     0,
    19,     0,     0,     0,     0,     0,    10,    20,    11,     0,
    12,    15,    13,     0,     0,     0,    16,     0,    21,     0,
     0,     0,     0,     0,    14,     0,     0,    17,    18,     0,
     0,     0
};

static const short yydefgoto[] = {    50,
     2,     3,     6,     8,    31,    32,    20,    21
};

static const short yypact[] = {     0,
    -2,-32768,     9,     1,-32768,    12,    10,-32768,    -1,    12,
    12,     2,    15,    16,    17,     8,-32768,-32768,    18,    11,
     2,    19,    20,    20,    23,    24,-32768,-32768,-32768,    25,
-32768,    20,-32768,    21,    13,    12,-32768,    26,-32768,    22,
    28,    30,    12,    27,-32768,    31,    29,    33,-32768,    36,
    37,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,   -10,   -22,-32768,    32,-32768
};


#define	YYLAST		53


static const short yytable[] = {    17,
    18,    33,     1,    -3,    19,     5,    10,    11,    12,    37,
    13,    14,    15,    16,     4,     7,     9,    22,    25,    23,
    24,    27,    30,    26,    29,    40,    34,    35,    39,    41,
    36,    38,    45,    44,    47,    51,    52,    42,    43,    48,
     0,     0,    46,    49,     0,     0,     0,     0,     0,     0,
     0,     0,    28
};

static const short yycheck[] = {    10,
    11,    24,     3,     6,     3,     5,     8,     9,    10,    32,
    12,    13,    14,    15,     6,     4,     7,     3,    11,     4,
     4,    11,     3,     6,     6,    36,     4,     4,    16,     4,
     6,    11,    43,     4,     4,     0,     0,    16,    11,    11,
    -1,    -1,    16,    11,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    21
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 60 "d_dbx.yac"
{ name = yyvsp[0].string;;
    break;}
case 4:
#line 61 "d_dbx.yac"
{
					switch (yyvsp[-1].integer) {
						case 'T': /* that's only a structure definition */
						case 't': /* or some informations for casts, not variables */
							break;
						case 'G':
							if (gst && gst->object == STRUCTURE)
								break;
						default : /* we now have a variable to create */
							gv = create_variable(mbkstrdup(name), yyvsp[-1].integer, yyvsp[0].integer, getsize(yyvsp[0].integer));
							/* address is given as argument */
							/* class is also given as argument for address offset */
					}
				;
    break;}
case 5:
#line 77 "d_dbx.yac"
{ yyval.integer = 0; /* automatic variable */;
    break;}
case 6:
#line 79 "d_dbx.yac"
{ yyval.integer = yyvsp[0].integer; /* type given in the string */;
    break;}
case 7:
#line 83 "d_dbx.yac"
{
					/* this is a terminal element of a rule
					   either typeNumber or typeFrom */
					yyval.integer = yyvsp[0].integer; /* just give it back */
				;
    break;}
case 8:
#line 89 "d_dbx.yac"
{
					ost = gst; /* stack for imbricated declarations : push */
					gst = create_struct("*", yyvsp[-3].integer, yyvsp[0].integer, POINTER, 32);
					if (fst == NULL)
						fst = gst;
					if (ost)
						gst = ost; /* stack for imbricated declarations : pop */
					else {
						gst = fst;
						fst = NULL;
					}
					yyval.integer = yyvsp[-3].integer;
				;
    break;}
case 9:
#line 103 "d_dbx.yac"
{
					ost = gst; /* stack for imbricated declarations : push */
					gst = create_struct("function", yyvsp[-3].integer, yyvsp[0].integer, FUNCTION, 32);
					if (fst == NULL)
						fst = gst;
					if (ost)
						ost = gst; /* stack for imbricated declarations : push */
					else {
						gst = fst;
						fst = NULL;
					}
					yyval.integer = yyvsp[-3].integer;
				;
    break;}
case 10:
#line 117 "d_dbx.yac"
{
					/* enum are better than #define since symbolic values may
					   be used for debug. Later on, perhaps */
				;
    break;}
case 11:
#line 122 "d_dbx.yac"
{
					/* xref are not neccessay but no easy to get rid of */
					/* keep same type value for all fields */
				;
    break;}
case 12:
#line 127 "d_dbx.yac"
{
					ost = gst; /* stack for imbricated declarations : push */
					delete_struct(yyvsp[-4].integer); /* if it has existed, it's thru xref */
					gst = create_struct(mbkstrdup(name), yyvsp[-4].integer, TERMINAL, STRUCTURE, yyvsp[-1].integer);
					gst->member = elm;
					elm = NULL;
					if (fst == NULL)
						fst = gst;
					if (ost)
						gst = ost; /* stack for imbricated declarations : pop */
					else {
						gst = fst;
						fst = NULL;
					}
					yyval.integer = yyvsp[-4].integer;
				;
    break;}
case 13:
#line 144 "d_dbx.yac"
{
					ost = gst; /* stack for imbricated declarations : push */
					delete_struct(yyvsp[-4].integer); /* if it has existed, it's thru xref */
					gst = create_struct(mbkstrdup(name), yyvsp[-4].integer, TERMINAL, STRUCTURE, yyvsp[-1].integer);
					gst->member = elm;
					elm = NULL;
					if (fst == NULL)
						fst = gst;
					if (ost)
						gst = ost; /* stack for imbricated declarations : pop */
					else {
						gst = fst;
						fst = NULL;
					}
					yyval.integer = yyvsp[-4].integer;
				;
    break;}
case 14:
#line 161 "d_dbx.yac"
{
					ost = gst; /* stack for imbricated declarations : push */
					gst = create_struct("array", yyvsp[-8].integer, yyvsp[0].integer, ARRAY, (yyvsp[-2].integer + 1) * 8);
					if (fst == NULL)
						fst = gst;
					if (ost)
						gst = ost; /* stack for imbricated declarations : pop */
					else {
						gst = fst;
						fst = NULL;
					}
					yyval.integer = yyvsp[-8].integer;
				;
    break;}
case 17:
#line 181 "d_dbx.yac"
{
				PTELEMENT pel;

					pel = create_element(mbkstrdup(yyvsp[-7].string), yyvsp[-5].integer, yyvsp[-3].integer, yyvsp[-1].integer);
					if (!elm)
						elm = pel;
					else {
						for (e = elm; e->next; e = e->next); /* find last */
						e->next = pel;
					}
				;
    break;}
case 18:
#line 193 "d_dbx.yac"
{
				PTELEMENT pel;

					pel = create_element(mbkstrdup(yyvsp[-8].string), yyvsp[-6].integer, yyvsp[-4].integer, yyvsp[-2].integer);
					if (!elm)
						elm = pel;
					else {
						for (e = elm; e->next; e = e->next); /* find last */
						e->next = pel;
					}
				;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 213 "d_dbx.yac"


/* memory allocating routines */
static PTELEMENT create_element(name, number, address, size)
char *name;
int number, address, size;
{
PTELEMENT member;
	
	member = (PTELEMENT)mbkalloc(sizeof(ELEMENT));
	member->name = name;
	member->typeNumber = number;
	member->address = address;
	member->size = size;
	member->next = NULL;

	return member;
}

static PTSTRUCT create_struct(name, number, from, type, size)
char *name;
int number, from, type, size;
{
static PTSTRUCT lastStruct;
PTSTRUCT s;

	for (s = firstStruct; s; s = s->next)
		if (s->typeNumber == number)
			fprintf(stderr, "Type already there (%d)!\n", number);

   s = (PTSTRUCT)mbkalloc(sizeof(STRUCT));
	s->name = name;
	s->typeNumber = number;
	s->typeFrom = from;
	s->object = type;
	s->size = size;
	s->member = NULL;
   s->next = NULL;
	/* order may be interesting for array and pointer printout */
   if (!firstStruct) /* first add */
      lastStruct = firstStruct = s;
   else { /* insert in end of list */
      lastStruct->next = s;
      lastStruct = s;
   }
   return s;
}

static void delete_struct(number)
int number;
{
PTSTRUCT s, ps;

	for (s = firstStruct; s; ps = s, s = s->next)
		if (s->typeNumber == number)
			break;

	if (!s)
		return;	
	else if (s == firstStruct)
		firstStruct = s->next;
	else
		ps->next = s->next;
	mbkfree((void *)s->name);
	mbkfree((void *)s);
}

static PTVARIABLE create_variable(name, scope, number, size)
char *name;
int scope, number, size;
{
static PTVARIABLE lastVariable; /* add at then end, order needed */
PTVARIABLE v;
 
   v =(PTVARIABLE)mbkalloc(sizeof(VARIABLE));
	v->name = name;
	v->typeNumber = number;
	v->size = size;
	v->address = varAddress;
	v->class = varClass; /* both needed because of static arrays */
	v->scope = scope;    /* and variables that must be distinguished */
	v->next = NULL;
	/* must have the same order than declaration, for 'main' parameters */
   if (!firstVariable) /* first add */
      lastVariable = firstVariable = v;
   else { /* insert in end of list */
      lastVariable->next = v;
      lastVariable = v;
   }
   return v;
}

/* check if a type is a C terminal one, simplify the grammar because of void */
int isknowntype(s)
char *s;
{
int i = 0;
	while (*s && *s != ':')
		yylval.string[i++] = *s++;
	yylval.string[i] = '\0';

	if (!strcmp(yylval.string, "int")
			|| !strcmp(yylval.string, "char")
			|| !strcmp(yylval.string, "longint")
			|| !strcmp(yylval.string, "unsignedint")
			|| !strcmp(yylval.string, "longunsignedint")
			|| !strcmp(yylval.string, "shortint")
			|| !strcmp(yylval.string, "longlongint")
			|| !strcmp(yylval.string, "shortunsignedint")
			|| !strcmp(yylval.string, "longlongunsignedint")
			|| !strcmp(yylval.string, "signedchar")
			|| !strcmp(yylval.string, "unsignedchar")
			|| !strcmp(yylval.string, "float")
			|| !strcmp(yylval.string, "double")
			|| !strcmp(yylval.string, "longdouble")
			|| !strcmp(yylval.string, "void"))
		return 1;
	return 0;
}

int getsize(type)
int type;
{
PTSTRUCT s;

	if (type < 13) /* gcc predefined types, all coded on 32 bits */
		return 32; /* even if only part of the 32 bits are used */
	else if (type == 13 || type == 14)
		return 64; /* 'double' size for the machine */
	else if (type == 15) /* that's 'void' */
		return 0;

	for (s = firstStruct; s; s = s->next)
		if (s->typeNumber == type)
			return s->size;

	fprintf(stderr, "Error : variable with undefined type (%d)!\n", type);
	EXIT(1);
}

static void fill_dbx_info(str)
char *str;
{
char *t = str, *s = str, *u;
static int length;
static char *buffer; /* contains what is to be parsed */
 
	/* kill spaces in the line, needed because of default: in yylex */
	while (*t)
		if (!isspace(*t))
			*s++ = *t++;
		else
			t++;
	*s = '\0';

	if (*(s - 2)  == '\\') {
		*(s - 2) = '\0';
		if (!length) {
			length = t - str + 1;
			buffer = (char *)mbkalloc(length);
			strcpy(buffer, str);
		} else {
			length += t - str + 1;
			buffer = mbkrealloc(buffer, length);
			strcat(buffer, str);
		}
		mbkfree((void *)str);
		return; /* get more information for structure filling */
	} else if (length && *(s - 1) == ';' && *(s - 2) == ';') {
		length += t - str + 1;
		buffer = mbkrealloc(buffer, length);
		strcat(buffer, str);
		mbkfree((void *)str);
		length = 0;
		dbx_line = buffer; /* since it's end of structure, globalize it! */
	} else if (isknowntype(str)) { /* skip terminal types */
		mbkfree((void *)str);
		return;
	} else 
		dbx_line = str; /* globalize it! */
	u = dbx_line;
	yyparse();
	mbkfree((void *)u);
}

/* lexical analyser */
static int yylex()
{
static char c;
int i = 0;
char *s = dbx_line; /* remember where to start from */

	switch (*s) {
		case '\0':

#ifdef OUT
			printf("\n\n");
#endif

			return -1; /* expected by yacc as end of entries */

		case ';':
		case ',': /* easy, because such symbols are not legal in C identifiers */
		case ':':
		case '=':
		case '*':

#ifdef OUT
			printf("(%c)", *s);
			if (*s == ';' && c == ';')
				printf("\n\n");
#endif

			return c = *dbx_line++;

		case 'T':
		case 't':
		case 'S':
		case 'V':
		case 'G':
		case 'p':
		case 'F':
			if (c == ':') { /* context dependant return value : storage class */

#ifdef OUT
				printf("FLAG(%c)", *s);
#endif
				yylval.integer = c = *dbx_line++;
				return FLAG;
			}

			c = *s; /* just to warrant correctness of state */
			while (*s && *s != ':')
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			dbx_line = s;

#ifdef OUT
			printf("SYMBOL{%s}", yylval.string);
#endif

			return SYMBOL;

		case 's':
		case 'u':
		case 'e':
			if (c == '=') { /* context dependant return value : storage class */

#ifdef OUT
				printf("(%c)", *s);
#endif
				return c = *dbx_line++;
			}

			c = *s; /* just to warrant correctness of state */
			while (*s && *s != ':')
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			dbx_line = s; /* points on ':' now */

#ifdef OUT
			printf("SYMBOL{%s}", yylval.string);
#endif

			return SYMBOL;

		case 'f':
			if (c == ':') { /* context dependant return value : storage class */

#ifdef OUT
				printf("FLAG(%c)", *s);
#endif
				yylval.integer = c = *dbx_line++;
				return FLAG;
			}
			if (c == '=') { /* context dependant return value : storage class */

#ifdef OUT
				printf("(%c)", *s);
#endif
				return c = *dbx_line++;
			}

			c = *s; /* just to warrant correctness of state */
			while (*s && *s != ':')
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			dbx_line = s; /* points on ':' now */

#ifdef OUT
			printf("SYMBOL{%s}", yylval.string);
#endif

			return SYMBOL;

		case 'a':
		case 'x':
		case 'r':
			if (c == '=') { /* context dependant return value : storage class */
				c = *s;
				if (c == 'a')
					dbx_line += 3; /* skip 'ar1' : always here */
				else
					dbx_line += 2; /* skip 'u', 's' or 1, unnecessary information */

#ifdef OUT
				printf("(%c)", c);
#endif
				return c;
			}

			c = *s; /* just to warrant correctness of state */
			while (*s && *s != ':')
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			dbx_line = s; /* points on ':' now */

#ifdef OUT
			printf("SYMBOL{%s}", yylval.string);
#endif

			return SYMBOL;

		case '-': /* what a shit of a syntax, this dbx */
			s++; /* skip it an go to numbers */
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			c = *s; /* just to warrant correctness of state */
			while (isdigit(*s++)); /* skip digits */
			yylval.integer = atoi(dbx_line); /* counts only digits */
			dbx_line = --s; /* points at end of numbers */

#ifdef OUT
			printf("INTEGER[%d]", yylval.integer);
#endif

			return INTEGER;

		default:
			c = *s; /* just to warrant correctness of state */
			while (*s && *s != ':')
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			dbx_line = s; /* points on ':' now */

#ifdef OUT
			printf("SYMBOL{%s}", yylval.string);
#endif

			return SYMBOL;
	}
}

yyerror(s)
{
	fflush(stdout);
	fprintf(stderr, "syntax error on line %s, char '%c'\n",
				dbx_line, yychar);
	EXIT(1);
}

/*******************************************************************************
* free space concerned with dbx informations                                   *
*******************************************************************************/
free_dbx_info()
{
PTVARIABLE var, v;
PTSTRUCT str, s;
PTELEMENT elm, e;

	for (var = firstVariable; var; var = v) {
		v = var->next;
		mbkfree((void *)var->name);
		mbkfree((void *)var);
	}

	for (str = firstStruct; str; str = s) {
		s = str->next;
		elm = str->member;
		while (elm) {
			e = elm->next;
			mbkfree((void *)elm->name);
			mbkfree((void *)elm);
			elm = e;
		}
		mbkfree((void *)str->name);
		mbkfree((void *)str);
	}

	/* need to be null before any dbx stuff */
	firstVariable = NULL;
	firstStruct = NULL;
}

AnalysDebug(str, class, address)
char *str;
int class, address;
{
	varClass = class;
	varAddress = address;
	fill_dbx_info(str);
}
