/*------------------------------------------------------------\
|                                                             |
| Tool    :                   GRAAL                           |
|                                                             |
| File    :                   Panel.c                         |
|                                                             |
| Authors :      Venot Frederic and Jacomme Ludovic           |
|                                                             |
| Date    :                  01.08.93                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>
# include <Xm/Xm.h>
# include <Xm/FileSB.h>
# include <Xm/SelectioB.h>
# include <Xm/PushBG.h>

# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include RFM_H
# include GTB_H
# include GSB_H
# include GRM_H
# include GMS_H

# include "GMS_panel.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Panel                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    Panel Informations                       |
|                                                             |
\------------------------------------------------------------*/

   static char *GraalPanelInformationsButtonName[] =

   {
     "Text",
     "Close"
   };

 GraalPanelButtonItem GraalSetupInformationsButton[] =

         {
           {
             &GraalPanelInformationsButtonName[0],
             "Nothing", NULL, 0, 0,
             NULL,
             NULL,
              0, 0,
              8, 9,
             NULL,
             (XtPointer)NULL,
             (Widget)NULL
           }
           ,
           {
             &GraalPanelInformationsButtonName[1],
             NULL, NULL, 0, 0,
             NULL,
             NULL,
             3, 9,
             2, 1,
             GraalExitDialogCallback,
             (XtPointer)NULL,
             (Widget)NULL
           }
           ,
           NULL
         };

   GraalPanelItem GraalSetupInformationsPanel =

         {
           "Informations",
           1,
           0,
           GRAAL_SETUP_INFORMATIONS_X,
           GRAAL_SETUP_INFORMATIONS_Y,
           360,
           250,
           8,
           10,
           (Widget)NULL,
           (Widget)NULL,
           (Widget)NULL,
           (Widget)NULL,
           GraalSetupInformationsButton
         };

   int GraalSetupInformationsDefaultValues[ 5 ] =

         {
           GRAAL_SETUP_INFORMATIONS_X,
           GRAAL_SETUP_INFORMATIONS_Y,
           360, 250, 0
         };

/*------------------------------------------------------------\
|                                                             |
|                Callback For Informations                    |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                   GraalDisplayInformations                  |
|                                                             |
\------------------------------------------------------------*/

void GraalDisplayInformations()

{
  char *Message;

  rdsbegin();

  Message = GraalGetInformations();

  XmTextSetString( GraalSetupInformationsButton[0].BUTTON, Message );

  GraalEnterPanel( &GraalSetupInformationsPanel );

  GraalLimitedLoop( GraalSetupInformationsPanel.PANEL );

  GraalExitPanel( &GraalSetupInformationsPanel );

  rdsend();
}
