/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :  NetOptim                                                   */
/*    Fichier :  incdelai.h                                                 */
/*                                                                          */
/*    (c) copyright 1993 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : N. Dictus                             le : 03/11/1994     */
/*                                                                          */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

int NO_CAPA;
long delaiCriticUp, delaiCriticDw;
long delaiCriticMinUp, delaiCriticMinDw;
loins_list *porteCriticUp, *porteCriticDw;
loins_list *porteCriticMinUp, *porteCriticMinDw;

long profondeurCircuit ;
loins_list *instProf ;

ptype_list *listeCritic;

		/* Tables de hasch */
pTH pathTH;	/* key   : nom d'instance, value = 1 si extremite de chemin */
pTH capaTH;	/* key   : nom de signal, value : somme capas sur le signal */
pTH delaiTH;	/* key   : index de signal_nom de connecteur_transition */
pTH delaiminTH;	/* value : TP+RC en fct du connecteur et de la transition  */
pTH loconOutTH; /* key   : nom d'instance,
		   value : pointeur sur connecteur de sortie */
pTH genConTH;   /* key   : nom de signal,
                   value : pointeur sur le connecteur qui drive le signal */
pTH genUpTH;    /* key   : nom de signal,
                   value : pointeur sur l'instance qui drive le signal */
pTH genDwTH;    /* key   : nom de signal,
                   value : pointeur sur l'instance qui drive le signal */

#define RETARDUP	23
#define RETARDDW	24
#define LOINSUP		25
#define LOINSDW		26
#define LOCONUP		27
#define LOCONDW		28
#define REQUIUP		32
#define REQUIDW		33
#define SLACKUP		34
#define SLACKDW		35
#define CRITIC		36
#define PROF	        30
#define RETARDMINUP	37
#define RETARDMINDW	38 
#define LOINSMINUP	39
#define LOINSMINDW	40
#define LOCONMINUP	41
#define LOCONMINDW	42

void RAZsig();
void RAZlofig();
void majDelaiCon();
void majDelaiInst();
long getDel();
void prepareLofig();
void calcul_retard();
void retard();
void calcul_requi();
void requi();
