
/*  A Bison parser, made from bvl_bcomp.yac  */

#define SYF_Y_BISON 1  /* Identify Bison output.  */

#define	_AND	258
#define	Pragma	259
#define	_BEGIN	260
#define	_END	261
#define	_EQSym	262
#define	_EXIT	263
#define	_FILE	264
#define	_GESym	265
#define	_GTSym	266
#define	_IN	267
#define	_INOUT	268
#define	_LABEL	269
#define	_LESym	270
#define	_LINKAGE	271
#define	_LTSym	272
#define	_NAND	273
#define	_NESym	274
#define	_NEXT	275
#define	_NOR	276
#define	_NOT	277
#define	_NULL	278
#define	_OR	279
#define	_OUT	280
#define	_XOR	281
#define	ABS	282
#define	ACCESS	283
#define	AFTER	284
#define	ALIAS	285
#define	ALL	286
#define	ARCHITECTURE	287
#define	ARRAY	288
#define	ASSERT	289
#define	ATTRIBUTE	290
#define	AbstractLit	291
#define	Ampersand	292
#define	Apostrophe	293
#define	Arrow	294
#define	BLOCK	295
#define	BODY	296
#define	BUFFER	297
#define	BUS	298
#define	Bar	299
#define	BasedInt	300
#define	BasedReal	301
#define	BitStringLit	302
#define	Box	303
#define	CASE	304
#define	COMPONENT	305
#define	CONFIGURATION	306
#define	CONSTANT	307
#define	CharacterLit	308
#define	Colon	309
#define	Comma	310
#define	DISCONNECT	311
#define	DOWNTO	312
#define	DecimalInt	313
#define	DecimalReal	314
#define	Dot	315
#define	DoubleStar	316
#define	ELSE	317
#define	ELSIF	318
#define	ENTITY	319
#define	ERROR	320
#define	FOR	321
#define	FUNCTION	322
#define	GENERATE	323
#define	GENERIC	324
#define	GUARDED	325
#define	IF	326
#define	IS	327
#define	Identifier	328
#define	LIBRARY	329
#define	LOOP	330
#define	LeftParen	331
#define	MAP	332
#define	MOD	333
#define	Minus	334
#define	NEW	335
#define	OF	336
#define	ON	337
#define	OPEN	338
#define	OTHERS	339
#define	PACKAGE	340
#define	PORT	341
#define	PROCEDURE	342
#define	PROCESS	343
#define	Plus	344
#define	RANGE	345
#define	RECORD	346
#define	REGISTER	347
#define	REM	348
#define	REPORT	349
#define	RETURN	350
#define	RightParen	351
#define	SELECT	352
#define	SEVERITY	353
#define	SIGNAL	354
#define	_STABLE	355
#define	SUBTYPE	356
#define	Semicolon	357
#define	Slash	358
#define	Star	359
#define	StringLit	360
#define	THEN	361
#define	TO	362
#define	TRANSPORT	363
#define	BEHTYPE	364
#define	UNITS	365
#define	UNTIL	366
#define	USE	367
#define	VARIABLE	368
#define	VarAsgn	369
#define	WAIT	370
#define	WARNING	371
#define	WHEN	372
#define	WHILE	373
#define	WITH	374

#line 11 "bvl_bcomp.yac"

#include <stdio.h>
#include MUT_H
#include LOG_H
#include "syf_beh.h"

#include "bvl_utype.h"
#include "bvl_byacc.h"
#include "bvl_bedef.h"

static struct dct_entry *addent ();
static struct dct_recrd *addrcd ();
static struct dct_entry **initab ();
static void addtab ();
static int chktab ();
static void fretab ();
void *syf_addstr ();
int syf_chkdcl ();
struct ptype *reversetype();
struct choice_chain *order_choice();

#line 33 "bvl_bcomp.yac"
typedef union  {
	int		 valu;
	char		*text;
	struct ptype	*ptyp;
	struct syf_bepcs	proc;
        struct g_type dble;
        syf_name  	name;   
	syf_ablstr	list;
	struct syf_betyp 	type;
	} SYF_Y_STYPE;

#ifndef SYF_Y_LTYPE
typedef
  struct syf_y_ltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  syf_y_ltype;

#define SYF_Y_LTYPE syf_y_ltype
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	SYF_Y_FINAL		337
#define	SYF_Y_FLAG		-32768
#define	SYF_Y_NTBASE	120

#define SYF_Y_TRANSLATE(x) ((unsigned)(x) <= 374 ? syf_y_translate[x] : 247)

static const char syf_y_translate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119
};

#if SYF_Y_DEBUG != 0
static const short syf_y_prhs[] = {     0,
     0,     1,     5,     6,    15,    18,    19,    21,    25,    28,
    32,    34,    36,    37,    39,    45,    49,    52,    53,    57,
    65,    67,    68,    70,    71,    73,    75,    77,    78,    79,
    93,    96,    98,    99,   102,   104,   106,   108,   110,   112,
   114,   117,   119,   127,   130,   131,   134,   142,   150,   152,
   153,   160,   162,   164,   167,   168,   175,   178,   180,   185,
   186,   190,   192,   194,   196,   198,   200,   207,   212,   216,
   220,   222,   225,   227,   229,   230,   232,   234,   235,   238,
   240,   243,   244,   248,   249,   252,   253,   254,   255,   256,
   270,   272,   273,   276,   278,   280,   282,   284,   285,   287,
   291,   294,   295,   299,   301,   302,   305,   307,   309,   311,
   313,   315,   317,   323,   328,   333,   335,   336,   337,   349,
   350,   351,   358,   359,   362,   363,   373,   374,   377,   378,
   384,   386,   387,   391,   394,   395,   399,   401,   403,   405,
   407,   408,   411,   412,   415,   417,   419,   421,   423,   425,
   427,   429,   433,   437,   441,   445,   447,   451,   455,   459,
   463,   465,   469,   471,   473,   477,   479,   481,   484,   486,
   488,   490,   492,   494,   496,   498,   500,   502,   504,   506,
   508,   512,   514,   516,   518,   520,   525,   532,   536,   538,
   539,   543,   544,   548,   549,   551,   552,   554,   556,   558,
   561,   563,   565,   567,   569
};

#endif

static const short syf_y_rhs[] = {    -1,
   121,   122,   136,     0,     0,    64,   239,    72,   123,   129,
   246,   238,   245,     0,    64,     1,     0,     0,   125,     0,
    76,   127,   244,     0,    90,   127,     0,   243,   128,   243,
     0,   107,     0,    57,     0,     0,   130,     0,    86,    76,
   131,   244,   245,     0,    86,     1,   245,     0,   133,   132,
     0,     0,   132,   245,   133,     0,   134,   234,    54,   135,
   166,   124,   167,     0,     1,     0,     0,    99,     0,     0,
    12,     0,    25,     0,    13,     0,     0,     0,    32,    73,
    81,   239,    72,   137,   139,   138,     5,   168,   246,   238,
   245,     0,    32,     1,     0,   140,     0,     0,   140,   141,
     0,   147,     0,   146,     0,   148,     0,   152,     0,   143,
     0,   142,     0,     1,   245,     0,     4,     0,    52,    73,
    54,   166,   124,   144,   245,     0,   114,   227,     0,     0,
   114,   215,     0,   113,   234,    54,   166,   124,   145,   245,
     0,    99,   234,    54,   166,   124,   167,   245,     0,   149,
     0,     0,   109,    73,    72,   151,   150,   245,     0,   155,
     0,   159,     0,     1,   245,     0,     0,   101,    73,    72,
   154,   153,   245,     0,   166,   124,     0,   156,     0,    76,
   158,   157,   244,     0,     0,   157,    55,   158,     0,    73,
     0,    53,     0,   160,     0,   161,     0,   162,     0,    33,
    76,   163,   244,    81,   154,     0,    33,   164,    81,   154,
     0,   229,    90,    48,     0,    76,   165,   244,     0,   127,
     0,   229,   126,     0,   166,     0,   239,     0,     0,    43,
     0,   169,     0,     0,   169,   170,     0,   171,     0,     1,
   245,     0,     0,   241,   172,   174,     0,     0,   173,   174,
     0,     0,     0,     0,     0,    88,   175,   182,   176,   179,
     5,   177,   186,   178,   246,    88,   237,   245,     0,   180,
     0,     0,   180,   181,     0,   143,     0,   146,     0,   148,
     0,   152,     0,     0,   183,     0,    76,   184,    96,     0,
   229,   185,     0,     0,    55,   229,   185,     0,   187,     0,
     0,   187,   188,     0,   189,     0,   190,     0,   191,     0,
   193,     0,   199,     0,   207,     0,    34,   215,   211,   212,
   245,     0,   240,   114,   215,   245,     0,   240,    15,   204,
   245,     0,   215,     0,     0,     0,    71,   210,   106,   194,
   186,   195,   196,   198,   246,    71,   245,     0,     0,     0,
   196,    63,   210,   106,   197,   186,     0,     0,    62,   186,
     0,     0,    49,   215,   200,    72,   202,   201,   246,    49,
   245,     0,     0,   201,   202,     0,     0,   117,   205,    39,
   203,   186,     0,   192,     0,     0,   209,   206,   208,     0,
    23,   245,     0,     0,   208,    44,   209,     0,   227,     0,
    84,     0,   229,     0,   215,     0,     0,    94,   213,     0,
     0,    98,   214,     0,   105,     0,    65,     0,   116,     0,
   216,     0,   217,     0,   218,     0,   219,     0,   220,     3,
   220,     0,   216,     3,   220,     0,   220,    24,   220,     0,
   217,    24,   220,     0,   220,     0,   220,    18,   220,     0,
   220,    21,   220,     0,   220,    26,   220,     0,   219,    26,
   220,     0,   221,     0,   221,   226,   221,     0,   222,     0,
   223,     0,   222,    37,   223,     0,   224,     0,   225,     0,
    22,   225,     0,   227,     0,   228,     0,   229,     0,     7,
     0,    19,     0,    10,     0,    11,     0,    15,     0,    17,
     0,    53,     0,   105,     0,    47,     0,    76,   215,    96,
     0,   239,     0,   230,     0,   231,     0,   232,     0,   239,
    76,   243,   244,     0,   239,    76,   243,   128,   243,   244,
     0,   239,    38,   233,     0,   100,     0,     0,    73,   235,
   236,     0,     0,   236,    55,    73,     0,     0,   242,     0,
     0,   239,     0,    73,     0,   229,     0,   242,    54,     0,
    73,     0,    36,     0,    96,     0,   102,     0,     6,     0
};

#if SYF_Y_DEBUG != 0
static const short syf_y_rline[] = { 0,
   229,   247,   346,   378,   385,   391,   397,   402,   409,   415,
   433,   435,   440,   441,   445,   450,   457,   462,   463,   469,
   510,   527,   528,   532,   534,   536,   538,   543,   553,   572,
   580,   586,   590,   591,   596,   597,   598,   599,   600,   601,
   602,   608,   620,   642,   648,   650,   656,   702,   753,   757,
   771,   774,   776,   778,   783,   797,   800,   816,   822,   874,
   875,   882,   884,   890,   897,   899,   904,   918,   929,   945,
   952,   954,   959,   965,   980,   982,   987,   991,   992,   997,
   998,  1004,  1009,  1009,  1013,  1016,  1019,  1022,  1030,  1039,
  1048,  1053,  1054,  1062,  1063,  1064,  1065,  1069,  1070,  1074,
  1080,  1089,  1090,  1100,  1104,  1105,  1110,  1111,  1112,  1113,
  1114,  1115,  1120,  1134,  1152,  1269,  1274,  1284,  1295,  1302,
  1303,  1314,  1328,  1333,  1347,  1367,  1413,  1414,  1420,  1427,
  1445,  1450,  1458,  1462,  1467,  1468,  1479,  1484,  1490,  1574,
  1579,  1581,  1587,  1589,  1595,  1600,  1602,  1607,  1609,  1611,
  1613,  1618,  1622,  1629,  1633,  1640,  1642,  1646,  1653,  1657,
  1664,  1666,  1673,  1678,  1680,  1687,  1692,  1694,  1700,  1708,
  1710,  1820,  1822,  1824,  1826,  1828,  1830,  1835,  1837,  1839,
  1844,  1851,  1858,  1860,  1862,  1867,  1880,  1899,  1960,  1964,
  1967,  1970,  1971,  1978,  1980,  1985,  1987,  1992,  1997,  2002,
  2011,  2016,  2021,  2026,  2031
};

static const char * const syf_y_tname[] = {   "$","error","$illegal.","_AND","Pragma",
"_BEGIN","_END","_EQSym","_EXIT","_FILE","_GESym","_GTSym","_IN","_INOUT","_LABEL",
"_LESym","_LINKAGE","_LTSym","_NAND","_NESym","_NEXT","_NOR","_NOT","_NULL",
"_OR","_OUT","_XOR","ABS","ACCESS","AFTER","ALIAS","ALL","ARCHITECTURE","ARRAY",
"ASSERT","ATTRIBUTE","AbstractLit","Ampersand","Apostrophe","Arrow","BLOCK",
"BODY","BUFFER","BUS","Bar","BasedInt","BasedReal","BitStringLit","Box","CASE",
"COMPONENT","CONFIGURATION","CONSTANT","CharacterLit","Colon","Comma","DISCONNECT",
"DOWNTO","DecimalInt","DecimalReal","Dot","DoubleStar","ELSE","ELSIF","ENTITY",
"ERROR","FOR","FUNCTION","GENERATE","GENERIC","GUARDED","IF","IS","Identifier",
"LIBRARY","LOOP","LeftParen","MAP","MOD","Minus","NEW","OF","ON","OPEN","OTHERS",
"PACKAGE","PORT","PROCEDURE","PROCESS","Plus","RANGE","RECORD","REGISTER","REM",
"REPORT","RETURN","RightParen","SELECT","SEVERITY","SIGNAL","_STABLE","SUBTYPE",
"Semicolon","Slash","Star","StringLit","THEN","TO","TRANSPORT","BEHTYPE","UNITS",
"UNTIL","USE","VARIABLE","VarAsgn","WAIT","WARNING","WHEN","WHILE","WITH","design_file",
"@1","entity_declaration","@2",".constraint.","constraint","range_constraint",
"range","direction",".port_clause.","port_clause","formal_port_list","...formal_port_element..",
"formal_port_element",".SIGNAL.",".mode.","architecture_body","@3","@4","architecture_declarative_part",
"..block_declarative_item..","block_declarative_item","pragma_declaration","constant_declaration",
"constant_VarAsgn__expression",".VarAsgn__expression.","variable_declaration",
"signal_declaration","type_declaration","full_type_declaration","@5","type_definition",
"subtype_declaration","@6","subtype_indication","scalar_type_definition","enumeration_type_definition",
"...enumeration_literal..","enumeration_literal","composite_type_definition",
"array_type_definition","unconstrained_array_definition","constrained_array_definition",
"index_subtype_definition","index_constraint","discrete_range","type_mark",".signal_kind.",
"architecture_statement_part","..concurrent_statement..","concurrent_statement",
"process_statement","@7","@8","unlabeled_process_statement","@9","@10","@11",
"@12","process_declarative_part","..process_declarative_item..","process_declarative_item",
".sensitivity_list.","sensitivity_list","signal_list","...name..","sequence_of_statements",
"..sequential_statement..","sequential_statement","assertion_statement","variable_assignment_statement",
"signal_assignment_statement","waveform_element","if_statement","@13","@14",
"..ELSIF__THEN__seq_of_stmts..","@15",".ELSE__seq_of_stmts.","case_statement",
"@16","..case_statement_alternative..","case_statement_alternative","@17","waveform",
"choices","@18","null_statement","..Bar__choice..","choice","condition",".REPORT__expression.",
".SEVERITY__expression.","report__message","severity__message","expression",
"relation..AND__relation..","relation..OR__relation..","relation.NAND_NOR__relation.",
"relation..XOR__relation..","relation","simple_expression",".sign.term..add_op__term..",
"term","factor","primary","relational_operator","literal","aggregate","name",
"indexed_name","slice_name","attribute_name","attribute_designator","identifier_list",
"@19","...identifier..",".label.",".simple_name.","simple_name","target","a_label",
"label","abstractlit","RightParen_ERR","Semicolon_ERR","END_ERR",""
};
#endif

static const short syf_y_r1[] = {     0,
   121,   120,   123,   122,   122,   124,   124,   125,   126,   127,
   128,   128,   129,   129,   130,   130,   131,   132,   132,   133,
   133,   134,   134,   135,   135,   135,   135,   137,   138,   136,
   136,   139,   140,   140,   141,   141,   141,   141,   141,   141,
   141,   142,   143,   144,   145,   145,   146,   147,   148,   150,
   149,   151,   151,   151,   153,   152,   154,   155,   156,   157,
   157,   158,   158,   159,   160,   160,   161,   162,   163,   164,
   165,   165,   165,   166,   167,   167,   168,   169,   169,   170,
   170,   172,   171,   173,   171,   175,   176,   177,   178,   174,
   179,   180,   180,   181,   181,   181,   181,   182,   182,   183,
   184,   185,   185,   186,   187,   187,   188,   188,   188,   188,
   188,   188,   189,   190,   191,   192,   194,   195,   193,   196,
   197,   196,   198,   198,   200,   199,   201,   201,   203,   202,
   204,   206,   205,   207,   208,   208,   209,   209,   209,   210,
   211,   211,   212,   212,   213,   214,   214,   215,   215,   215,
   215,   216,   216,   217,   217,   218,   218,   218,   219,   219,
   220,   220,   221,   222,   222,   223,   224,   224,   225,   225,
   225,   226,   226,   226,   226,   226,   226,   227,   227,   227,
   228,   229,   229,   229,   229,   230,   231,   232,   233,   235,
   234,   236,   236,   237,   237,   238,   238,   239,   240,   241,
   242,   243,   244,   245,   246
};

static const short syf_y_r2[] = {     0,
     0,     3,     0,     8,     2,     0,     1,     3,     2,     3,
     1,     1,     0,     1,     5,     3,     2,     0,     3,     7,
     1,     0,     1,     0,     1,     1,     1,     0,     0,    13,
     2,     1,     0,     2,     1,     1,     1,     1,     1,     1,
     2,     1,     7,     2,     0,     2,     7,     7,     1,     0,
     6,     1,     1,     2,     0,     6,     2,     1,     4,     0,
     3,     1,     1,     1,     1,     1,     6,     4,     3,     3,
     1,     2,     1,     1,     0,     1,     1,     0,     2,     1,
     2,     0,     3,     0,     2,     0,     0,     0,     0,    13,
     1,     0,     2,     1,     1,     1,     1,     0,     1,     3,
     2,     0,     3,     1,     0,     2,     1,     1,     1,     1,
     1,     1,     5,     4,     4,     1,     0,     0,    11,     0,
     0,     6,     0,     2,     0,     9,     0,     2,     0,     5,
     1,     0,     3,     2,     0,     3,     1,     1,     1,     1,
     0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
     1,     3,     3,     3,     3,     1,     3,     3,     3,     3,
     1,     3,     1,     1,     3,     1,     1,     2,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     3,     1,     1,     1,     1,     4,     6,     3,     1,     0,
     3,     0,     3,     0,     1,     0,     1,     1,     1,     2,
     1,     1,     1,     1,     1
};

static const short syf_y_defact[] = {     1,
     0,     0,     0,     5,   198,     0,     0,     2,     3,    31,
     0,    13,     0,     0,     0,    14,     0,     0,     0,   205,
   196,    28,   204,    16,    21,    23,     0,    18,     0,     0,
   197,    33,   203,     0,    17,   190,     0,     4,    29,     0,
    15,     0,   192,    24,     0,     0,    42,     0,     0,     0,
     0,     0,    34,    40,    39,    36,    35,    37,    49,    38,
    19,   191,    25,    27,    26,     0,    78,    41,     0,     0,
     0,     0,     0,     0,     6,    74,     0,     0,     0,     0,
     0,     0,     0,   193,     0,    75,     7,   196,     0,   201,
    79,    80,     0,    82,     0,     6,     6,    55,     6,     0,
     0,     0,    50,    52,    58,    53,    64,    65,    66,     6,
   202,     0,     0,    76,    20,     0,    81,    86,    85,     0,
   200,     0,    75,     0,    57,    54,     0,     0,    63,    62,
    60,     0,    45,     8,    12,    11,     0,    30,    98,    83,
     0,     0,     0,    56,    71,     0,     0,    73,     0,   183,
   184,   185,    74,     0,     0,    51,     0,     0,    10,     0,
    87,    99,   180,   178,   179,    44,    43,    48,     0,    70,
     0,    72,     0,     0,    68,     0,    59,     0,     0,    46,
   148,   149,   150,   151,   156,   161,   163,   164,   166,   167,
   169,   170,   171,   182,    47,     0,   102,    92,     0,    69,
     9,   189,   188,     0,    61,   168,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   172,   174,   175,   176,   177,
   173,     0,     0,   100,     0,   101,     0,    91,    67,     0,
   186,   181,   153,   155,   160,   152,   157,   158,   154,   159,
   162,   165,   102,    88,    94,    95,    96,    97,    93,     0,
   103,   105,   187,    89,   104,     0,     0,     0,     0,     0,
   106,   107,   108,   109,   110,   111,   112,   199,     0,     0,
   134,   141,   125,     0,   140,     0,     0,   194,     0,   143,
     0,   117,   131,     0,   116,     0,     0,   195,   145,   142,
     0,     0,     0,   105,   115,   114,    90,   146,   147,   144,
   113,     0,   127,   118,   138,     0,   132,   137,   139,     0,
   120,   129,   135,   128,     0,   123,   105,   133,     0,   105,
     0,     0,   130,     0,   126,   124,     0,     0,   136,   121,
     0,   105,   119,   122,     0,     0,     0
};

static const short syf_y_defgoto[] = {   335,
     1,     3,    12,    86,    87,   172,   112,   137,    15,    16,
    27,    35,    28,    29,    66,     8,    32,    45,    39,    40,
    53,    54,    55,   142,   158,    56,    57,    58,    59,   132,
   103,    60,   124,    98,   104,   105,   155,   131,   106,   107,
   108,   109,   146,   128,   147,    99,   115,    77,    78,    91,
    92,   120,    93,   119,   139,   198,   252,   256,   227,   228,
   249,   161,   162,   196,   226,   254,   255,   261,   262,   263,
   264,   283,   265,   294,   311,   316,   332,   322,   266,   281,
   310,   303,   317,   284,   306,   313,   267,   318,   307,   274,
   280,   292,   290,   300,   275,   181,   182,   183,   184,   185,
   186,   187,   188,   189,   190,   222,   191,   192,   193,   150,
   151,   152,   203,    37,    43,    62,   287,    30,   194,   269,
    94,    95,   113,    34,    24,    21
};

static const short syf_y_pact[] = {-32768,
   -26,    18,    -2,-32768,-32768,   -21,    25,-32768,-32768,-32768,
   -28,   -19,    -9,    17,    72,-32768,    37,   -12,    11,-32768,
    -9,-32768,-32768,-32768,-32768,-32768,    15,-32768,    45,   -12,
-32768,-32768,-32768,   -12,   -12,-32768,    69,-32768,-32768,    23,
-32768,    11,-32768,   127,   120,   -12,-32768,    74,    45,    82,
    84,    45,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    87,-32768,-32768,-32768,    -9,-32768,-32768,   106,   110,
    94,    96,   121,   101,   100,-32768,    72,    16,    -9,    -9,
    -9,    19,    -9,-32768,   146,   140,-32768,    -9,   -12,-32768,
-32768,-32768,    97,-32768,   130,   100,   100,-32768,   100,   -12,
   111,    77,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   100,
-32768,    15,   -34,-32768,-32768,   -12,-32768,-32768,-32768,    97,
-32768,    76,   140,   -12,-32768,-32768,    71,   105,-32768,-32768,
-32768,   -12,    88,-32768,-32768,-32768,   146,-32768,   112,-32768,
   -18,   -12,   -12,-32768,-32768,    15,    15,-32768,   113,-32768,
-32768,-32768,    24,    -9,    41,-32768,    -8,   -12,-32768,    -9,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   123,-32768,
     7,-32768,   107,   146,-32768,    77,-32768,   -13,    -8,-32768,
   198,   181,-32768,   180,   135,   162,   171,-32768,-32768,-32768,
-32768,-32768,-32768,    -7,-32768,   114,   154,-32768,    -9,-32768,
-32768,-32768,-32768,   -25,-32768,-32768,   115,    -8,    -8,    -8,
    -8,    -8,    -8,    -8,    -8,-32768,-32768,-32768,-32768,-32768,
-32768,    -8,    -8,-32768,    -9,-32768,   207,    20,-32768,   146,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   154,-32768,-32768,-32768,-32768,-32768,-32768,    15,
-32768,-32768,-32768,-32768,    92,    72,   -12,    -8,    -8,    -8,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -6,   125,
-32768,   122,-32768,   109,-32768,    -8,    -8,   141,   116,   119,
   147,-32768,-32768,   -12,-32768,   -12,   -12,-32768,-32768,-32768,
   -40,   -12,   103,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,     1,-32768,-32768,-32768,   179,-32768,-32768,-32768,     2,
-32768,-32768,-32768,-32768,   173,   108,-32768,   182,   -12,-32768,
    -8,    72,-32768,     1,-32768,-32768,   117,   153,-32768,-32768,
   -12,-32768,-32768,-32768,   225,   228,-32768
};

static const short syf_y_pgoto[] = {-32768,
-32768,-32768,-32768,    52,-32768,-32768,   -94,    26,-32768,-32768,
-32768,-32768,   187,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,     3,-32768,-32768,     4,-32768,     5,-32768,-32768,
-32768,     8,-32768,  -143,-32768,-32768,-32768,    59,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -22,   118,-32768,-32768,-32768,
-32768,-32768,-32768,   124,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    -5,  -174,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -73,-32768,-32768,-32768,-32768,-32768,-32768,   -85,   -81,
-32768,-32768,-32768,-32768,  -142,-32768,-32768,-32768,-32768,   -17,
    21,-32768,    22,-32768,    64,-32768,  -135,-32768,  -124,-32768,
-32768,-32768,-32768,    -3,-32768,-32768,-32768,   159,     0,-32768,
-32768,   -29,  -127,  -105,   -30,   -76
};


#define	SYF_Y_LAST		301


static const short syf_y_table[] = {    38,
    88,     6,   149,    41,    42,   166,   134,    20,   276,   159,
   175,    25,    17,   178,   180,    68,    89,    18,     4,   100,
    31,   -77,   135,    46,   298,    10,    47,   -32,   163,     7,
   173,   135,   145,   163,   164,   197,   207,     2,   163,   164,
   169,   170,   111,    75,   164,    70,   204,   163,    73,   177,
     9,   101,    13,   164,   200,   229,    96,    97,   117,     5,
   110,   173,   179,     5,     5,    76,    14,   179,   174,   126,
    33,    48,   136,     5,    48,   299,   201,    20,    76,    76,
    76,   136,    76,   -22,   305,   138,   165,    31,    90,    23,
     5,   165,    19,   144,   102,   176,   165,    11,   231,   174,
   243,   156,   250,   -84,   148,   165,   111,   277,    22,    26,
    33,   167,   168,  -182,   257,   272,   273,    36,   302,   304,
    50,    49,    44,    50,    67,   258,   153,   195,    51,   129,
   268,    51,    52,   285,   286,    52,    33,   211,    63,    64,
   259,    74,   323,     5,   253,   326,    69,   122,   123,   130,
   125,    65,   212,    76,    71,   213,    72,   334,   214,    79,
   215,   133,   260,    80,     5,    81,   308,    82,   216,   320,
   321,   217,   218,    84,    83,    85,   219,   309,   220,   270,
   221,   111,   114,   121,   118,   154,   127,   160,   308,   141,
   233,   234,   235,   236,   237,   238,   239,   240,    76,   309,
   208,   157,   171,   199,   209,   210,   202,   223,   225,   224,
   232,   244,   278,    90,   282,   279,   291,   312,   293,   302,
   289,   319,   330,   331,   336,   324,   271,   337,    61,   230,
   245,   246,   247,   315,   205,   248,   314,   251,   329,   327,
   143,   206,   241,   140,   242,   328,   116,     0,   288,     0,
     0,     0,     0,   295,     0,   296,   297,     0,     0,     0,
     0,   301,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   325,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   333
};

static const short syf_y_check[] = {    30,
    77,     2,   127,    34,    35,   141,   112,     6,    15,   137,
   154,     1,    13,    22,   157,    46,     1,     1,     1,     1,
    21,     6,    57,     1,    65,     1,     4,     5,    47,    32,
    38,    57,   127,    47,    53,   160,   179,    64,    47,    53,
   146,   147,    36,    66,    53,    49,   174,    47,    52,   155,
    72,    33,    81,    53,    48,   199,    79,    80,    89,    73,
    83,    38,    76,    73,    73,    66,    86,    76,    76,   100,
    96,    52,   107,    73,    52,   116,   171,     6,    79,    80,
    81,   107,    83,    73,    84,   116,   105,    88,    73,   102,
    73,   105,    76,   124,    76,    55,   105,    73,   204,    76,
   225,   132,   230,    88,   127,   105,    36,   114,    72,    99,
    96,   142,   143,    90,    23,   258,   259,    73,   117,   294,
   101,    99,    54,   101,     5,    34,   127,   158,   109,    53,
   255,   109,   113,   276,   277,   113,    96,     3,    12,    13,
    49,    55,   317,    73,   250,   320,    73,    96,    97,    73,
    99,    25,    18,   154,    73,    21,    73,   332,    24,    54,
    26,   110,    71,    54,    73,    72,   302,    72,     7,    62,
    63,    10,    11,    73,    54,    76,    15,   302,    17,   256,
    19,    36,    43,    54,    88,    81,    76,    76,   324,   114,
   208,   209,   210,   211,   212,   213,   214,   215,   199,   324,
     3,   114,    90,    81,    24,    26,   100,    37,    55,    96,
    96,     5,    88,    73,   106,    94,    98,    39,    72,   117,
   105,    49,   106,    71,     0,    44,   257,     0,    42,   204,
   228,   228,   228,   310,   176,   228,   310,   243,   324,   321,
   123,   178,   222,   120,   223,   322,    88,    -1,   278,    -1,
    -1,    -1,    -1,   284,    -1,   286,   287,    -1,    -1,    -1,
    -1,   292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   319,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   331
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/labo/gnu/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define syf_y_errok		(syf_y_errstatus = 0)
#define syf_y_clearin	(syf_y_char = SYF_Y_EMPTY)
#define SYF_Y_EMPTY		-2
#define SYF_Y_EOF		0
#define SYF_Y_ACCEPT	return(0)
#define SYF_Y_ABORT 	return(1)
#define SYF_Y_ERROR		goto syf_y_errlab1
/* Like SYF_Y_ERROR except do call syf_y_error.
   This remains here temporarily to ease the
   transition to the new meaning of SYF_Y_ERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define SYF_Y_FAIL		goto syf_y_errlab
#define SYF_Y_RECOVERING()  (!!syf_y_errstatus)
#define SYF_Y_BACKUP(token, value) \
do								\
  if (syf_y_char == SYF_Y_EMPTY && syf_y_len == 1)				\
    { syf_y_char = (token), syf_y_lval = (value);			\
      syf_y_char1 = SYF_Y_TRANSLATE (syf_y_char);				\
      SYF_Y_POPSTACK;						\
      goto syf_y_backup;						\
    }								\
  else								\
    { syf_y_error ("syntax error: cannot back up"); SYF_Y_ERROR; }	\
while (0)

#define SYF_Y_TERROR	1
#define SYF_Y_ERRCODE	256

#ifndef SYF_Y_PURE
#define SYF_Y_LEX		syf_y_lex()
#endif

#ifdef SYF_Y_PURE
#ifdef SYF_Y_LSP_NEEDED
#define SYF_Y_LEX		syf_y_lex(&syf_y_lval, &syf_y_lloc)
#else
#define SYF_Y_LEX		syf_y_lex(&syf_y_lval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef SYF_Y_PURE

int	syf_y_char;			/*  the lookahead symbol		*/
SYF_Y_STYPE	syf_y_lval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef SYF_Y_LSP_NEEDED
SYF_Y_LTYPE syf_y_lloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int syf_y_nerrs;			/*  number of parse errors so far       */
#endif  /* not SYF_Y_PURE */

#if SYF_Y_DEBUG != 0
int syf_y_debug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  SYF_Y_INITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	SYF_Y_INITDEPTH
#define SYF_Y_INITDEPTH 200
#endif

/*  SYF_Y_MAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if SYF_Y_MAXDEPTH == 0
#undef SYF_Y_MAXDEPTH
#endif

#ifndef SYF_Y_MAXDEPTH
#define SYF_Y_MAXDEPTH 10000
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __syf_y__bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__syf_y__bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__syf_y__bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 169 "/labo/gnu/lib/bison.simple"
int
syf_y_parse()
{
  register int syf_y_state;
  register int syf_y_n;
  register short *syf_y_ssp;
  register SYF_Y_STYPE *syf_y_vsp;
  int syf_y_errstatus;	/*  number of tokens to shift before error messages enabled */
  int syf_y_char1;		/*  lookahead token as an internal (translated) token number */

  short	syf_y_ssa[SYF_Y_INITDEPTH];	/*  the state stack			*/
  SYF_Y_STYPE syf_y_vsa[SYF_Y_INITDEPTH];	/*  the semantic value stack		*/

  short *syf_y_ss = syf_y_ssa;		/*  refer to the stacks thru separate pointers */
  SYF_Y_STYPE *syf_y_vs = syf_y_vsa;	/*  to allow syf_y_overflow to reallocate them elsewhere */

#ifdef SYF_Y_LSP_NEEDED
  SYF_Y_LTYPE syf_y_lsa[SYF_Y_INITDEPTH];	/*  the location stack			*/
  SYF_Y_LTYPE *syf_y_ls = syf_y_lsa;
  SYF_Y_LTYPE *syf_y_lsp;

#define SYF_Y_POPSTACK   (syf_y_vsp--, syf_y_ssp--, syf_y_lsp--)
#else
#define SYF_Y_POPSTACK   (syf_y_vsp--, syf_y_ssp--)
#endif

  int syf_y_stacksize = SYF_Y_INITDEPTH;

#ifdef SYF_Y_PURE
  int syf_y_char;
  SYF_Y_STYPE syf_y_lval;
  int syf_y_nerrs;
#ifdef SYF_Y_LSP_NEEDED
  SYF_Y_LTYPE syf_y_lloc;
#endif
#endif

  SYF_Y_STYPE syf_y_val;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int syf_y_len;

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    fprintf(stderr, "Starting parse\n");
#endif

  syf_y_state = 0;
  syf_y_errstatus = 0;
  syf_y_nerrs = 0;
  syf_y_char = SYF_Y_EMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  syf_y_ssp = syf_y_ss - 1;
  syf_y_vsp = syf_y_vs;
#ifdef SYF_Y_LSP_NEEDED
  syf_y_lsp = syf_y_ls;
#endif

/* Push a new state, which is found in  syf_y_state  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
syf_y_newstate:

  *++syf_y_ssp = syf_y_state;

  if (syf_y_ssp >= syf_y_ss + syf_y_stacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      SYF_Y_STYPE *syf_y_vs1 = syf_y_vs;
      short *syf_y_ss1 = syf_y_ss;
#ifdef SYF_Y_LSP_NEEDED
      SYF_Y_LTYPE *syf_y_ls1 = syf_y_ls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = syf_y_ssp - syf_y_ss + 1;

#ifdef syf_y_overflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      syf_y_overflow("parser stack overflow",
		 &syf_y_ss1, size * sizeof (*syf_y_ssp),
		 &syf_y_vs1, size * sizeof (*syf_y_vsp),
#ifdef SYF_Y_LSP_NEEDED
		 &syf_y_ls1, size * sizeof (*syf_y_lsp),
#endif
		 &syf_y_stacksize);

      syf_y_ss = syf_y_ss1; syf_y_vs = syf_y_vs1;
#ifdef SYF_Y_LSP_NEEDED
      syf_y_ls = syf_y_ls1;
#endif
#else /* no syf_y_overflow */
      /* Extend the stack our own way.  */
      if (syf_y_stacksize >= SYF_Y_MAXDEPTH)
	{
	  syf_y_error("parser stack overflow");
	  return 2;
	}
      syf_y_stacksize *= 2;
      if (syf_y_stacksize > SYF_Y_MAXDEPTH)
	syf_y_stacksize = SYF_Y_MAXDEPTH;
      syf_y_ss = (short *) alloca (syf_y_stacksize * sizeof (*syf_y_ssp));
      __syf_y__bcopy ((char *)syf_y_ss1, (char *)syf_y_ss, size * sizeof (*syf_y_ssp));
      syf_y_vs = (SYF_Y_STYPE *) alloca (syf_y_stacksize * sizeof (*syf_y_vsp));
      __syf_y__bcopy ((char *)syf_y_vs1, (char *)syf_y_vs, size * sizeof (*syf_y_vsp));
#ifdef SYF_Y_LSP_NEEDED
      syf_y_ls = (SYF_Y_LTYPE *) alloca (syf_y_stacksize * sizeof (*syf_y_lsp));
      __syf_y__bcopy ((char *)syf_y_ls1, (char *)syf_y_ls, size * sizeof (*syf_y_lsp));
#endif
#endif /* no syf_y_overflow */

      syf_y_ssp = syf_y_ss + size - 1;
      syf_y_vsp = syf_y_vs + size - 1;
#ifdef SYF_Y_LSP_NEEDED
      syf_y_lsp = syf_y_ls + size - 1;
#endif

#if SYF_Y_DEBUG != 0
      if (syf_y_debug)
	fprintf(stderr, "Stack size increased to %d\n", syf_y_stacksize);
#endif

      if (syf_y_ssp >= syf_y_ss + syf_y_stacksize - 1)
	SYF_Y_ABORT;
    }

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    fprintf(stderr, "Entering state %d\n", syf_y_state);
#endif

  goto syf_y_backup;
 syf_y_backup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* syf_y_resume: */

  /* First try to decide what to do without reference to lookahead token.  */

  syf_y_n = syf_y_pact[syf_y_state];
  if (syf_y_n == SYF_Y_FLAG)
    goto syf_y_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* syf_y_char is either SYF_Y_EMPTY or SYF_Y_EOF
     or a valid token in external form.  */

  if (syf_y_char == SYF_Y_EMPTY)
    {
#if SYF_Y_DEBUG != 0
      if (syf_y_debug)
	fprintf(stderr, "Reading a token: ");
#endif
      syf_y_char = SYF_Y_LEX;
    }

  /* Convert token to internal form (in syf_y_char1) for indexing tables with */

  if (syf_y_char <= 0)		/* This means end of input. */
    {
      syf_y_char1 = 0;
      syf_y_char = SYF_Y_EOF;		/* Don't call SYF_Y_LEX any more */

#if SYF_Y_DEBUG != 0
      if (syf_y_debug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      syf_y_char1 = SYF_Y_TRANSLATE(syf_y_char);

#if SYF_Y_DEBUG != 0
      if (syf_y_debug)
	{
	  fprintf (stderr, "Next token is %d (%s", syf_y_char, syf_y_tname[syf_y_char1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef SYF_Y_PRINT
	  SYF_Y_PRINT (stderr, syf_y_char, syf_y_lval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  syf_y_n += syf_y_char1;
  if (syf_y_n < 0 || syf_y_n > SYF_Y_LAST || syf_y_check[syf_y_n] != syf_y_char1)
    goto syf_y_default;

  syf_y_n = syf_y_table[syf_y_n];

  /* syf_y_n is what to do for this token type in this state.
     Negative => reduce, -syf_y_n is rule number.
     Positive => shift, syf_y_n is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (syf_y_n < 0)
    {
      if (syf_y_n == SYF_Y_FLAG)
	goto syf_y_errlab;
      syf_y_n = -syf_y_n;
      goto syf_y_reduce;
    }
  else if (syf_y_n == 0)
    goto syf_y_errlab;

  if (syf_y_n == SYF_Y_FINAL)
    SYF_Y_ACCEPT;

  /* Shift the lookahead token.  */

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    fprintf(stderr, "Shifting token %d (%s), ", syf_y_char, syf_y_tname[syf_y_char1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (syf_y_char != SYF_Y_EOF)
    syf_y_char = SYF_Y_EMPTY;

  *++syf_y_vsp = syf_y_lval;
#ifdef SYF_Y_LSP_NEEDED
  *++syf_y_lsp = syf_y_lloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (syf_y_errstatus) syf_y_errstatus--;

  syf_y_state = syf_y_n;
  goto syf_y_newstate;

/* Do the default action for the current state.  */
syf_y_default:

  syf_y_n = syf_y_defact[syf_y_state];
  if (syf_y_n == 0)
    goto syf_y_errlab;

/* Do a reduction.  syf_y_n is the number of a rule to reduce with.  */
syf_y_reduce:
  syf_y_len = syf_y_r2[syf_y_n];
  syf_y_val = syf_y_vsp[1-syf_y_len]; /* implement default value of the action */

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       syf_y_n, syf_y_rline[syf_y_n]);

      /* Print the symbols being reduced, and their result.  */
      for (i = syf_y_prhs[syf_y_n]; syf_y_rhs[i] > 0; i++)
	fprintf (stderr, "%s ", syf_y_tname[syf_y_rhs[i]]);
      fprintf (stderr, " -> %s\n", syf_y_tname[syf_y_r1[syf_y_n]]);
    }
#endif


  switch (syf_y_n) {

case 1:
#line 230 "bvl_bcomp.yac"
{  
                /* ###----------------------------------------------###  */
                /*    Initializations					 */
                /* ###----------------------------------------------###  */
                SYF_NM1LST = NULL;
                SYF_GRDLST = NULL;
                SYF_CNDLST = NULL;
                SYF_VALLST = NULL;

                hshtab     = initab ();

		
		SYF_MODNAM = NULL;
                SYF_BEFPNT = syf_beh_addbefig (SYF_HEDFIG,NULL);
                SYF_HEDFIG = SYF_BEFPNT;
                ;
    break;}
case 2:
#line 248 "bvl_bcomp.yac"
{
                struct syf_beout *beout_pnt;
                struct syf_berin *berin_pnt;
                struct syf_betyp *betyp_pnt;
                struct syf_beaux *beaux_pnt;
                struct syf_bebus *bebus_pnt;
                struct syf_bepcs *bepcs_pnt;
                struct syf_bereg *bereg_pnt;
		int i,j =0;
 
                /* ###----------------------------------------------### */
                /*    Checking that each output have at
least one driver*/
                /* ###----------------------------------------------### */
		/*printf("liste des types\n");
                betyp_pnt = SYF_BEFPNT->BETYP;
                while (betyp_pnt != NULL)
                  {
		   printf("name : %s [%d]\n",betyp_pnt->NAME,j);
		   printf("class : %c \n",betyp_pnt->CLASS);
		   printf("BASE : %d \n",betyp_pnt->BASE);
		   printf("INDEX : %d \n",betyp_pnt->INDEX);
		   printf("TYPE : %d \n",chktab (hshtab,betyp_pnt->NAME,SYF_MODNAM,SYF_TYPDFN) );
		   if(betyp_pnt->VALUE != NULL)
		   for ( i= 0; i< betyp_pnt->SIZE ; i++)
		   	  printf("VAL : %s \n",*(betyp_pnt->VALUE + i));
                  betyp_pnt = betyp_pnt->NEXT;
				  j++;
                  }*/
	
                /*beout_pnt = SYF_BEFPNT->BEOUT;
                while (beout_pnt != NULL)
                  {
		   printf("%s \n",beout_pnt->NAME);
                  if (beout_pnt->ABL == NULL)
                    syf_error (40,beout_pnt->NAME);
                  beout_pnt = beout_pnt->NEXT;
                  }*/

           /*     berin_pnt = SYF_BEFPNT->BERIN;
                while (beout_pnt != NULL)
                  {
		   printf("%s \n",berin_pnt->NAME);
                  if (beout_pnt->ABL == NULL)
                    syf_error (40,berin_pnt->NAME);
                  berin_pnt = berin_pnt->NEXT;
                  }*/
 
                /*bepcs_pnt = SYF_BEFPNT->BEPCS;
                while (bepcs_pnt != NULL)
                  {
		  struct syf_bepgm *bepgm;
		  struct ptype *betyp;
		   printf("label : %s \n",bepcs_pnt->LABEL);
			bepgm = SYF_BEFPNT->BEPGM;
			while(bepgm)
			{
		   printf("pragma : %s  %s %s\n",bepgm->TOOL,bepgm->TYPE,bepgm->NAME);
			  bepgm = bepgm->NEXT;
			}
			betyp = bepcs_pnt->INSTRUCTION;
			while(betyp)
			{
			  display_beh(betyp); 
			  betyp = betyp->NEXT;
			}
                  bepcs_pnt = bepcs_pnt->NEXT;
                  }*/

                beaux_pnt = SYF_BEFPNT->BEAUX;
                while (beaux_pnt != NULL)
                  {
		 /*  printf("%s \n",beaux_pnt->NAME);
                  if (beaux_pnt->ABL == NULL)
                    syf_error (40,beaux_pnt->NAME);*/
                  beaux_pnt = beaux_pnt->NEXT;
                  }
 
                bebus_pnt = SYF_BEFPNT->BEBUS;
                while (bebus_pnt != NULL)
                  {
                  if (bebus_pnt->BIABL == NULL)
                    syf_error (40,bebus_pnt->NAME);
                  bebus_pnt = bebus_pnt->NEXT;
                  }
 
                bereg_pnt = SYF_BEFPNT->BEREG;
                while (bereg_pnt != NULL)
                  {
                  if (bereg_pnt->BIABL == NULL)
                    syf_error (40,bereg_pnt->NAME);
                  bereg_pnt = bereg_pnt->NEXT;
                  }
                fretab (hshtab);
                ;
    break;}
case 3:
#line 349 "bvl_bcomp.yac"
{
		int type,size=0;
		struct syf_betyp *betyp_pnt;
                SYF_BEFPNT->NAME = syf_y_vsp[-1].text;
		SYF_MODNAM = syf_y_vsp[-1].text;

		betyp_pnt = syf_beh_prdeftyp();
		 SYF_BEFPNT->BETYP = betyp_pnt;
		 SYF_NUMTYP =1;
		 while(betyp_pnt)
		 {
		   size++;
		    betyp_pnt = betyp_pnt->NEXT;
		  }

		 betyp_pnt =SYF_BEFPNT->BETYP ;
		while(betyp_pnt)
		  {
		type = val_type(betyp_pnt->NAME);
   	    addtab(hshtab,betyp_pnt->NAME,SYF_MODNAM,SYF_SIGDFN,SYF_TPEDFN);
   	    addtab(hshtab,betyp_pnt->NAME,SYF_MODNAM,SYF_USRDFN,type);
   	    addtab(hshtab,betyp_pnt->NAME,SYF_MODNAM,SYF_LBLDFN,betyp_pnt->CLASS);
   	    addtab(hshtab,betyp_pnt->NAME,SYF_MODNAM,SYF_TYPDFN,size +1 - SYF_NUMTYP);
            addtab(hshtab,betyp_pnt->NAME,SYF_MODNAM,SYF_PNTDFN,(int)betyp_pnt);
		    betyp_pnt = betyp_pnt->NEXT;
		    SYF_NUMTYP++;
		  }
                ;
    break;}
case 4:
#line 381 "bvl_bcomp.yac"
{
                if ((syf_y_vsp[-1].text != NULL) && (syf_y_vsp[-1].text != syf_y_vsp[-6].text))
                  syf_error (1,syf_y_vsp[-1].text);
                ;
    break;}
case 5:
#line 387 "bvl_bcomp.yac"
{ syf_error (2,NULL); ;
    break;}
case 6:
#line 392 "bvl_bcomp.yac"
{  
                syf_y_val.name.FLAG  = 'U';
                syf_y_val.name.LEFT  = -1;
                syf_y_val.name.RIGHT = -1;
                ;
    break;}
case 7:
#line 398 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name; ;
    break;}
case 8:
#line 405 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[-1].name; ;
    break;}
case 9:
#line 411 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name; ;
    break;}
case 10:
#line 418 "bvl_bcomp.yac"
{    
                syf_y_val.name.FLAG  = 'A';
                syf_y_val.name.LEFT  = syf_y_vsp[-2].valu;
                syf_y_val.name.RIGHT = syf_y_vsp[0].valu;

                if (((syf_y_vsp[-2].valu > syf_y_vsp[0].valu) && (syf_y_vsp[-1].valu == SYF_UPTDFN)) ||
                    ((syf_y_vsp[-2].valu < syf_y_vsp[0].valu) && (syf_y_vsp[-1].valu == SYF_DWTDFN)) ||
                    ((syf_y_vsp[-2].valu < 0 ) || (syf_y_vsp[-1].valu < 0 )))
                  {
                  syf_error (32,NULL);
                  }
                ;
    break;}
case 11:
#line 434 "bvl_bcomp.yac"
{ syf_y_val.valu = SYF_UPTDFN; ;
    break;}
case 12:
#line 436 "bvl_bcomp.yac"
{ syf_y_val.valu = SYF_DWTDFN; ;
    break;}
case 16:
#line 453 "bvl_bcomp.yac"
{ syf_error (3,NULL); ;
    break;}
case 20:
#line 476 "bvl_bcomp.yac"
{
                char *signame;
                int   sigconf;
                void *pnt;
 
                /* ###----------------------------------------------### */
                /*    First, check the validity of the declaration.     */
                /* Then, for each port, create the apropriate set of    */
                /* structures (berin, bepor, beout, bebus)              */
                /* ###----------------------------------------------### */
 
                syf_chkdcl ('P', syf_y_vsp[-3].valu, val_type(syf_y_vsp[-2].name.NAME), syf_y_vsp[-2].name.FLAG, syf_y_vsp[0].valu, syf_y_vsp[-1].name.FLAG);

                SYF_NM1LST = reverse (SYF_NM1LST);
                while (SYF_NM1LST != NULL)
                  {
                  signame = (char *)SYF_NM1LST->DATA;
                  if (chktab (hshtab,signame,SYF_MODNAM,SYF_SIGDFN) != 0)
                    syf_error (4,signame);

                  pnt =  syf_addstr (SYF_BEFPNT,'P',syf_y_vsp[-3].valu,val_type(syf_y_vsp[-2].name.NAME),syf_y_vsp[-2].name.TYPE,syf_y_vsp[-2].name.FLAG,signame,
                                syf_y_vsp[-1].name.LEFT,syf_y_vsp[-1].name.RIGHT);
 
                  addtab (hshtab,signame,SYF_MODNAM,SYF_SIGDFN,syf_y_vsp[-3].valu);

                  addtab (hshtab,signame,SYF_MODNAM,SYF_TYPDFN,syf_y_vsp[-2].name.TYPE);
                  addtab (hshtab,signame,SYF_MODNAM,SYF_WMNDFN,syf_y_vsp[-1].name.LEFT);
                  addtab (hshtab,signame,SYF_MODNAM,SYF_WMXDFN,syf_y_vsp[-1].name.RIGHT);
                  addtab (hshtab,signame,SYF_MODNAM,SYF_LBLDFN,syf_y_vsp[0].valu);
                  addtab (hshtab,signame,SYF_MODNAM,SYF_PNTDFN,(int)pnt);
 
                  SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
                  }
                ;
    break;}
case 21:
#line 511 "bvl_bcomp.yac"
{
                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the	*/
                /* sync. token 'Semicolon' is found			*/
                /* ###----------------------------------------------### */
 
                /*do
                  syf_y_char = syf_y_lex ();
                while ((syf_y_char != Semicolon) && (syf_y_char != 0));           
                syf_y_errok;
*/ 
                syf_error (6,NULL);
                ;
    break;}
case 24:
#line 533 "bvl_bcomp.yac"
{ syf_y_val.valu = SYF_ICNDFN; ;
    break;}
case 25:
#line 535 "bvl_bcomp.yac"
{ syf_y_val.valu = SYF_ICNDFN; ;
    break;}
case 26:
#line 537 "bvl_bcomp.yac"
{ syf_y_val.valu = SYF_OCNDFN; ;
    break;}
case 27:
#line 539 "bvl_bcomp.yac"
{ syf_y_val.valu = SYF_BCNDFN; ;
    break;}
case 28:
#line 548 "bvl_bcomp.yac"
{
                if (syf_y_vsp[-1].text != SYF_MODNAM)
                  syf_error (1,syf_y_vsp[-1].text);
                ;
    break;}
case 29:
#line 553 "bvl_bcomp.yac"
{
		  struct syf_betyp *listbetyp; 
		  struct syf_betyp *betypaux; 
		  struct syf_betyp *revbetyp = NULL; 
			listbetyp = SYF_BEFPNT->BETYP;
		     revbetyp = listbetyp;
		     listbetyp = listbetyp->NEXT;		
		     revbetyp->NEXT = NULL;	
		  while(listbetyp != NULL)
		   {
		     betypaux = revbetyp;	
		     revbetyp = listbetyp;
		     listbetyp = listbetyp->NEXT;		
		     revbetyp->NEXT = betypaux;		
		   }
			
                        SYF_BEFPNT->BETYP = syf_beh_crtbetyp(revbetyp);
		;
    break;}
case 30:
#line 576 "bvl_bcomp.yac"
{
                if ((syf_y_vsp[-1].text != NULL) && (syf_y_vsp[-1].text != syf_y_vsp[-11].text))
                  syf_error (7,syf_y_vsp[-1].text);
                ;
    break;}
case 31:
#line 582 "bvl_bcomp.yac"
{ syf_error (8,NULL); ;
    break;}
case 41:
#line 604 "bvl_bcomp.yac"
{ syf_error (9,NULL); ;
    break;}
case 42:
#line 609 "bvl_bcomp.yac"
{
		char pragma[30];
		char type[30];
		char name[30];
		 sscanf((char *)syf_y_vsp[0].valu,"-- %s %s %s", pragma,type,name);

                        SYF_BEFPNT->BEPGM = syf_beh_addbepgm(SYF_BEFPNT->BEPGM,"SYF",type,name,NULL);
		;
    break;}
case 43:
#line 627 "bvl_bcomp.yac"
{
                int sigconf;

                if (syf_chkdcl ('C',0,val_type(syf_y_vsp[-3].name.NAME),syf_y_vsp[-3].name.FLAG,0,syf_y_vsp[-2].name.FLAG) == 0)
                {
                  addtab (hshtab,syf_y_vsp[-5].text,SYF_MODNAM,SYF_WMNDFN,syf_y_vsp[-2].name.LEFT);
                  addtab (hshtab,syf_y_vsp[-5].text,SYF_MODNAM,SYF_WMXDFN,syf_y_vsp[-2].name.RIGHT);
                  addtab (hshtab,syf_y_vsp[-5].text,SYF_MODNAM,SYF_SIGDFN,SYF_CSTDFN);
                  addtab (hshtab,syf_y_vsp[-5].text,SYF_MODNAM,SYF_TYPDFN,-1);
                  addtab (hshtab,syf_y_vsp[-5].text,NULL,SYF_PNTDFN,syf_y_vsp[-1].text);
                }
                ;
    break;}
case 44:
#line 644 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 45:
#line 649 "bvl_bcomp.yac"
{  syf_y_val.list.LIST_ABL = NULL ;;
    break;}
case 46:
#line 652 "bvl_bcomp.yac"
{  syf_y_val.list = syf_y_vsp[0].list ;;
    break;}
case 47:
#line 663 "bvl_bcomp.yac"
{
                char *signame;
                int   sigconf;
                void *pnt;
                int   errflg;
 
                errflg = syf_chkdcl ('V',0,val_type(syf_y_vsp[-3].name.NAME),syf_y_vsp[-3].name.FLAG,0,syf_y_vsp[-2].name.FLAG);

              /* ###----------------------------------------------### */
            /*    First, check the validity of the declaration.     */
          /* Then, for each signal, create the apropriate set of  */
        /* structures (berin, bereg, beaux, bebux)
                */
                /* ###----------------------------------------------### */
 
              SYF_NM1LST = reverse (SYF_NM1LST);
                while (SYF_NM1LST != NULL)
                  {
                  signame = (char *)SYF_NM1LST->DATA;
                  if (chktab (hshtab,signame,SYF_MODNAM,SYF_SIGDFN) != 0)
                  syf_error (80,signame);

                /*  pnt = syf_addstr (SYF_BEFPNT,'V',0,val_type($4.NAME),$4.TYPE,
			$4.FLAG,signame, $5.LEFT,$5.RIGHT);*/
 
                  addtab (hshtab,signame,SYF_MODNAM,SYF_SIGDFN,SYF_VARDFN);
                  addtab (hshtab,signame,SYF_MODNAM,SYF_TYPDFN,syf_y_vsp[-3].name.TYPE);
                addtab (hshtab,signame,SYF_MODNAM,SYF_WMNDFN,syf_y_vsp[-2].name.LEFT);
              addtab (hshtab,signame,SYF_MODNAM,SYF_WMXDFN,syf_y_vsp[-2].name.RIGHT);
              addtab (hshtab,signame,SYF_MODNAM,SYF_LBLDFN,syf_y_vsp[-1].list);
            addtab (hshtab,signame,SYF_MODNAM,SYF_PNTDFN,syf_y_vsp[-1].list.LIST_ABL);
 
          SYF_NM1LST = delchain (SYF_NM1LST,SYF_NM1LST);
        
                }
           ;
    break;}
case 48:
#line 709 "bvl_bcomp.yac"
{
                char *signame;
                int   sigconf;
                void *pnt;
                int   errflg;
 
                errflg = syf_chkdcl ('S',0,val_type(syf_y_vsp[-3].name.NAME),syf_y_vsp[-3].name.FLAG,syf_y_vsp[-1].valu,syf_y_vsp[-2].name.FLAG);
 
              /* ###----------------------------------------------### */
            /*    First, check the validity of the declaration.     */
          /* Then, for each signal, create the apropriate set of  */
        /* structures (berin, bereg, beaux, bebux)
                */
                /* ###----------------------------------------------### */
 
	  /*if( val_type($4.NAME) != -1)
		syf_error(81,$4.NAME);*/
	  /*else */
	  {
              SYF_NM1LST = reverse (SYF_NM1LST);
                while (SYF_NM1LST != NULL)
                  {
                  signame = (char *)SYF_NM1LST->DATA;
                  if (chktab (hshtab,signame,SYF_MODNAM,SYF_SIGDFN) != 0)
                  syf_error (10,signame);

                  pnt = syf_addstr (SYF_BEFPNT,'S',0,val_type(syf_y_vsp[-3].name.NAME),syf_y_vsp[-3].name.TYPE,
			syf_y_vsp[-3].name.FLAG,signame, syf_y_vsp[-2].name.LEFT,syf_y_vsp[-2].name.RIGHT);
 
                  addtab (hshtab,signame,SYF_MODNAM,SYF_SIGDFN,SYF_SGNDFN);
                  addtab (hshtab,signame,SYF_MODNAM,SYF_TYPDFN,syf_y_vsp[-3].name.TYPE);
                addtab (hshtab,signame,SYF_MODNAM,SYF_WMNDFN,syf_y_vsp[-2].name.LEFT);
              addtab (hshtab,signame,SYF_MODNAM,SYF_WMXDFN,syf_y_vsp[-2].name.RIGHT);
              addtab (hshtab,signame,SYF_MODNAM,SYF_LBLDFN,syf_y_vsp[-1].valu);
            addtab (hshtab,signame,SYF_MODNAM,SYF_PNTDFN,(int)pnt);
 
          SYF_NM1LST = delchain (SYF_NM1LST,SYF_NM1LST);
        
                  }
           }  
	;
    break;}
case 50:
#line 761 "bvl_bcomp.yac"
{
		SYF_BEFPNT->BETYP =  syf_beh_addbetyp(SYF_BEFPNT->BETYP,syf_y_vsp[-2].text,syf_y_vsp[0].type.LEFT,
		 syf_y_vsp[0].type.RIGHT,syf_y_vsp[0].type.VALUE,syf_y_vsp[0].type.SIZE,syf_y_vsp[0].type.BYTE,syf_y_vsp[0].type.BASE,syf_y_vsp[0].type.INDEX,syf_y_vsp[0].type.RESOLV,syf_y_vsp[0].type.CLASS); 
   		addtab(hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_SIGDFN,SYF_TPEDFN);
   		addtab(hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_LBLDFN,syf_y_vsp[0].type.CLASS);
   	        addtab(hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_TYPDFN,SYF_NUMTYP);
                addtab (hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_PNTDFN,(int)SYF_BEFPNT->BETYP);
				SYF_NUMTYP++;
		;
    break;}
case 52:
#line 775 "bvl_bcomp.yac"
{ syf_y_val.type = syf_y_vsp[0].type; ;
    break;}
case 53:
#line 777 "bvl_bcomp.yac"
{ syf_y_val.type = syf_y_vsp[0].type; ;
    break;}
case 54:
#line 779 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
case 55:
#line 787 "bvl_bcomp.yac"
{
		SYF_BEFPNT->BETYP =  syf_beh_addbetyp(SYF_BEFPNT->BETYP,syf_y_vsp[-2].text,syf_y_vsp[0].type.LEFT,
		 syf_y_vsp[0].type.RIGHT,syf_y_vsp[0].type.VALUE,syf_y_vsp[0].type.SIZE,syf_y_vsp[0].type.BYTE,syf_y_vsp[0].type.BASE,syf_y_vsp[0].type.INDEX,syf_y_vsp[0].type.RESOLV,syf_y_vsp[0].type.CLASS); 
   		addtab(hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_SIGDFN,SYF_TPEDFN);
   		addtab(hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_LBLDFN,syf_y_vsp[0].type.CLASS);
   	        addtab(hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_TYPDFN,SYF_NUMTYP);
                addtab (hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_PNTDFN,(int)SYF_BEFPNT->BETYP);
				SYF_NUMTYP++;
		;
    break;}
case 57:
#line 802 "bvl_bcomp.yac"
{ struct syf_betyp *betyp_pnt;
		betyp_pnt = (struct syf_betyp*)chktab(hshtab,syf_y_vsp[-1].name,SYF_MODNAM,SYF_PNTDFN);
		syf_y_val.type.BASE = syf_y_vsp[-1].name.TYPE ; 
		syf_y_val.type.VALUE = NULL ;
		syf_y_val.type.SIZE = 0 ;
		syf_y_val.type.BYTE = betyp_pnt->BYTE  ;
		syf_y_val.type.LEFT = syf_y_vsp[0].name.LEFT ;
		syf_y_val.type.RIGHT = syf_y_vsp[0].name.RIGHT ;
		syf_y_val.type.CLASS = 'S' ;
		syf_y_val.type.RESOLV = 0 ;
		;
    break;}
case 58:
#line 817 "bvl_bcomp.yac"
{ 
		syf_y_val.type = syf_y_vsp[0].type; 
		;
    break;}
case 59:
#line 826 "bvl_bcomp.yac"
{
                char *enumname;
		int size=0;
		int indice=0;
                char **pnt;
		chain_list *nm1lst;
 
                SYF_NM1LST = reverse (SYF_NM1LST);

		nm1lst = SYF_NM1LST;
                while (nm1lst != NULL)
		  {
			size++;
			nm1lst = nm1lst->NEXT;
	  	  }
		if( size != 0)
		  pnt = (char **) malloc(size * sizeof(char*));
	         
                while (SYF_NM1LST != NULL)
                  {
                  enumname = namealloc((char *)SYF_NM1LST->DATA);
                  if (chktab (hshtab,enumname,SYF_MODNAM,SYF_SIGDFN) != 0)
                    syf_error (82,enumname);

                  addtab (hshtab,enumname,SYF_MODNAM,SYF_SIGDFN,SYF_CSTDFN);
                  addtab (hshtab,enumname,SYF_MODNAM,SYF_TYPDFN,SYF_NUMTYP);
                  addtab (hshtab,enumname,SYF_MODNAM,SYF_USRDFN,size);
                  addtab (hshtab,enumname,SYF_MODNAM,SYF_WMNDFN,-1);
                  addtab (hshtab,enumname,SYF_MODNAM,SYF_WMXDFN,-1);
                  addtab (hshtab,enumname,SYF_MODNAM,SYF_LBLDFN,indice);
                  addtab (hshtab,enumname,SYF_MODNAM,SYF_PNTDFN,(int)pnt);
 
		  pnt[indice++] = enumname;
                  SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
                  }
		syf_y_val.type.VALUE = pnt ;
		syf_y_val.type.SIZE = size ;
		syf_y_val.type.LEFT = 0 ;
		syf_y_val.type.RIGHT = 0 ;
		syf_y_val.type.BYTE = size/256 +1;
		syf_y_val.type.CLASS = 'E' ;
		syf_y_val.type.BASE = 0 ;
		syf_y_val.type.RESOLV = 0 ;
		;
    break;}
case 61:
#line 878 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
case 62:
#line 883 "bvl_bcomp.yac"
{ SYF_NM1LST = addchain (SYF_NM1LST,syf_y_vsp[0].text); ;
    break;}
case 63:
#line 885 "bvl_bcomp.yac"
{ SYF_NM1LST = addchain (SYF_NM1LST,syf_y_vsp[0].text); ;
    break;}
case 64:
#line 891 "bvl_bcomp.yac"
{ 
		 syf_y_val.type = syf_y_vsp[0].type; 
		;
    break;}
case 65:
#line 898 "bvl_bcomp.yac"
{ syf_y_val.type = syf_y_vsp[0].type; ;
    break;}
case 66:
#line 900 "bvl_bcomp.yac"
{ syf_y_val.type = syf_y_vsp[0].type; ;
    break;}
case 67:
#line 910 "bvl_bcomp.yac"
{ 
		syf_y_val.type = syf_y_vsp[0].type;
		syf_y_val.type.CLASS = 'U'; 
		syf_y_val.type.INDEX = syf_y_vsp[-3].name.TYPE; 
		;
    break;}
case 68:
#line 922 "bvl_bcomp.yac"
{ syf_y_val.type = syf_y_vsp[0].type; 
		syf_y_val.type.CLASS = 'A'; 
		syf_y_val.type.INDEX = syf_y_vsp[-2].name.TYPE; 
		;
    break;}
case 69:
#line 932 "bvl_bcomp.yac"
{ 
		syf_y_val.name.NAME = syf_y_vsp[-2].name.NAME;
		syf_y_val.name.LEFT = syf_y_vsp[-2].name.LEFT;
		syf_y_val.name.RIGHT = syf_y_vsp[-2].name.RIGHT;
		/*$$.TYPE = chktab(hshtab,$1,SYF_MODNAM,SYF_TYPDFN); */
		syf_y_val.name.TYPE = syf_y_vsp[-2].name.TYPE; 
		syf_y_val.name.FLAG = chktab(hshtab,syf_y_vsp[-2].name,SYF_MODNAM,SYF_LBLDFN);
		if (syf_y_val.name.TYPE == 0 || syf_y_val.name.FLAG ==0)
		  syf_error(83,syf_y_vsp[-2].name);
	      ;
    break;}
case 70:
#line 948 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[-1].name;;
    break;}
case 71:
#line 953 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name;;
    break;}
case 72:
#line 956 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name;
	    syf_y_val.name.NAME = syf_y_vsp[-1].name.NAME;
	  ;
    break;}
case 73:
#line 961 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name;;
    break;}
case 74:
#line 966 "bvl_bcomp.yac"
{ 
		int type;
		syf_y_val.name.NAME = syf_y_vsp[0].text;
		syf_y_val.name.LEFT = -1;
		syf_y_val.name.RIGHT = -1;
		syf_y_val.name.TYPE = chktab(hshtab,syf_y_vsp[0].text,SYF_MODNAM,SYF_TYPDFN);
		syf_y_val.name.FLAG = chktab(hshtab,syf_y_vsp[0].text,SYF_MODNAM,SYF_LBLDFN);
		type = chktab(hshtab,syf_y_vsp[0].text,SYF_MODNAM,SYF_SIGDFN); 
		if (type != SYF_TPEDFN || syf_y_val.name.TYPE ==0)
			syf_error(84,syf_y_vsp[0].text);
	      ;
    break;}
case 75:
#line 981 "bvl_bcomp.yac"
{ syf_y_val.valu = 0; ;
    break;}
case 76:
#line 983 "bvl_bcomp.yac"
{ syf_y_val.valu = BUS; ;
    break;}
case 81:
#line 1000 "bvl_bcomp.yac"
{ syf_error (18,NULL); ;
    break;}
case 82:
#line 1005 "bvl_bcomp.yac"
{
		  SYF_LBLNAM = namealloc(syf_y_vsp[0].text); 
		;
    break;}
case 84:
#line 1009 "bvl_bcomp.yac"
{
		  SYF_LBLNAM = NULL; 
		;
    break;}
case 86:
#line 1017 "bvl_bcomp.yac"
{SYF_NM1LST = NULL ;;
    break;}
case 87:
#line 1019 "bvl_bcomp.yac"
{ SYF_BEFPNT->BEPCS = syf_beh_addbepcs(SYF_BEFPNT->BEPCS,SYF_LBLNAM,SYF_NM1LST,NULL,NULL,0); 
		  SYF_NM1LST = NULL; ;
    break;}
case 88:
#line 1023 "bvl_bcomp.yac"
{  
		void *pnt;
		pnt = (void *)(&(SYF_BEFPNT->BEPCS->INSTRUCTION));
                   SYF_NM1LST = addchain(NULL,pnt);
		;
    break;}
case 89:
#line 1030 "bvl_bcomp.yac"
{
		    struct ptype **pnt;
		    struct ptype *ptype;
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    ptype = reversetype(*pnt); 
		    *pnt = ptype; 
                  SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
		  ;
    break;}
case 90:
#line 1042 "bvl_bcomp.yac"
{ 
                syf_y_errok;
		;
    break;}
case 93:
#line 1056 "bvl_bcomp.yac"
{
                syf_y_errok;
                ;
    break;}
case 101:
#line 1082 "bvl_bcomp.yac"
{ 
		if(syf_y_vsp[-1].name.TYPE == 0)
			syf_error(17,syf_y_vsp[-1].name.NAME) ;
		SYF_NM1LST = addchain (SYF_NM1LST,syf_y_vsp[-1].name.NAME); ;
    break;}
case 103:
#line 1093 "bvl_bcomp.yac"
{ 
		if(syf_y_vsp[-1].name.TYPE == 0)
			syf_error(17,syf_y_vsp[-1].name.NAME) ;
		SYF_NM1LST = addchain (SYF_NM1LST,syf_y_vsp[-1].name.NAME); ;
    break;}
case 113:
#line 1125 "bvl_bcomp.yac"
{   unsigned int type; 
		    int mode; 	
		    struct ptype **pnt;

                    SYF_BEFPNT->BEMSG  = syf_beh_addbemsg(SYF_BEFPNT->BEMSG,NULL,syf_y_vsp[-1].valu,syf_y_vsp[-2].text,syf_y_vsp[-3].list.LIST_ABL->DATA,NULL);
		;
    break;}
case 114:
#line 1138 "bvl_bcomp.yac"
{   unsigned int type; 
		    int mode; 	
		    struct ptype **pnt;
		    type = chktab(hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_TYPDFN);
		    mode = chktab(hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_SIGDFN);
		    if( mode == 0)
			syf_error(17,syf_y_vsp[-3].name.NAME);
		    else if( mode != SYF_VARDFN)
			syf_error(27,syf_y_vsp[-3].name.NAME);
		    addtab(hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_PNTDFN,syf_y_vsp[-1].list.LIST_ABL);
		;
    break;}
case 115:
#line 1156 "bvl_bcomp.yac"
{   unsigned int type; 
		    int mode,i; 	
		    int left_bnd,right_bnd;
		    int in_bound,out_bound;
		    int left ,right;
	            int rev_flg, debut;
		    int sig_width;
		    struct chain   *abl_pnt;
		    char extname[100];
		    struct syf_expr expr;
		    struct ptype **pnt;

		    type = chktab(hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_TYPDFN);
		    mode = chktab(hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_SIGDFN);

	 	if( mode == 0)
			syf_error(17,syf_y_vsp[-3].name.NAME);
		if(mode != SYF_OCNDFN && mode != SYF_BCNDFN &&
								 mode != SYF_SGNDFN)
		   syf_error(17,syf_y_vsp[-3].name.NAME);

 	    left_bnd  = chktab (hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_WMNDFN);
        right_bnd = chktab (hshtab,syf_y_vsp[-3].name.NAME,SYF_MODNAM,SYF_WMXDFN);
 
                left  = syf_y_vsp[-3].name.LEFT;
                right = syf_y_vsp[-3].name.RIGHT;

		expr = syf_y_vsp[-1].list; 

                if (left_bnd <= right_bnd)
                  {
                  sig_width = right_bnd - left_bnd + 1;
                  if (left <= right)
                    {
                    rev_flg   = 0;
                    in_bound  = right_bnd - right;
                    out_bound = right_bnd - left;
                    if ((left < left_bnd) || (right > right_bnd))
                      syf_error (36,syf_y_vsp[-3].name.NAME);
		    debut = left;  
                    }

   else
                    {
                    rev_flg   = 1;
                    in_bound  = right_bnd - left;
                    out_bound = right_bnd - right;
                    if ((left > right_bnd) || (right < left_bnd))
                      syf_error (36,syf_y_vsp[-3].name.NAME);
		    debut = right;  
                    }
                  }
                else
                  {
                  sig_width = left_bnd - right_bnd + 1;
                  if (left <= right)
                    {
                    rev_flg   = 1;
                    in_bound  = left  - right_bnd;
                    out_bound = right - right_bnd;
                    if ((left < right_bnd) || (right > left_bnd))
                      syf_error (36,syf_y_vsp[-3].name.NAME);
		    debut = left;  
                    }
                  else
                    {
                    rev_flg   = 0;
                    in_bound  = right - right_bnd;
                    out_bound = left  - right_bnd;
                    if ((left > left_bnd) || (right < right_bnd))
                      syf_error (36,syf_y_vsp[-3].name.NAME);
		    debut = right;  
                    }
                  }
                if ((out_bound - in_bound + 1) != expr.WIDTH)
		{
                  syf_error (35,syf_y_vsp[-3].name.NAME);
		}
 
                if (rev_flg == 1)
                  expr.LIST_ABL = reverse (expr.LIST_ABL);
 
                abl_pnt = expr.LIST_ABL;
 

		    if( mode == SYF_ICNDFN)
			syf_error(21,syf_y_vsp[-3].name.NAME);
		    else if( mode == 0)
			syf_error(17,syf_y_vsp[-3].name.NAME);
			else
			{
		      pnt = (struct ptype**)(SYF_NM1LST->DATA);
                  if(sig_width >1) 
		  		  {
                      for (i=0 ; i<sig_width ; i++)
                        {
      			sprintf (extname,"%s %d",syf_y_vsp[-3].name.NAME,i+debut);
                        if (i >= in_bound)
                          {
                         *pnt =syf_beh_addbeasg(*pnt,extname, (struct chain *)abl_pnt->DATA,type);
                          abl_pnt = abl_pnt->NEXT;
                          }
                        if (i >= out_bound)
                          break;
                        } 
                  }       
			     else
                    *pnt  = syf_beh_addbeasg(*pnt,syf_y_vsp[-3].name.NAME,abl_pnt->DATA,type);
	        }
		;
    break;}
case 116:
#line 1270 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 117:
#line 1277 "bvl_bcomp.yac"
{
		    struct ptype **pnt;
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    *pnt = syf_beh_addbeifs(*pnt,syf_y_vsp[-1].list.LIST_ABL->DATA);
	            SYF_NM1LST = addchain(SYF_NM1LST,&(((struct syf_beifs*)(*pnt)->DATA)->CNDTRUE));
		;
    break;}
case 118:
#line 1284 "bvl_bcomp.yac"
{
		    struct ptype **pnt;
		    struct ptype *ptype;
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    ptype = reversetype(*pnt); 
		    *pnt = ptype; 
                  SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
	            SYF_NM1LST = addchain(SYF_NM1LST,&(((struct syf_beifs*)(*pnt)->DATA)->CNDFALSE));	
		;
    break;}
case 121:
#line 1307 "bvl_bcomp.yac"
{
		    struct ptype **pnt;
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    *pnt = syf_beh_addbeifs(*pnt,syf_y_vsp[-1].list.LIST_ABL->DATA);
	            SYF_NM1LST = addchain(SYF_NM1LST,(void*)&((struct syf_beifs*)(*pnt)->DATA)->CNDTRUE);	
		;
    break;}
case 122:
#line 1314 "bvl_bcomp.yac"
{
		    struct ptype **pnt;
		    struct ptype *ptype;
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    ptype = reversetype(*pnt); 
		    *pnt = ptype; 
                    SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
                    SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
	            SYF_NM1LST = addchain(SYF_NM1LST,&((struct syf_beifs*)(*pnt)->DATA)->CNDFALSE);	
		syf_y_errok; ;
    break;}
case 123:
#line 1329 "bvl_bcomp.yac"
{ 
                  SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
		  syf_y_errok; 
		;
    break;}
case 124:
#line 1335 "bvl_bcomp.yac"
{ 
		    struct ptype *ptype;
		    struct ptype **pnt;
		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    ptype = reversetype(*pnt); 
		    *pnt = ptype; 
                  SYF_NM1LST = delchain (SYF_NM1LST, SYF_NM1LST);
		  syf_y_errok; 
		;
    break;}
case 125:
#line 1349 "bvl_bcomp.yac"
{	
		    struct ptype **pnt;
		    struct syf_becas *becas;

		    pnt = (struct ptype**)SYF_NM1LST->DATA;
		    
		    /*becas = (struct syf_becas *)mbkalloc(sizeof(struct syf_becas));
		    becas->CHOICE = NULL;
		    becas->USER   = NULL;		
		    becas->SIZE   = 0;		
		    becas->TYPE = $2.TYPE;
		    becas->ABL = $2.LIST_ABL->DATA;*/
		    SYF_OTHPNT  = NULL;	
		*pnt = syf_beh_addbecas(*pnt,syf_y_vsp[0].list.LIST_ABL->DATA,syf_y_vsp[0].list.TYPE);	
	            SYF_NM1LST = addchain(SYF_NM1LST,(void*)&(((struct syf_becas*)((*pnt)->DATA))->SIZE));
	            SYF_NM1LST = addchain(SYF_NM1LST,(void*)&(((struct syf_becas*)(*pnt)->DATA)->CHOICE));
		;
    break;}
case 126:
#line 1372 "bvl_bcomp.yac"
{
		unsigned int size=1;
		unsigned int *size1;
		int indice=0;
		struct choice_chain *ch;
                struct syf_becho **pnt;
                struct syf_becho *tab;
		struct choice_chain *nm1lst;
 

		nm1lst = SYF_CASPNT;
                while (nm1lst != NULL)
		  {
			size++;
			nm1lst = nm1lst->NEXT;
	  	  }
		pnt = (struct syf_becho**)SYF_NM1LST->DATA;
		  SYF_NM1LST = delchain(SYF_NM1LST,SYF_NM1LST);
		if( size != 0)
		  tab  = (struct syf_becho*)mbkalloc(size*sizeof(struct syf_becho));
		 while(SYF_CASPNT)
		 {
		  tab[indice].INSTRUCTION = reversetype(SYF_CASPNT->INSTRUCTION);
		  tab[indice].SIZE = SYF_CASPNT->SIZE;
		  tab[indice++].VALUE = SYF_CASPNT->VALUE;
		  ch = SYF_CASPNT;
		  SYF_CASPNT =SYF_CASPNT->NEXT;
		  /*free(ch);*/
		  }
		  tab[indice].INSTRUCTION = reversetype(SYF_OTHPNT);
		  tab[indice].SIZE = -1;
		  tab[indice++].VALUE = namealloc("others");
		  (*pnt) = tab;
		  size1 = (unsigned int*) SYF_NM1LST->DATA;
		  *size1 = size;
		  SYF_NM1LST = delchain(SYF_NM1LST,SYF_NM1LST);
		  SYF_OTHPNT = NULL;
		;
    break;}
case 128:
#line 1416 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
case 129:
#line 1422 "bvl_bcomp.yac"
{ 
		 SYF_PTYPE = NULL;
		 SYF_NM1LST = addchain(SYF_NM1LST,(void*)&SYF_PTYPE);
		 ;
    break;}
case 130:
#line 1427 "bvl_bcomp.yac"
{ 
		 if( SYF_CNDLST == NULL)
		     syf_error(85,"case");
		 else if ( SYF_CNDLST->DATA == NULL)
		     SYF_OTHPNT = SYF_PTYPE ;
		 else 
		 while(SYF_CNDLST)
		 {
		  char* val;
		  val = (char *)SYF_CNDLST->DATA;
		  SYF_CASPNT = order_choice(SYF_CASPNT,SYF_PTYPE,val,strlen(val));
		  SYF_CNDLST = delchain(SYF_CNDLST,SYF_CNDLST);
		 }
		  SYF_NM1LST = delchain(SYF_NM1LST,SYF_NM1LST);
		;
    break;}
case 131:
#line 1446 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 132:
#line 1451 "bvl_bcomp.yac"
{
		 if (strcmp(syf_y_vsp[0].name.NAME , "others"))
                 	SYF_CNDLST = addchain (NULL ,(void*)syf_y_vsp[0].name.NAME); 
		 else 
                 	SYF_CNDLST = addchain (NULL ,NULL); 
		;
    break;}
case 133:
#line 1458 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
case 136:
#line 1471 "bvl_bcomp.yac"
{
                if (!strcmp(syf_y_vsp[0].name.NAME , "others")  || SYF_CNDLST->DATA == NULL)
                  syf_error (31,NULL);
                SYF_CNDLST = addchain (SYF_CNDLST ,(void*)syf_y_vsp[0].name.NAME);
                ;
    break;}
case 137:
#line 1480 "bvl_bcomp.yac"
{ syf_y_val.name.NAME  = syf_y_vsp[0].text;
		  syf_y_val.name.RIGHT = -1;
		  syf_y_val.name.TYPE  = -1;
		  syf_y_val.name.LEFT  = -1;;
    break;}
case 138:
#line 1485 "bvl_bcomp.yac"
{
		  syf_y_val.name.RIGHT = -1;
		  syf_y_val.name.TYPE  = -1;
		  syf_y_val.name.LEFT  = -1;
		  syf_y_val.name.NAME  = namealloc("others");;
    break;}
case 139:
#line 1491 "bvl_bcomp.yac"
{
                char           *val;
                char            val2[256];
                int             left;
                int             right;
                int             in_bound;
                int             out_bound;
                int             left_bnd;
                int             right_bnd;
                int             sig_conf;
 
                strcpy (val2,"B\"");
                sig_conf = chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_SIGDFN);
                val      = (char *) chktab (hshtab,syf_y_vsp[0].name.NAME,NULL,SYF_PNTDFN);
                if (sig_conf == 0)
                  syf_error (17,syf_y_vsp[0].name.NAME);
                else
                  {
                  if (sig_conf != SYF_CSTDFN)
                    syf_error (76,syf_y_vsp[0].name.NAME);
                  }
 
                left_bnd  = chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_WMNDFN);
                right_bnd = chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_WMXDFN);
 
                left  = syf_y_vsp[0].name.LEFT;
                right = syf_y_vsp[0].name.RIGHT;
 
                if (left_bnd <= right_bnd)
                  {
                  if (left <= right)
                    {
                    in_bound = left - left_bnd;
                    out_bound = right - left_bnd;
                    if ((left < left_bnd) || (right > right_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  else
                    {
                    in_bound = left - right_bnd;
                    out_bound = right - right_bnd;
                    if ((left > right_bnd) || (right < left_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  }
                else
                  {
                  if (left <= right)
                    {
                    in_bound = right - left_bnd;
                    out_bound = left - left_bnd;
                    if ((left < right_bnd) || (right > left_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  else
                    {
                    in_bound = right - right_bnd;
                    out_bound = left - right_bnd;
                    if ((left > left_bnd) || (right < right_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  }
		if( chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_TYPDFN) == -1) 
		{
                  syf_tobin (&val2[2],val,in_bound,out_bound);
                  strcat (val2,"\"");
                  syf_y_val.name.NAME = namealloc (val2);
                  syf_y_val.name.LEFT = -1;
                  syf_y_val.name.RIGHT = -1;
                  syf_y_val.name.TYPE = -1;
		}
		else 
		 {
                  syf_y_val.name.LEFT = syf_y_vsp[0].name.LEFT;
                  syf_y_val.name.RIGHT = syf_y_vsp[0].name.RIGHT;
                  syf_y_val.name.TYPE = syf_y_vsp[0].name.TYPE;
		  sig_conf = chktab(hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_LBLDFN) ;
			syf_y_val.name.NAME = (char *)syf_numtobin(sig_conf); 
		 }
		;
    break;}
case 140:
#line 1575 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 141:
#line 1580 "bvl_bcomp.yac"
{ syf_y_val.text = NULL;;
    break;}
case 142:
#line 1583 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text;;
    break;}
case 143:
#line 1588 "bvl_bcomp.yac"
{ syf_y_val.valu = 'E';;
    break;}
case 144:
#line 1591 "bvl_bcomp.yac"
{ syf_y_val.valu = syf_y_vsp[-1].valu;;
    break;}
case 145:
#line 1596 "bvl_bcomp.yac"
{ syf_stostr(syf_y_vsp[0].text);;
    break;}
case 146:
#line 1601 "bvl_bcomp.yac"
{ syf_y_val.valu = 'E';;
    break;}
case 147:
#line 1603 "bvl_bcomp.yac"
{ syf_y_val.valu = 'W';;
    break;}
case 148:
#line 1608 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 149:
#line 1610 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 150:
#line 1612 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 151:
#line 1614 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 152:
#line 1621 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (AND ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 153:
#line 1625 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (AND ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1);;
    break;}
case 154:
#line 1632 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (OR ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 155:
#line 1636 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (OR ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 156:
#line 1641 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 157:
#line 1645 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (NAND ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 158:
#line 1649 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (NAND ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 159:
#line 1656 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (XOR ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 160:
#line 1660 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (XOR ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 161:
#line 1665 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 162:
#line 1669 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (syf_y_vsp[-1].valu ,syf_y_vsp[-2].list ,syf_y_vsp[0].list ,-1,-1); ;
    break;}
case 163:
#line 1674 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 164:
#line 1679 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 165:
#line 1683 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (CONC,syf_y_vsp[-2].list,syf_y_vsp[0].list,-1,-1); ;
    break;}
case 166:
#line 1688 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 167:
#line 1693 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 168:
#line 1696 "bvl_bcomp.yac"
{ syf_y_val.list = syf_crtabl (NOT,syf_y_vsp[0].list,SYF_EMPSTR,-1,-1); ;
    break;}
case 169:
#line 1701 "bvl_bcomp.yac"
{
                struct syf_expr expr1;
 
                expr1.IDENT = syf_y_vsp[0].text;
                expr1.TYPE = -1;
                syf_y_val.list = syf_crtabl (NOPS,expr1,SYF_EMPSTR,-1,-1);
                ;
    break;}
case 170:
#line 1709 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[0].list; ;
    break;}
case 171:
#line 1711 "bvl_bcomp.yac"
{
                struct syf_expr expr1;
                int             left;
                int             right;
                int             left_bnd;
                int             right_bnd;
                int             in_bound;
                int             out_bound;
                int             mode;

                mode = chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_SIGDFN);
		if( mode == SYF_OCNDFN)
		{
                    syf_error (26,syf_y_vsp[0].name.NAME);
	            syf_y_val.list.IDENT = NULL;	
	            syf_y_val.list.LIST_ABL = NULL;	
	            syf_y_val.list.WIDTH = 0;	
	            syf_y_val.list.TYPE = 0;	
		}
		else if( mode == 0 || mode == SYF_TPEDFN)
		{
                    syf_error (17,syf_y_vsp[0].name.NAME);
	            syf_y_val.list.IDENT = NULL;	
	            syf_y_val.list.LIST_ABL = NULL;	
	            syf_y_val.list.WIDTH = 0;	
	            syf_y_val.list.TYPE = 0;	
		}
	       else
               { 
                left_bnd  = chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_WMNDFN);
                right_bnd = chktab (hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_WMXDFN);
 
                left  = syf_y_vsp[0].name.LEFT;
                right = syf_y_vsp[0].name.RIGHT;
 
                if (left_bnd <= right_bnd)
                  {
                  if (left <= right)
                    {
                    in_bound  = left  - left_bnd;
                    out_bound = right - left_bnd;
                    if ((left < left_bnd) || (right > right_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  else
                    {
                    in_bound  = right - left_bnd;
                    out_bound = left  - left_bnd;
                    if ((left > right_bnd) || (right < left_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  }
                else
                  {
                  if (left <= right)
                    {
                    in_bound  = left  - right_bnd;
                    out_bound = right - right_bnd;
                    if ((left < right_bnd) || (right > left_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  else
                    {
                    in_bound  = right - right_bnd;
                    out_bound = left  - right_bnd;
                    if ((left > left_bnd) || (right < right_bnd))
                      syf_error (36,syf_y_vsp[0].name.NAME);
                    }
                  }

                if ( mode == SYF_VARDFN)
                  {
                  expr1.IDENT = NULL;
                  expr1.TYPE = chktab(hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_TYPDFN);

                  expr1.LIST_ABL = (struct chain *)chktab(hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_PNTDFN);
                  syf_y_val.list = syf_crtabl (SUBVAR,expr1,SYF_EMPSTR,in_bound,out_bound);
                  }
                else if ((mode != SYF_CSTDFN)||
		   (chktab(hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_TYPDFN) != -1))
                  {
				  int  prtype;
				  int  type;
                  expr1.IDENT = syf_y_vsp[0].name.NAME;
				  prtype = chktab(hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_USRDFN);
				  type = chktab(hshtab,syf_y_vsp[0].name.NAME,SYF_MODNAM,SYF_TYPDFN);
					  if(val_type((SYF_BEFPNT->BETYP + type -1)->NAME) !=-1)
					  expr1.TYPE = chktab(hshtab,namealloc("bit"),SYF_MODNAM,SYF_TYPDFN);
					  else
				      expr1.TYPE = type;
              if(syf_y_vsp[0].name.FLAG == 'X')
                        {
                        expr1 = syf_crtabl (NOPI,expr1,SYF_EMPSTR,left,right);  
                        syf_y_val.list    = syf_crtabl (STABLE,expr1,SYF_EMPSTR,left,right);   
                        }
		  else
                  syf_y_val.list = syf_crtabl (NOPI,expr1,SYF_EMPSTR,left,right);
                  }
                else
                  {
                 expr1.IDENT = (char *)chktab(hshtab,syf_y_vsp[0].name.NAME,NULL,SYF_PNTDFN);
		 expr1.TYPE =(int)-1;/*dec, cast int */
                  syf_y_val.list = syf_crtabl (NOPS,expr1,SYF_EMPSTR,in_bound,out_bound);
                  }
		 }
                ;
    break;}
case 172:
#line 1821 "bvl_bcomp.yac"
{ syf_y_val.valu = EQ; ;
    break;}
case 173:
#line 1823 "bvl_bcomp.yac"
{ syf_y_val.valu = NE; ;
    break;}
case 174:
#line 1825 "bvl_bcomp.yac"
{ syf_y_val.valu = GE; ;
    break;}
case 175:
#line 1827 "bvl_bcomp.yac"
{ syf_y_val.valu = GT; ;
    break;}
case 176:
#line 1829 "bvl_bcomp.yac"
{ syf_y_val.valu = LE; ;
    break;}
case 177:
#line 1831 "bvl_bcomp.yac"
{ syf_y_val.valu = LT; ;
    break;}
case 178:
#line 1836 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 179:
#line 1838 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 180:
#line 1840 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 181:
#line 1847 "bvl_bcomp.yac"
{ syf_y_val.list = syf_y_vsp[-1].list; ;
    break;}
case 182:
#line 1852 "bvl_bcomp.yac"
{
                syf_y_val.name.NAME  = syf_y_vsp[0].text;
                syf_y_val.name.TYPE  = chktab (hshtab,syf_y_vsp[0].text,SYF_MODNAM,SYF_TYPDFN);
              	syf_y_val.name.LEFT  = chktab (hshtab,syf_y_vsp[0].text,SYF_MODNAM,SYF_WMNDFN);
                syf_y_val.name.RIGHT = chktab (hshtab,syf_y_vsp[0].text,SYF_MODNAM,SYF_WMXDFN);
                ;
    break;}
case 183:
#line 1859 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name; ;
    break;}
case 184:
#line 1861 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name; ;
    break;}
case 185:
#line 1863 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name; ;
    break;}
case 186:
#line 1871 "bvl_bcomp.yac"
{
                syf_y_val.name.NAME  = syf_y_vsp[-3].text;
                syf_y_val.name.LEFT  = syf_y_vsp[-1].valu;
                syf_y_val.name.TYPE  = chktab (hshtab,syf_y_vsp[-3].text,SYF_MODNAM,SYF_TYPDFN);
                syf_y_val.name.RIGHT = syf_y_vsp[-1].valu;
                ;
    break;}
case 187:
#line 1886 "bvl_bcomp.yac"
{
                if (((syf_y_vsp[-3].valu > syf_y_vsp[-1].valu) && (syf_y_vsp[-2].valu == SYF_UPTDFN)) ||
                    ((syf_y_vsp[-3].valu < syf_y_vsp[-1].valu) && (syf_y_vsp[-2].valu == SYF_DWTDFN)))
                  syf_error (32,syf_y_vsp[-5].text);
 
                syf_y_val.name.NAME  = syf_y_vsp[-5].text;
                syf_y_val.name.TYPE  = chktab (hshtab,syf_y_vsp[-5].text,SYF_MODNAM,SYF_TYPDFN);
                syf_y_val.name.LEFT  = syf_y_vsp[-3].valu;
                syf_y_val.name.RIGHT = syf_y_vsp[-1].valu;
                ;
    break;}
case 188:
#line 1902 "bvl_bcomp.yac"
{
                char             extname[100];
                char            *lclname;
                int              sig_conf;
                int              type;
                int              kind;
                struct syf_expr  expr1;
                struct syf_expr  expr2;
                struct chain    *ptabl;
 
                sprintf (extname,"%s'delayed",syf_y_vsp[-2].text);
                lclname = namealloc (extname);

                if (chktab (hshtab,lclname,SYF_MODNAM,SYF_SIGDFN) == 0 )
                {
                sig_conf = chktab (hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_SIGDFN);
                type = chktab (hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_TYPDFN);
                kind = chktab (hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_LBLDFN);
                switch (sig_conf)
                  {
                  case SYF_ICNDFN : 
                  case SYF_BCNDFN : 
                    break;
                  default :
                    syf_error (79,syf_y_vsp[-2].text);
                  } 
 
                if (chktab (hshtab,syf_y_vsp[-2].text,SYF_MODNAM,SYF_WMNDFN) != -1)
                  syf_error (79,syf_y_vsp[-2].text);

                if (chktab (hshtab,namealloc("bit"),SYF_MODNAM,SYF_TYPDFN) != type)
                  syf_error (79,syf_y_vsp[-2].text);
 
 
                if (SYF_ERRFLG == 0)
                  {
                    expr1.IDENT = syf_y_vsp[-2].text;
                    expr1.WIDTH  = 1;
                    expr2 = syf_crtabl (NOPI,expr1,SYF_EMPSTR,-1,-1);
                    ptabl = (struct chain*)expr2.LIST_ABL->DATA;
                    SYF_BEFPNT->BEDLY = syf_beh_addbeaux(SYF_BEFPNT->BEDLY,lclname,
                                                     ptabl,NULL);
                    addtab (hshtab,lclname,SYF_MODNAM,SYF_WMNDFN,-1);
                    addtab (hshtab,lclname,SYF_MODNAM,SYF_WMXDFN,-1);
                    addtab (hshtab,lclname,SYF_MODNAM,SYF_SIGDFN, SYF_STBDFN);
                    addtab (hshtab,lclname,SYF_MODNAM,SYF_TYPDFN, type);
                    addtab (hshtab,lclname,SYF_MODNAM,SYF_LBLDFN, kind);
                    }
                 }
                syf_y_val.name.NAME = syf_y_vsp[-2].text;
                syf_y_val.name.LEFT = -1;
                syf_y_val.name.RIGHT = -1;
                syf_y_val.name.FLAG  = 'X';
 
                ;
    break;}
case 190:
#line 1965 "bvl_bcomp.yac"
{ SYF_NM1LST = addchain (SYF_NM1LST,syf_y_vsp[0].text); ;
    break;}
case 193:
#line 1974 "bvl_bcomp.yac"
{ SYF_NM1LST = addchain (SYF_NM1LST,syf_y_vsp[0].text); ;
    break;}
case 194:
#line 1979 "bvl_bcomp.yac"
{ syf_y_val.text = NULL; ;
    break;}
case 195:
#line 1981 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 196:
#line 1986 "bvl_bcomp.yac"
{ syf_y_val.text = NULL; ;
    break;}
case 197:
#line 1988 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 198:
#line 1993 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 199:
#line 1998 "bvl_bcomp.yac"
{ syf_y_val.name = syf_y_vsp[0].name; ;
    break;}
case 200:
#line 2004 "bvl_bcomp.yac"
{
                SYF_LBLNAM = syf_y_vsp[-1].text;
                syf_y_val.text = syf_y_vsp[-1].text;
                ;
    break;}
case 201:
#line 2012 "bvl_bcomp.yac"
{ syf_y_val.text = syf_y_vsp[0].text; ;
    break;}
case 202:
#line 2017 "bvl_bcomp.yac"
{ syf_y_val.valu = atoi(syf_y_vsp[0].text); ;
    break;}
case 203:
#line 2022 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
case 204:
#line 2027 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
case 205:
#line 2032 "bvl_bcomp.yac"
{ syf_y_errok; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 442 "/labo/gnu/lib/bison.simple"

  syf_y_vsp -= syf_y_len;
  syf_y_ssp -= syf_y_len;
#ifdef SYF_Y_LSP_NEEDED
  syf_y_lsp -= syf_y_len;
#endif

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    {
      short *ssp1 = syf_y_ss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != syf_y_ssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++syf_y_vsp = syf_y_val;

#ifdef SYF_Y_LSP_NEEDED
  syf_y_lsp++;
  if (syf_y_len == 0)
    {
      syf_y_lsp->first_line = syf_y_lloc.first_line;
      syf_y_lsp->first_column = syf_y_lloc.first_column;
      syf_y_lsp->last_line = (syf_y_lsp-1)->last_line;
      syf_y_lsp->last_column = (syf_y_lsp-1)->last_column;
      syf_y_lsp->text = 0;
    }
  else
    {
      syf_y_lsp->last_line = (syf_y_lsp+syf_y_len-1)->last_line;
      syf_y_lsp->last_column = (syf_y_lsp+syf_y_len-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  syf_y_n = syf_y_r1[syf_y_n];

  syf_y_state = syf_y_pgoto[syf_y_n - SYF_Y_NTBASE] + *syf_y_ssp;
  if (syf_y_state >= 0 && syf_y_state <= SYF_Y_LAST && syf_y_check[syf_y_state] == *syf_y_ssp)
    syf_y_state = syf_y_table[syf_y_state];
  else
    syf_y_state = syf_y_defgoto[syf_y_n - SYF_Y_NTBASE];

  goto syf_y_newstate;

syf_y_errlab:   /* here on detecting error */

  if (! syf_y_errstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++syf_y_nerrs;

#ifdef SYF_Y_ERROR_VERBOSE
      syf_y_n = syf_y_pact[syf_y_state];

      if (syf_y_n > SYF_Y_FLAG && syf_y_n < SYF_Y_LAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(syf_y_tname) / sizeof(char *)); x++)
	    if (syf_y_check[x + syf_y_n] == x)
	      size += strlen(syf_y_tname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = 0; x < (sizeof(syf_y_tname) / sizeof(char *)); x++)
		    if (syf_y_check[x + syf_y_n] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, syf_y_tname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      syf_y_error(msg);
	      free(msg);
	    }
	  else
	    syf_y_error ("parse error; also virtual memory exceeded");
	}
      else
#endif /* SYF_Y_ERROR_VERBOSE */
	syf_y_error("parse error");
    }

  goto syf_y_errlab1;
syf_y_errlab1:   /* here on error raised explicitly by an action */

  if (syf_y_errstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (syf_y_char == SYF_Y_EOF)
	SYF_Y_ABORT;

#if SYF_Y_DEBUG != 0
      if (syf_y_debug)
	fprintf(stderr, "Discarding token %d (%s).\n", syf_y_char, syf_y_tname[syf_y_char1]);
#endif

      syf_y_char = SYF_Y_EMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  syf_y_errstatus = 3;		/* Each real token shifted decrements this */

  goto syf_y_errhandle;

syf_y_errdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  syf_y_n = syf_y_defact[syf_y_state];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (syf_y_n) goto syf_y_default;
#endif

syf_y_errpop:   /* pop the current state because it cannot handle the error token */

  if (syf_y_ssp == syf_y_ss) SYF_Y_ABORT;
  syf_y_vsp--;
  syf_y_state = *--syf_y_ssp;
#ifdef SYF_Y_LSP_NEEDED
  syf_y_lsp--;
#endif

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    {
      short *ssp1 = syf_y_ss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != syf_y_ssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

syf_y_errhandle:

  syf_y_n = syf_y_pact[syf_y_state];
  if (syf_y_n == SYF_Y_FLAG)
    goto syf_y_errdefault;

  syf_y_n += SYF_Y_TERROR;
  if (syf_y_n < 0 || syf_y_n > SYF_Y_LAST || syf_y_check[syf_y_n] != SYF_Y_TERROR)
    goto syf_y_errdefault;

  syf_y_n = syf_y_table[syf_y_n];
  if (syf_y_n < 0)
    {
      if (syf_y_n == SYF_Y_FLAG)
	goto syf_y_errpop;
      syf_y_n = -syf_y_n;
      goto syf_y_reduce;
    }
  else if (syf_y_n == 0)
    goto syf_y_errpop;

  if (syf_y_n == SYF_Y_FINAL)
    SYF_Y_ACCEPT;

#if SYF_Y_DEBUG != 0
  if (syf_y_debug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++syf_y_vsp = syf_y_lval;
#ifdef SYF_Y_LSP_NEEDED
  *++syf_y_lsp = syf_y_lloc;
#endif

  syf_y_state = syf_y_n;
  goto syf_y_newstate;
}
#line 2034 "bvl_bcomp.yac"

static struct dct_entry *addent (head , key)
struct dct_entry *head;
char             *key;

  {
  struct dct_entry *entry;
  int              i;

  if (SYF_DCEHED == NULL)
    {
    SYF_DCEHED = (struct dct_entry *)
                 mbkalloc (sizeof(struct dct_entry) * SYF_ALODFN);

    entry = SYF_DCEHED;
    for (i=1 ; i<SYF_ALODFN ; i++)
      {
      entry->next = entry + 1;
      entry++;
      }
    entry->next = NULL;
    }

  entry       = SYF_DCEHED;
  SYF_DCEHED  = SYF_DCEHED->next;

  entry->next = head;
  entry->data = NULL;
  entry->key  = key;

  return (entry);
  }

static struct dct_recrd *addrcd (head , key)

struct dct_recrd *head;
char             *key;

  {
  struct dct_recrd *recrd;
  int               i;

  if (SYF_DCRHED == NULL)
    {
    SYF_DCRHED = (struct dct_recrd *)
                 mbkalloc (sizeof(struct dct_recrd) * SYF_ALODFN);

    recrd = SYF_DCRHED;
    for (i=1 ; i<SYF_ALODFN ; i++)
      {
      recrd->next = recrd + 1;
      recrd++;
      }
    recrd->next = NULL;
    }

  recrd           = SYF_DCRHED;
  SYF_DCRHED      = SYF_DCRHED->next;

  recrd->next     = head;
  recrd->fd0_val  = 0;
  recrd->fd1_val  = 0;
  recrd->fd2_val  = 0;
  recrd->fd3_val  = 0;
  recrd->fd4_val  = 0;
  recrd->fd5_val  = 0;
  recrd->fd6_val  = 0;
  recrd->pnt_val  = 0;
  recrd->key      = key;

  return (recrd);
  }

static struct dct_entry **initab ()

  {
  struct dct_entry **head;
  int                i;

  head = (struct dct_entry **)
         mbkalloc (sizeof(struct dct_entry *) * SYF_HSZDFN);

  for (i=0 ; i<SYF_HSZDFN ; i++)
    head[i] = NULL;

  return (head);
  }

static void addtab (head,key_str,ctx_str,field,valu)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
int                field;
int                valu;

  {
  int               found = 0;
  int               index;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  index     = (int) key_str % SYF_HSZDFN;
  entry_pnt = head[index];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 0)
    {
    head[index] = addent (head[index],key_str); 
    entry_pnt = head[index]; 
    }

  found = 0;
  recrd_pnt = entry_pnt->data;
  while (recrd_pnt != NULL)
    {
    if (recrd_pnt->key == ctx_str)
      {
      found = 1;
      break;
      }
    recrd_pnt = recrd_pnt->next;
    }

  if (found == 0)
    {
    entry_pnt->data = addrcd (entry_pnt->data,ctx_str); 
    recrd_pnt       = entry_pnt->data ;
    }

  switch (field)
    {
    case 0 :
      recrd_pnt->fd0_val = valu;
      break;
    case 1 :
      recrd_pnt->fd1_val = valu;
      break;
    case 2 :
      recrd_pnt->fd2_val = valu;
      break;
    case 3 :
      recrd_pnt->fd3_val = valu;
      break;
    case 4 :
      recrd_pnt->fd4_val = valu;
      break;
    case 5 :
      recrd_pnt->fd5_val = valu;
      break;
    case 6 :
      recrd_pnt->fd6_val = valu;
      break;
    case 7 :
      recrd_pnt->pnt_val = valu;
      break;
    }

  }

static int chktab (head,key_str,ctx_str,field)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
int                field;

  {
  int               found = 0;
  int               valu = 0;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  entry_pnt = head [(int)key_str % SYF_HSZDFN];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 1)
    {
    found = 0;
    recrd_pnt = entry_pnt->data;
    while (recrd_pnt != NULL)
      {
      if (recrd_pnt->key == ctx_str)
        {
        found = 1;
        break;
        }
      recrd_pnt = recrd_pnt->next;
      }
    if (found == 1)
      {
      switch (field)
        {
        case 0 :
          valu = recrd_pnt->fd0_val;
          break;
        case 1 :
          valu = recrd_pnt->fd1_val;
          break;
        case 2 :
          valu = recrd_pnt->fd2_val;
          break;
        case 3 :
          valu = recrd_pnt->fd3_val;
          break;
        case 4 :
          valu = recrd_pnt->fd4_val;
          break;
        case 5 :
          valu = recrd_pnt->fd5_val;
          break;
        case 6 :
          valu = recrd_pnt->fd6_val;
          break;
        case 7 :
          valu = recrd_pnt->pnt_val;
          break;
        }
      }
    }

  return (valu);
  }

static void fretab (pt_hash)

struct dct_entry **pt_hash;
  {
  struct dct_entry *pt_entry;
  struct dct_entry *pt_nxtentry;
  struct dct_recrd *pt_record;
  int               i;

  if (pt_hash != NULL)
    {
    for (i=0 ; i<SYF_HSZDFN ; i++)
      {
      if ((pt_entry = pt_hash[i]) != NULL)
        {
        while (pt_entry != NULL)
          {
          pt_record = pt_entry->data;

          while (pt_record->next != NULL)
            pt_record = pt_record->next;

          pt_record->next = SYF_DCRHED;
          SYF_DCRHED      = pt_entry->data;

          pt_nxtentry     = pt_entry->next;
          pt_entry->next  = SYF_DCEHED;
          SYF_DCEHED      = pt_entry;
          pt_entry        = pt_nxtentry;
          }
        }
      }
    free (pt_hash);
    }
  }

void *syf_addstr (ptfig,object,mode,prtype,type,flag,name,left,right)

struct syf_befig *ptfig;
char          object;
int           mode;
int           prtype;
unsigned char type;
char          flag;
char         *name;
short         left;
short         right;

  {
  void  *pnt    = NULL;
  char   porflg = 0;
  char   rinflg = 0;
  char   outflg = 0;
  char   busflg = 0;
  char   auxflg = 0;
  char   buxflg = 0;
  char   regflg = 0;
  char   lclmod;
  char   lcltyp;
  char   extname[100];
  short  i;
  short  inc = 1;

  switch (object)
    {
    case 'P':

	/* ###------------------------------------------------------### */
	/*   if object is a port ...					*/
	/* ###------------------------------------------------------### */

      porflg = 1;
      switch (mode)
        {
        case SYF_ICNDFN:
          lclmod = 'I'; lcltyp = type ; rinflg = 1; break;
        case SYF_OCNDFN:
          switch (prtype)
            {
            case BIT :
              lclmod = 'O'; lcltyp = type ; outflg = 1; break;
            case MUX_BIT :
              lclmod = 'Z'; lcltyp = type; busflg = 1; break;
            case WOR_BIT :
              lclmod = 'Z'; lcltyp = type; busflg = 1; break;
            }
          break;
        case SYF_BCNDFN:
          rinflg = 1;
          switch (prtype)
            {
            case BIT:
              lclmod = 'B'; lcltyp = type; outflg = 1; rinflg =1;break;
            case MUX_BIT:
              lclmod = 'T'; lcltyp = type; busflg = 1;rinflg =1; break;
            case WOR_BIT:
              lclmod = 'T'; lcltyp = type; busflg = 1; rinflg =1;break;
            }
          break;
        }
      break;

    case 'S':

	/* ###------------------------------------------------------### */
	/*   if object is a signal ...					*/
	/* ###------------------------------------------------------### */

      switch (prtype)
        {
        case BIT:
          lcltyp = type; auxflg = 1; break;
        case REG_BIT :
          rinflg = 1; regflg = 1; break;
        case MUX_BIT :
          lcltyp = type; rinflg = 1; buxflg = 1; break;
        case WOR_BIT :
          lcltyp = type; rinflg = 1; buxflg = 1; break;
	default : lcltyp = type ; auxflg =1;break;
        }
      break;
    }

  if (flag == 'A' || flag == 'U')
    {
	/* ###------------------------------------------------------### */
	/*   if object is an array ...					*/
	/* ###------------------------------------------------------### */

    if (left >= right)
      inc = -1;

    for (i=left ; i!=(right+inc) ; i+=inc)
      {
      sprintf (extname,"%s %d",name,i);

      if (porflg == 1)
        ptfig->BEPOR = syf_beh_addbepor (ptfig->BEPOR,extname,lclmod,lcltyp);
      if (rinflg == 1)
        ptfig->BERIN = syf_beh_addberin (ptfig->BERIN,extname);
      if (outflg == 1)
        ptfig->BEOUT = syf_beh_addbeout (ptfig->BEOUT,extname,NULL,NULL,lcltyp);
      if (busflg == 1)
        ptfig->BEBUS = syf_beh_addbebus (ptfig->BEBUS,extname,NULL,NULL,lcltyp);
      if (auxflg == 1)
        ptfig->BEAUX = syf_beh_addbeaux (ptfig->BEAUX,extname,NULL,NULL,lcltyp);
      if (buxflg == 1)
        ptfig->BEBUX = syf_beh_addbebux (ptfig->BEBUX,extname,NULL,NULL,lcltyp);
      if (regflg == 1)
        ptfig->BEREG = syf_beh_addbereg (ptfig->BEREG,extname,NULL,NULL);
      }
    }
  else
    {
	/* ###------------------------------------------------------### */
	/*   if object is a scalar ...					*/
	/* ###------------------------------------------------------### */

    if (porflg == 1)
      ptfig->BEPOR = syf_beh_addbepor (ptfig->BEPOR,name,lclmod,lcltyp);
    if (rinflg == 1)
      ptfig->BERIN = syf_beh_addberin (ptfig->BERIN,name);
    if (outflg == 1)
      ptfig->BEOUT = syf_beh_addbeout (ptfig->BEOUT,name,NULL,NULL,lcltyp);
    if (busflg == 1)
      ptfig->BEBUS = syf_beh_addbebus (ptfig->BEBUS,name,NULL,NULL,lcltyp);
    if (auxflg == 1)
      ptfig->BEAUX = syf_beh_addbeaux (ptfig->BEAUX,name,NULL,NULL,lcltyp);
    if (buxflg == 1)
      ptfig->BEBUX = syf_beh_addbebux (ptfig->BEBUX,name,NULL,NULL,lcltyp);
    if (regflg == 1)
      ptfig->BEREG = syf_beh_addbereg (ptfig->BEREG,name,NULL,NULL);

    }

  if (outflg == 1)
    pnt = (void *) ptfig->BEOUT;
  if (busflg == 1)
    pnt = (void *) ptfig->BEBUS;
  if (auxflg == 1)
    pnt = (void *) ptfig->BEAUX;
  if (buxflg == 1)
    pnt = (void *) ptfig->BEBUX;
  if (regflg == 1)
    pnt = (void *) ptfig->BEREG;

  return (pnt);
  }

int syf_chkdcl (object,mode,type,flag,kind,constraint)

char object;
int  mode;
int  type;
char flag;
int  kind;
char constraint;

  {
  int errflg = 0;

  if (flag != constraint && constraint !='U'  && flag !='U')
    {
    errflg = 1;
    syf_error (33,NULL);
    }
  else
    {
    switch (object)
      {
      case 'P':
	/* ###------------------------------------------------------### */
	/*    If object is a port :					*/
	/*       - if type is bit, no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT :

            switch (mode)
              {
              case 0 :
                errflg = 1; break;
              }
            if (kind != 0)
              errflg = 1;
            break;

          case MUX_BIT :

            switch (mode)
              {
              case SYF_ICNDFN :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case WOR_BIT :

            switch (mode)
              {
              case SYF_ICNDFN :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case REG_BIT :
          case NATURAL:

            errflg = 1;
            break;
          }
        if (errflg == 1)
          syf_error (5,NULL);
        break;

      case 'G':
	/* ###------------------------------------------------------### */
	/*    If object is a generic :					*/
	/*       - only natural type is allowed				*/
	/* ###------------------------------------------------------### */

        if ((type != NATURAL) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          syf_error (77,NULL);
          }
        break;

      case 'S':
	/* ###------------------------------------------------------### */
	/*    If object is a signal :					*/
	/*       - no mode can be specified				*/
	/*       - if type is bit no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - if type is reg_bit, register kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

       /* switch (type)
          {
          case BIT:
            if ((mode != 0) || (kind != 0))
              errflg = 1;
            break;
          case MUX_BIT :
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case WOR_BIT :
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case REG_BIT :
            if ((mode != 0) || (kind != REG_BIT))
              errflg = 1;
            break;
          case NATURAL :
            errflg = 1; break;
          }*/
	 if(type !=-1)
          	errflg = 1;
        if (mode != 0)
            errflg = 1;

        if (errflg == 1)
          syf_error (11,NULL);
        break;

      case 'C':
	/* ###------------------------------------------------------### */
	/*    If object is a constant :					*/
	/*       - only bit type without any other indication is legal	*/
	/* ###------------------------------------------------------### */

        if ((type != BIT) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          syf_error (78,NULL);
          }
        break;
      }
    }

  return (errflg);
  }

  display_beh(ptyp)
  struct ptype *ptyp;
	{
	  int i;
	 struct syf_beifs *beifs;
	 struct syf_becas *becas;
	 struct syf_beasg *beasg;

	while(ptyp)
	{	
  	 switch(ptyp->TYPE)
	  {
		
	   case BEH_BEIFS : printf("\n if ");
		   	  beifs = (struct syf_beifs *) ptyp->DATA;
		          displayExpr(beifs->CND);
			 	printf("\nthen \n"); 
		          display_beh(beifs->CNDTRUE);
			  if (beifs->CNDFALSE)
				{
			 	printf("else"); 
				display_beh(beifs->CNDFALSE);
			  	}
			  else
				printf("\nEND IF \n");
		  	  break;
	   case BEH_BEASG  : beasg = (struct syf_beasg*) ptyp->DATA;
			 printf("\n%s <= ",beasg->NAME);
			 displayExpr(beasg->ABL);
			 break;
  	  case BEH_BECAS   : becas = (struct syf_becas*) ptyp->DATA; 
			 printf("case  ");
			 displayExpr(becas->ABL); 
			 printf("is   ");
			 printf("size =%d \n",becas->SIZE);
				for(i= 0;  i < (int)becas->SIZE; i++)
				{
			 printf("WHEN %s = %d  \n",becas->CHOICE[i].VALUE,syf_bintonum((becas->CHOICE[i]).VALUE));
			      display_beh((becas->CHOICE[i]).INSTRUCTION);
				printf("END CASE\n") ;
				}
			 break;
  	  case BEH_BEMSG   : break;
	  default        : printf("illegal ptype \n");
	  }
		ptyp = ptyp->NEXT;
	}
	}

 int val_type(name)
 char *name;
 {

    if(!name)
	   return(-1);
	if (!strcmp(name,"boolean"))
             return(BOOLEAN);	
	if (!strcmp(name,"bit"))
             return(BIT);	
	if (!strcmp(name,"mux_bit"))
             return(MUX_BIT);	
	if (!strcmp(name,"wor_bit"))
             return(WOR_BIT);	
	if (!strcmp(name,"reg_bit"))
             return(REG_BIT);	
	if (!strcmp(name,"bit_vector"))
             return(BIT);	
	if (!strcmp(name,"mux_vector"))
             return(MUX_BIT);	
	if (!strcmp(name,"wor_vector"))
             return(WOR_BIT);	
	if (!strcmp(name,"reg_vector"))
             return(REG_BIT);	
	if (!strcmp(name,"integer"))
             return(INTEGER);	
	if (!strcmp(name,"natural"))
             return(NATURAL);	
	return(-1);
 }
 struct ptype *reversetype(pnt)
 struct ptype *pnt;
  {
    struct ptype* revtype;
    struct ptype* aux2;
    struct ptype* aux1;

    if(pnt == NULL || pnt->NEXT == NULL)
	return(pnt);
			revtype = pnt;
		     aux1 = pnt->NEXT;		
		     revtype->NEXT = NULL;	
		  while(aux1)
		   {
		     aux2 = revtype;	
		     revtype = aux1;
		     aux1 = aux1->NEXT;		
		     revtype->NEXT = aux2;	
		   }
	return(revtype);
 }
	
 struct choice_chain *addchoice(lastpnt,type,val,size)
 struct choice_chain *lastpnt;
 struct ptype *type;
 char    *val;
 unsigned int size;
 {
    struct choice_chain *pnt;	

    pnt = (struct choice_chain*)mbkalloc(sizeof(struct choice_chain));
    pnt->VALUE = val;
    pnt->SIZE = size;
    pnt->INSTRUCTION  = type;
    pnt->NEXT   = lastpnt;
	return(pnt);
 }

 struct choice_chain *order_choice(pnt,type,val,size)
 struct choice_chain *pnt;
 struct ptype *type;
 char    *val;
 unsigned int size;
 {
    struct choice_chain *aux1;
    struct choice_chain *aux2;
   
      if(!pnt)
	{
    	 	aux1 = addchoice (pnt,type,val,size);
		return(aux1);
	}

	 if(strcmp(pnt->VALUE,val)>0) 
		{
	  aux1 =addchoice(pnt,type,val,size);
               return(aux1);
		}
	
    aux1 =pnt; 
    aux2 =pnt->NEXT; 
	while(aux2)
	{
	 if(strcmp(aux2->VALUE, val)>0) 
	  {
    	 	aux2 = addchoice (aux2,type,val,size);
		aux1->NEXT = aux2;
		return(pnt);
  	  }
	 aux1 = aux2;
	 aux2 = aux2->NEXT;
	}
    	 	aux2 = addchoice (aux2,type,val,size);
		aux1->NEXT = aux2;
		return(pnt);
 } 
          
