/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                   Color.h                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  01.08.93                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef DREAL_COLOR
# define DREAL_COLOR

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                             Pattern                         |
|                                                             |
\------------------------------------------------------------*/

# define DREAL_PATTERN_WIDTH    16
# define DREAL_PATTERN_HEIGHT   16
# define DREAL_PATTERN_SQUARE   32
# define DREAL_MAX_PATTERN      10

# define DREAL_MAX_COLOR        ( RDS_MAX_LAYER + 6 )

# define DREAL_LARGE_TEXT_FONT_NAME   "9x15"
# define DREAL_MEDIUM_TEXT_FONT_NAME  "7x13"
# define DREAL_SMALL_TEXT_FONT_NAME   "5x8"

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void DrealInitializeGraphicContext();
  extern void DrealInitializeColors();

# endif 
