

/*          Alliance CAD System 3.0                                         */
/*             FpGen Package 1.05                                           */
/*                                                                          */
/*  Copyright(c) 93-95, MASI, CAO-VLSI Team                                 */
/*                                                                          */
/*  Author      :          Jean-Paul CHAPUT                                 */
/*  E-mail      :      cao-vlsi@masi.ibp.fr                                 */
/* ************************************************************************ */
/*  Module      :      "UtProto.c"                                          */


/* ******************************* Includes ******************************* */


#include  "UtBase.h"
#include  "UtProto.h"


/* ************************** Internal constants ************************** */


/* ********************* Internal Types And Structures ******************** */


/* Structure holding together all internal module global variables.
 */
static struct {
  long  ModuleId;          /* "UtProto.c" module identifier. */
  } GV;


/* ************************** Internal Variables ************************** */


/* ************************* Interface Functions ************************** */


/* ************************** Internal Functions ************************** */


/* ************************* Functions Definitions ************************ */


/*  Function  :  'UtPro_Init()'.                                            */
/* ------------------------------------------------------------------------ */
/*  Perform all initialisations neededs to use the functions of the utilies
 *  module :
 *       I - Load internal errors table.
 *      II - Load internal warnings table.
 */

extern void  UtPro_Init()
{
  static long  FirstCall    = TRUE;

  if (FirstCall == FALSE) return;
    FirstCall  = FALSE;

  /* Attribution of a module identifier. */
  GV.ModuleId = GfpUT_GetModuleId( "UtProto", F_GfpUT_ModuleAdd );
}


