

/* *************** Interface of Module "UtXlong" **************** */


#define    C_GfpUT_XLSIZE             4  /* 128 bits. */
#define    C_GfpUT_BaseOctal          3
#define    C_GfpUT_BaseBinary         1
#define    C_GfpUT_BaseHexadecimal    4


extern long  DP_LGSIZE;  /* Number of long used for a eXtended Long. */


#ifndef  ANSI_PROTO

extern void  UtXlg_Init();
extern long *GfpUT_XlAlloc();
extern void  GfpUT_XlSetLong();
extern void  GfpUT_XlFree();
extern long  GfpUT_XlGetBit();
extern long  GfpUT_XlStrCheck();
extern void  GfpUT_XlStrToXl();
extern char *GfpUT_XlToStr();
extern char *GfpUT_XlToStrVHDL();

#else

extern void  UtXlg_Init(void);
extern long *GfpUT_XlAlloc(void);
extern void  GfpUT_XlSetLong(long *aPtXlong, long  aLong, long  aValue);
extern void  GfpUT_XlFree(long *aPtXlong);
extern long  GfpUT_XlGetBit(long *aPtXlong, long  aBit);
extern long  GfpUT_XlStrCheck(char *aStringNumber);
extern void  GfpUT_XlStrToXl(char *aStringNumber, long *aPtXlong);
extern char *GfpUT_XlToStr(long *aPtXlong   ,
						   long  aConstWidth,
						   long  aBaseValue );
extern char *GfpUT_XlToStrVHDL(long *aPtXlong, long  aConstWidth);

#endif
