

/* *************** Interface of Module "UtMBKLo" **************** */


#define    C_GfpUT_ImplicitConNoIndex        -1
#define    C_GfpUT_TypeConImplicit            2
#define    C_GfpUT_TypeConVdd                 3
#define    C_GfpUT_TypeConVss                 4
#define    C_GfpUT_TypeConNormal              5
#define    C_GfpUT_IdxTypeUnknow              6
#define    C_GfpUT_IdxTypeDefault             7
#define    C_GfpUT_IdxTypeScalar              8
#define    C_GfpUT_IdxTypeBus                 9
#define    C_GfpUT_SigTypeUnknow             10
#define    C_GfpUT_SigTypeScalar             11
#define    C_GfpUT_SigTypeBusPin             12
#define    C_GfpUT_SigTypeBus                13
#define    C_SUPP_MBKNOCAPA                   0.0


extern char  DP_SEPAR;
extern char  DP_IC[C_SUPP_MaxLenString];


/* #ifdef  DEF_LOFIG
 * #undef  DEF_LOFIG
 * #endif
 */

/* 'mbkenv' reset the trap function for SIGTERM, and 'DEF_LOFIG' always
 * call 'mbkenv'. The probleme is when the user have defined previously
 * a trap function for SIGTERM. In order to preserve the first trap
 * function, we use this very dirty patch.
 */
/* #define  DEF_LOFIG( aModelName )                   \
 *          {                                         \
 *            void (*TrapFunc)();                     \
 *                                                    \
 *                                                    \
 *            TrapFunc = signal( SIGTERM, SIG_DFL );  \
 *                                                    \
 *            genDEF_LOFIG( aModelName );             \
 *                                                    \
 *            signal( SIGTERM, TrapFunc );            \
 *          }
 */


/* #ifdef  DEF_PHFIG
 * #undef  DEF_PHFIG
 * #endif
 * 
 * #define  DEF_PHFIG( aModelName )                   \
 *          {                                         \
 *            void (*TrapFunc)();                     \
 *                                                    \
 *                                                    \
 *            TrapFunc = signal( SIGTERM, SIG_DFL );  \
 *                                                    \
 *            genDEF_PHFIG( aModelName );             \
 *                                                    \
 *            signal( SIGTERM, TrapFunc );            \
 *          }
 */


#ifndef  ANSI_PROTO

extern       void  UtMLo_Init();
extern       char *GfpUT_ConcatName();
extern       char *GfpUT_CheckName();
extern       long  GfpUT_IsDecimalNumber();
extern       long  GfpUT_StrIndexDecod();
extern       long  GfpUT_StrSigDecod();
extern       char *GfpUT_DecodMBKSigName();
extern       char *GfpUT_MakeImplicitConName();
extern       long  GfpUT_TypeConName();
#ifdef  MLO
extern locon_list *Dut_GetLoConBySig();
extern locon_list *GfpUT_AddLoConEnd();
#endif

#else

extern       void  UtMLo_Init(void);
extern       char *GfpUT_ConcatName(char *aName1, char *aName2);
extern       char *GfpUT_CheckName(char *pin_name);
extern       long  GfpUT_IsDecimalNumber(char *aStr);
extern       long  GfpUT_StrIndexDecod(char *aStr,
                                       long *aPtOrig,
                                       long *aPtExtr);
extern       long  GfpUT_StrSigDecod(char *aStr,
                                     char *aRoot,
                                     char *aPtOrig,
                                     char *aPtExtr);
extern       char *GfpUT_DecodMBKSigName(char *aMBKSigName, long *aPtSigIndex);
extern       char *GfpUT_MakeImplicitConName(char *aInstName,
											 char *aConName ,
											 long  aIndex   );
extern       long  GfpUT_TypeConName(char *aConName);
#ifdef  MLO
extern locon_list *Dut_GetLoConBySig(lofig_list *aLoFig, losig_list *aLoSig);
extern locon_list *GfpUT_AddLoConEnd(locon_list *aLoFig,
											char *aName ,
									  losig_list *aLoSig,
											char  aDir  );
#endif

#endif
