/* main.c :
   this file belongs to the Alliance cad system sources.
   Written by Frederic Petrot. */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include MUT_H
#include "frin.h"

char buffer[BUFSIZ];

static void
   usage(s)
char *s;
{
   fprintf(stderr, "Usage : %s name \n", s);
   exit(1);
}

main(argc, argv)
int argc;
char **argv;
{
char *out, c;

   if (argc != 2)
      usage(argv[0]);

   mbkenv();
   alliancebanner("FRIn", "1.0", "Floorplan Router Input", "94, 95", ALC);
   buildchip(argv[1]);
   savechip();
   exit(0);
}
