/*------------------------------------------------------------\
|                                                             |
| Tool    :                   GRAAL                           |
|                                                             |
| File    :                  Setup.h                          |
|                                                             |
| Authors :      Venot Frederic and Jacomme Ludovic           |
|                                                             |
| Date    :                  01.08.93                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef GRAAL_SETUP
# define GRAAL_SETUP

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define GRAAL_TOPLEVEL_TRANSLATE_X        8
# define GRAAL_TOPLEVEL_TRANSLATE_Y       25
# define GRAAL_PANEL_TRANSLATE_X           0
# define GRAAL_PANEL_TRANSLATE_Y           0

# define GRAAL_TOPLEVEL_X                10
# define GRAAL_TOPLEVEL_Y                10
# define GRAAL_TOPLEVEL_WIDTH          1024
# define GRAAL_TOPLEVEL_HEIGHT          768

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void GraalDefaultConfig();
  extern void GraalSaveConfig();
  extern void GraalLoadConfig();

# endif 
