
/*  A Bison parser, made from mg2mbk.yac with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CELL	258
#define	PLACE	259
#define	TERMINAL	260
#define	RA	261
#define	STRETCH	262
#define	WIRE	263
#define	MWIDTH	264
#define	HORIZ	265
#define	VERTI	266
#define	MLEFT	267
#define	MRIGHT	268
#define	MTOP	269
#define	MBOTTOM	270
#define	AT	271
#define	MX	272
#define	MY	273
#define	R	274
#define	NTR	275
#define	PTR	276
#define	COP	277
#define	CON	278
#define	COPS	279
#define	COPW	280
#define	CONW	281
#define	PVIA	282
#define	CXN	283
#define	CXP	284
#define	STRING	285
#define	NUM	286

#line 7 "mg2mbk.yac"

#include <stdio.h>
#include <string.h>
#include MUT_H
#include MPH_H
#define MAXLAYER (LAST_LAYER + 1)

static phfig_list *mgleaf; /* modgen leaf cell parsed */
static char mbk_layer();
static char *checkinsname();
static char *checkconname();
static char *checkrefname();
static chain_list *pl;
static int Extension[MAXLAYER] = {
	/*	NWELL	 */ 0,
	/*	PWELL	 */ 0,
	/*	NTIE	 */ 1,
	/*	PTIE	 */ 1,
	/*	NDIF	 */ 1,
	/*	PDIF	 */ 1,
	/*	NTRANS */ 0, /* meant for N transistor grid */
	/*	PTRANS */ 0, /* meant for P transistor grid */
	/*	POLY	 */ 1,
	/*	ALU1	 */ 1,
	/*	ALU2	 */ 2,
	/*	ALU3	 */ 2,
	/*	TPOLY	 */ 1,
	/*	TALU1	 */ 1,
	/*	TALU2	 */ 2,
	/*	TALU3	 */ 2 };

#define O_PS_AA 1.5
#define O_AA_PS 2

#ifdef GRIDDED
#define TWO 2
#else
#define TWO 1
#endif

/* note :
   All STRINGs are allocated using mbkstrdup since the pointer to yytext
   will change when more than a STRING is used in the grammar.
   So all STRINGs are freed once used. */


#line 54 "mg2mbk.yac"
typedef union {
	char *s;
	long n;
	struct pxy {
		long x;
		long y;
	} *p;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		152
#define	YYFLAG		-32768
#define	YYNTBASE	39

#define YYTRANSLATE(x) ((unsigned)(x) <= 286 ? yytranslate[x] : 51)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    36,
    37,     2,     2,    38,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    35,     2,
    34,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    32,     2,    33,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,    13,    15,    18,    24,    35,    38,
    47,    61,    74,    75,    85,    97,   109,   115,   121,   127,
   133,   139,   145,   151,   157,   161,   163,   167,   169,   171,
   173,   175,   177,   179,   180,   182,   184,   187,   190,   194
};

static const short yyrhs[] = {    40,
     0,    41,     0,    40,    41,     0,     3,    30,    32,    42,
    33,     0,    43,     0,    43,    42,     0,     4,    30,    34,
    44,    35,     0,     4,    30,    34,    30,    50,    16,    36,
    46,    37,    35,     0,    44,    35,     0,     6,    36,    30,
    38,    46,    38,    46,    37,     0,     5,    30,    36,     9,
    34,    31,    37,    49,    30,    16,    36,    46,    37,     0,
     7,    36,    30,    38,    31,    38,    48,    38,    46,    38,
    46,    37,     0,     0,     8,    45,    36,    30,    38,    31,
    38,    47,    37,     0,    20,    36,    31,    38,    31,    37,
    50,    16,    36,    46,    37,     0,    21,    36,    31,    38,
    31,    37,    50,    16,    36,    46,    37,     0,    22,    16,
    36,    46,    37,     0,    23,    16,    36,    46,    37,     0,
    24,    16,    36,    46,    37,     0,    25,    16,    36,    46,
    37,     0,    26,    16,    36,    46,    37,     0,    27,    16,
    36,    46,    37,     0,    28,    16,    36,    46,    37,     0,
    29,    16,    36,    46,    37,     0,    31,    38,    31,     0,
    46,     0,    46,    38,    47,     0,    10,     0,    11,     0,
    12,     0,    13,     0,    15,     0,    14,     0,     0,    17,
     0,    18,     0,    17,    18,     0,    19,    31,     0,    17,
    19,    31,     0,    18,    19,    31,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   103,   106,   107,   110,   116,   117,   120,   124,   134,   137,
   148,   158,   185,   185,   231,   261,   291,   296,   301,   306,
   311,   316,   321,   326,   333,   344,   348,   354,   355,   358,
   359,   360,   361,   364,   365,   367,   369,   371,   378,   385
};

static const char * const yytname[] = {   "$","error","$illegal.","CELL","PLACE",
"TERMINAL","RA","STRETCH","WIRE","MWIDTH","HORIZ","VERTI","MLEFT","MRIGHT","MTOP",
"MBOTTOM","AT","MX","MY","R","NTR","PTR","COP","CON","COPS","COPW","CONW","PVIA",
"CXN","CXP","STRING","NUM","'{'","'}'","'='","';'","'('","')'","','","design",
"cells","leafcell","lines","line","elm","@1","point","point_list","dir","face",
"op",""
};
#endif

static const short yyr1[] = {     0,
    39,    40,    40,    41,    42,    42,    43,    43,    43,    44,
    44,    44,    45,    44,    44,    44,    44,    44,    44,    44,
    44,    44,    44,    44,    46,    47,    47,    48,    48,    49,
    49,    49,    49,    50,    50,    50,    50,    50,    50,    50
};

static const short yyr2[] = {     0,
     1,     1,     2,     5,     1,     2,     5,    10,     2,     8,
    13,    12,     0,     9,    11,    11,     5,     5,     5,     5,
     5,     5,     5,     5,     3,     1,     3,     1,     1,     1,
     1,     1,     1,     0,     1,     1,     2,     2,     3,     3
};

static const short yydefact[] = {     0,
     0,     1,     2,     0,     3,     0,     0,     0,     0,     0,
    13,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     5,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     4,
     6,     9,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    34,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    35,    36,     0,     0,     7,     0,
     0,     0,     0,     0,     0,     0,    17,    18,    19,    20,
    21,    22,    23,    24,    37,     0,     0,    38,     0,     0,
     0,     0,     0,    34,    34,    25,    39,    40,     0,     0,
     0,    28,    29,     0,     0,     0,     0,     0,    30,    31,
    33,    32,     0,    10,     0,    26,     0,     0,     0,     0,
     0,     0,     0,    14,     0,     0,     8,     0,     0,    27,
     0,     0,     0,     0,    15,    16,     0,    12,    11,     0,
     0,     0
};

static const short yydefgoto[] = {   150,
     2,     3,    22,    23,    24,    29,   126,   127,   114,   123,
    78
};

static const short yypact[] = {    24,
    25,    24,-32768,    22,-32768,     8,    26,    27,    28,    29,
-32768,    30,    31,    42,    44,    45,    46,    47,    52,    53,
    54,    38,     8,    37,    40,    41,    43,    48,    51,    49,
    50,    55,    56,    58,    59,    60,    61,    62,    63,-32768,
-32768,-32768,    18,    67,    64,    65,    70,    66,    68,    57,
    57,    57,    57,    57,    57,    57,    57,    -9,    72,    71,
    57,    77,    73,    78,    79,    74,    76,    80,    81,    82,
    83,    84,    85,    86,     3,    95,    93,    99,-32768,    94,
    88,    89,    97,    92,    96,   100,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   101,   103,-32768,   102,    98,
    57,    39,   104,    -9,    -9,-32768,-32768,-32768,    57,     5,
   106,-32768,-32768,   107,    57,   114,   120,   109,-32768,-32768,
-32768,-32768,   110,-32768,    57,   111,   113,   105,   108,   112,
   121,   115,    57,-32768,    57,    57,-32768,   116,    57,-32768,
   117,   118,    57,   119,-32768,-32768,   122,-32768,-32768,    90,
   139,-32768
};

static const short yypgoto[] = {-32768,
-32768,   146,   128,-32768,    36,-32768,   -50,   -51,-32768,-32768,
   -52
};


#define	YYLAST		159


static const short yytable[] = {    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    81,     7,     8,     9,    10,    11,   119,   120,   121,   122,
    95,    96,     8,     9,    10,    11,     1,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    58,   112,   113,
   111,   116,   117,     6,     4,    25,    26,    32,   118,    33,
    34,    35,    36,    27,    28,    30,    31,    37,    38,    39,
    40,    42,    45,    43,   132,    60,    44,    46,    59,    48,
    49,   140,     0,     0,   141,   142,    47,    66,   144,   151,
    50,    51,   147,    52,    53,    54,    55,    56,    57,    63,
     0,    61,    62,    64,    80,    65,    79,    82,    84,    85,
    83,    86,    87,    97,    99,     0,    88,    89,    90,    91,
    92,    93,    94,    98,   100,   101,   102,   103,   104,   128,
   106,   107,   105,   108,   110,   129,   138,   109,   152,   131,
   135,   115,   124,   136,   125,   130,   137,     5,   133,   134,
    41,   143,   139,   145,   146,   148,     0,     0,   149
};

static const short yycheck[] = {    50,
    51,    52,    53,    54,    55,    56,    57,    17,    18,    19,
    61,     4,     5,     6,     7,     8,    12,    13,    14,    15,
    18,    19,     5,     6,     7,     8,     3,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    10,    11,
   101,   104,   105,    32,    30,    30,    30,    16,   109,    16,
    16,    16,    16,    36,    36,    36,    36,    16,    16,    16,
    33,    35,    30,    34,   125,     9,    36,    30,    43,    31,
    31,   133,    -1,    -1,   135,   136,    36,    31,   139,     0,
    36,    36,   143,    36,    36,    36,    36,    36,    36,    30,
    -1,    38,    38,    38,    34,    38,    35,    31,    31,    31,
    38,    38,    37,    19,    16,    -1,    37,    37,    37,    37,
    37,    37,    37,    31,    31,    38,    38,    31,    37,    16,
    31,    31,    37,    31,    37,    16,    16,    36,     0,    30,
    36,    38,    37,    36,    38,    37,    35,     2,    38,    37,
    23,    36,    38,    37,    37,    37,    -1,    -1,    37
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
#line 111 "mg2mbk.yac"
{
			mbkfree(yyvsp[-3].s);
		;
    break;}
case 7:
#line 121 "mg2mbk.yac"
{
			mbkfree(yyvsp[-3].s);
		;
    break;}
case 8:
#line 125 "mg2mbk.yac"
{
			if (!strcmp(yyvsp[-6].s, "ref_ref") || !strcmp(yyvsp[-6].s, "ref_con"))
				addphref(mgleaf, yyvsp[-6].s, checkrefname(yyvsp[-8].s), yyvsp[-2].p->x, yyvsp[-2].p->y);
			else /* unknown internally! */
				addphins(mgleaf, yyvsp[-6].s, checkinsname(yyvsp[-8].s), yyvsp[-5].n, yyvsp[-2].p->x, yyvsp[-2].p->y);
			mbkfree(yyvsp[-8].s);
			mbkfree(yyvsp[-6].s);
			mbkfree(yyvsp[-2].p);
		;
    break;}
case 10:
#line 138 "mg2mbk.yac"
{
			if (strncmp(yyvsp[-5].s, "zd", 2)) {
				fprintf(stderr, "modgen parser warning : ra not for ab box\n");
				/* exit(18); */
			} else
				defab(mgleaf, yyvsp[-3].p->x, yyvsp[-1].p->x, yyvsp[-3].p->y, yyvsp[-1].p->y);
			mbkfree(yyvsp[-5].s);
			mbkfree(yyvsp[-3].p);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 11:
#line 149 "mg2mbk.yac"
{
			if (strcmp(yyvsp[-11].s, "ul") && strcmp(yyvsp[-11].s, "ur")
					&& strcmp(yyvsp[-11].s, "lr") && strcmp(yyvsp[-11].s, "ll"))
				addphcon(mgleaf, (char)yyvsp[-5].n, checkconname(yyvsp[-11].s),
							yyvsp[-1].p->x, yyvsp[-1].p->y, mbk_layer(yyvsp[-4].s), yyvsp[-7].n); 
			mbkfree(yyvsp[-11].s);
			mbkfree(yyvsp[-4].s);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 12:
#line 159 "mg2mbk.yac"
{
		char layer = mbk_layer(yyvsp[-9].s);
		int x1 = yyvsp[-3].p->x, y1 = yyvsp[-3].p->y, x2 = yyvsp[-1].p->x, y2 = yyvsp[-1].p->y;

			mbkfree(yyvsp[-9].s);
			mbkfree(yyvsp[-3].p);
			mbkfree(yyvsp[-1].p);
			if (yyvsp[-5].n == VERTI) {
				if (y2 > y1) {
					y2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
					y1 += Extension[(int)layer] * SCALE_X * TWO / 2;
				} else {
					y2 += Extension[(int)layer] * SCALE_X * TWO / 2;
					y1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
				}
			} else {
				if (x2 > x1) {
					x2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
					x1 += Extension[(int)layer] * SCALE_X * TWO / 2;
				} else {
					x2 += Extension[(int)layer] * SCALE_X * TWO / 2;
					x1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
				}
			}
			addphseg(mgleaf, layer, yyvsp[-7].n, x1, y1, x2, y2, NULL);
		;
    break;}
case 13:
#line 185 "mg2mbk.yac"
{pl = NULL;;
    break;}
case 14:
#line 186 "mg2mbk.yac"
{
		chain_list *l;
		int x1, y1, x2, y2;
		char layer = mbk_layer(yyvsp[-5].s);

			mbkfree(yyvsp[-5].s);
			/* points in inverted order, but doesn't matter, same algo */
			for (l = pl; l->NEXT; l = l->NEXT) {
				x1 = (int)((struct pxy *)(l->DATA))->x;
				y1 = (int)((struct pxy *)(l->DATA))->y;
				x2 = (int)((struct pxy *)(l->NEXT->DATA))->x;
				y2 = (int)((struct pxy *)(l->NEXT->DATA))->y;
				if (l == pl) { /* last point */
					if (x1 == x2) {
						if (y2 > y1) {
							y1 += Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							y1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					} else {
						if (x2 > x1) {
							x1 += Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							x1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					}
				}
				if (!l->NEXT->NEXT) { /* first point */
					if (x1 == x2) {
						if (y2 > y1) {
							y2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							y2 += Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					} else {
						if (x2 > x1) {
							x2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							x2 += Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					}
				}
				addphseg(mgleaf, layer, yyvsp[-3].n, x1, y1, x2, y2, NULL);
			}
		;
    break;}
case 15:
#line 232 "mg2mbk.yac"
{ /* bounding box of transistors is knows for idps technology */
		float tx; /* used to compute transistor bbox */
		int x1, y1, x2, y2;

			/* +-----------+ when not placed yet */
			tx = ((float)yyvsp[-8].n / 2 + (float)O_PS_AA * SCALE_X * TWO);

			switch ((char)yyvsp[-4].n) {
				case NOSYM:
				case SYM_X:
				case SYM_Y:
				case SYMXY:
					y2 = y1 = yyvsp[-1].p->y;
					x1 = yyvsp[-1].p->x + tx;
					x2 = yyvsp[-1].p->x - tx;
					addphseg(mgleaf, NTRANS, yyvsp[-6].n, x1, y1, x2, y2, NULL);
					break;
				case ROT_P:
				case ROT_M:
				case SY_RP:
				case SY_RM:
					x2 = x1 = yyvsp[-1].p->x;
					y1 = yyvsp[-1].p->y + tx;
					y2 = yyvsp[-1].p->y - tx;
					addphseg(mgleaf, NTRANS, yyvsp[-6].n, x1, y1, x2, y2, NULL);
					break;
			}
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 16:
#line 262 "mg2mbk.yac"
{ /* bounding box of transistors is knows for idps technology */
		float tx; /* used to compute transistor bbox */
		int x1, y1, x2, y2;

			/* +-----------+ when not placed yet */
			tx = ((float)yyvsp[-8].n / 2 + (float)O_PS_AA * SCALE_X * TWO);

			switch ((char)yyvsp[-4].n) {
				case NOSYM:
				case SYM_X:
				case SYM_Y:
				case SYMXY:
					y2 = y1 = yyvsp[-1].p->y;
					x1 = yyvsp[-1].p->x + tx;
					x2 = yyvsp[-1].p->x - tx;
					addphseg(mgleaf, PTRANS, yyvsp[-6].n, x1, y1, x2, y2, NULL);
					break;
				case ROT_P:
				case ROT_M:
				case SY_RP:
				case SY_RM:
					x2 = x1 = yyvsp[-1].p->x;
					y1 = yyvsp[-1].p->y + tx;
					y2 = yyvsp[-1].p->y - tx;
					addphseg(mgleaf, PTRANS, yyvsp[-6].n, x1, y1, x2, y2, NULL);
					break;
			}
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 17:
#line 292 "mg2mbk.yac"
{
			addphvia(mgleaf, CONT_DIF_P, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 18:
#line 297 "mg2mbk.yac"
{
			addphvia(mgleaf, CONT_DIF_N, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 19:
#line 302 "mg2mbk.yac"
{
			addphvia(mgleaf, CONT_POLY, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 20:
#line 307 "mg2mbk.yac"
{
			addphvia(mgleaf, CONT_BODY_P, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 21:
#line 312 "mg2mbk.yac"
{
			addphvia(mgleaf, CONT_BODY_N, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 22:
#line 317 "mg2mbk.yac"
{
			addphvia(mgleaf, CONT_VIA, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 23:
#line 322 "mg2mbk.yac"
{
			addphvia(mgleaf, C_X_N, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 24:
#line 327 "mg2mbk.yac"
{
			addphvia(mgleaf, C_X_P, yyvsp[-1].p->x, yyvsp[-1].p->y);
			mbkfree(yyvsp[-1].p);
		;
    break;}
case 25:
#line 334 "mg2mbk.yac"
{
		struct pxy *pp;

			pp = (struct pxy *)mbkalloc(sizeof(struct pxy));
			pp->x = yyvsp[-2].n;
			pp->y = yyvsp[0].n;
			yyval.p = pp;
		;
    break;}
case 26:
#line 345 "mg2mbk.yac"
{
			pl = addchain(pl, (void *)yyvsp[0].p);
		;
    break;}
case 27:
#line 349 "mg2mbk.yac"
{
			pl = addchain(pl, (void *)yyvsp[-2].p);
		;
    break;}
case 28:
#line 354 "mg2mbk.yac"
{yyval.n = (long)HORIZ;;
    break;}
case 29:
#line 355 "mg2mbk.yac"
{yyval.n = (long)VERTI;;
    break;}
case 30:
#line 358 "mg2mbk.yac"
{yyval.n = (long)WEST;;
    break;}
case 31:
#line 359 "mg2mbk.yac"
{yyval.n = (long)EAST;;
    break;}
case 32:
#line 360 "mg2mbk.yac"
{yyval.n = (long)SOUTH;;
    break;}
case 33:
#line 361 "mg2mbk.yac"
{yyval.n = (long)NORTH;;
    break;}
case 34:
#line 364 "mg2mbk.yac"
{yyval.n = (long)NOSYM;;
    break;}
case 35:
#line 366 "mg2mbk.yac"
{yyval.n = (long)SYM_Y;;
    break;}
case 36:
#line 368 "mg2mbk.yac"
{yyval.n = (long)SYM_X;;
    break;}
case 37:
#line 370 "mg2mbk.yac"
{yyval.n = (long)SYMXY;;
    break;}
case 38:
#line 372 "mg2mbk.yac"
{
			if (yyvsp[0].n / SCALE_X / TWO == 90)
				yyval.n = (long)ROT_P;
			if (yyvsp[0].n / SCALE_X / TWO == 270)
				yyval.n = (long)ROT_M;
		;
    break;}
case 39:
#line 379 "mg2mbk.yac"
{
			if (yyvsp[0].n / SCALE_X / TWO == 90)
				yyval.n = (long)SY_RM;
			if (yyvsp[0].n / SCALE_X / TWO == 270)
				yyval.n = (long)SY_RP;
		;
    break;}
case 40:
#line 386 "mg2mbk.yac"
{
			if (yyvsp[0].n / SCALE_X / TWO == 90)
				yyval.n = (long)SY_RP;
			if (yyvsp[0].n / SCALE_X / TWO == 270)
				yyval.n = (long)SY_RM;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 394 "mg2mbk.yac"

char *
	filenameforlex()
{
	return mgleaf->NAME;
}

void
	mgnloadphfig(fig, name, mode)
phfig_list *fig;
char *name;
char mode;
{
extern FILE *yyin; /* declared in the lex.yy.c by default */
extern int yylineno;
chain_list *c;

	mgleaf = fig;
	if ((yyin = mbkfopen(name, IN_PH, READ_TEXT)) == NULL) {
		fflush(stdout);
		fprintf(stderr,
			"*** mbk error *** modgen parser failed opening file %s.%s\n",
			name, IN_PH);
		EXIT(1);
	}
	yylineno = 0;
	if (yyparse()) {
		fflush(stdout);
		fprintf(stderr,
			"*** mbk error *** modgen parser failed while reading file %s\n",
			filepath(name, IN_PH));
		EXIT(1);
	}
	(void)fclose(yyin);
	/* free :
	   temporary space for point list must be freed. */
	for (c = pl; c; c = c->NEXT)
		mbkfree(c->DATA);
	freechain(pl);
	/* not so nice :
	   It would be nice if I'd parse only the necessary stuff when reading
	   the file, but it's a little painful, and would need some checks
	   I can't afford right now. */
	if (mode == 'P') {
	void **ppobj;
	void *next;

		/* delete instances */
		for (ppobj = (void**)&HEAD_PHFIG->PHINS; *ppobj != NULL;) {
			next = (void *)((phins_list *)*ppobj)->NEXT;
			mbkfree((phins_list *)*ppobj);
			*ppobj = next;
		}

		/* delete vias */
		for (ppobj = (void**)&HEAD_PHFIG->PHVIA; *ppobj != NULL;) {
			next = (void *)((phvia_list *)*ppobj)->NEXT;
			mbkfree((phvia_list *)*ppobj);
			*ppobj = next;
		}

		/* delete segments */
		for (ppobj = (void**)&HEAD_PHFIG->PHSEG; *ppobj != NULL;) {
			if (((phseg_list *)*ppobj)->LAYER != TPOLY
					&& ((phseg_list *)*ppobj)->LAYER != TALU1
					&& ((phseg_list *)*ppobj)->LAYER != TALU2
					&& ((phseg_list *)*ppobj)->LAYER != TALU3) {
				next = (void *)((phseg_list *)*ppobj)->NEXT;
				mbkfree((phseg_list *)*ppobj);
				*ppobj = next;
			} else
				ppobj = (void **)&((phseg_list *)*ppobj)->NEXT;
		}
	}
	/* mbk strategy :
	   only one cell per modgen file. */
	fig = HEAD_PHFIG;
}

static char
	mbk_layer(mg_layer)
char *mg_layer;
{
	if (!strcmp(mg_layer, "nw"))
		return NWELL;
	if (!strcmp(mg_layer, "pw"))
		return PWELL;
	if (!strcmp(mg_layer, "xn"))
		return NTIE;
	if (!strcmp(mg_layer, "xp"))
		return PTIE;
	if (!strcmp(mg_layer, "nn"))
		return NDIF;
	if (!strcmp(mg_layer, "pp"))
		return PDIF;
	if (!strcmp(mg_layer, "ps"))
		return POLY;
	if (!strcmp(mg_layer, "m1"))
		return ALU1;
	if (!strcmp(mg_layer, "m2"))
		return ALU2;
	if (!strcmp(mg_layer, "m3"))
		return ALU3;
	if (!strcmp(mg_layer, "am1"))
		return TALU1;
	if (!strcmp(mg_layer, "am2"))
		return TALU2;
	if (!strcmp(mg_layer, "am3"))
		return TALU3;
}

/* decode a reference name :
   xxx[?]          -> xxx
   xxx[?][??]      -> xxx ?,
   xxx[?][??][???] -> xxx ?_??.
   I always have added an index since here also two instances can't have
   the same name. */

static char
	*checkrefname(name)
char *name;
{
char *s, *t, *u = NULL;
char one = 0;

   s = t = name;

   while (*t) {
      if (*t == '[')
			if (!one) {
         	*t = ' ';
				u = s;
				one = 1;
			} else if (one == 1) {
         	*t = '_';
				u = s;
				one++;
			} else {
         	*t = ' ';
				u = s;
			}
      else if (*t == ']')
         if (*(++t) == '\0') /* ok, it's finished */
            goto end;
         else if (*t == '[') /* multiple array */
            continue;
      *s++ = *t++;
   }
end:
   *s = '\0';
	/* last vectorized value :
	   it shall be skipped since I introduced it while driving the file. */
	if (u)
   	*u = '\0';
   return name;
}

/* decode a connector name :
   in modgen, 'cause we haven't the same conventions, a by me driven
   connector has the forms :
   xxx[?] -> xxx, where ? is a number, because I suffix all connectors that
                  way.
   xxx[??][?] -> xxx[??], because this was previously a vector. */

static char
	*checkconname(name)
char *name;
{
char *s, *t, *u = NULL;

   s = t = name;
   while (*t) {
      if (*t == '[') {
        	*t = ' ';
			u = s; /* last vector at that time */
      } else if (*t == ']') {
         if (*(++t) == '\0') /* ok, it's finished */
            goto end;
         else if (*t == '[') /* multiple array */
            continue;
		}
      *s++ = *t++;
   }
end:
   *s = '\0';
	/* last vectorized value :
	   it shall be skipped since I introduced it while driving the file. */
	if (u)
   	*u = '\0';
   return name;
}

/* decode an instance name :
   in modgen, 'cause we haven't the same conventions, a by me driven
   instance has the forms :
   xxx.corner
	since I arranged to put the corner in such a place that it makes it
   automatically good for mbk, I just forgot about the corner. */

static char
	*checkinsname(name)
char *name;
{
char *s = name;

	s = strrchr(name, '.');
   *s = '\0';
   return name;
}
