/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :  Synthetiseur de FSM                                       */
/*    Fichier :  syf_verif.h                                                  */
/*                                                                          */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) :  C. Sarwary                            le : 04/03/1992     */
/*                                                                          */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/***************************************************************************/


/* LES DECLARATIONS DE TYPE, dans les .h ..... please ... */

typedef struct doubleI
	{
	struct doubleI *next ;
	int newI, lastI ;
	}*pDoubleI ;

extern void verifCode();
extern void fsm_verify();
extern struct syf_bepcs *givMainProcess();
extern void syf_beh_verify();
extern void verifIf();
extern void verifWhen();
extern void verifAsg();
extern void verifPushPop();
extern void markPop();
extern void markAllPushPop();
extern int markSubAuto();
extern int isPush();
extern int isPush1();
extern void displayLst();
extern void flattenStack();
extern int markPush2Pop();
extern void doubleSubFsm();
extern chain_list *givePopCnd();
extern void doubleState();
extern int getLabel();
extern void delFromStack();
extern chain_list *givePopLst();
extern chain_list *invLst();
extern int giveLabel();
extern void createDoubleState();
extern pLocOut doubleLocOut();
extern void regenerState();
extern void changeLabel();
extern void copyState();
extern int isLabel();
extern void displayDoubleI();
extern void displayUser();
extern pTrans copyTrans();
extern void markkFsm();

