/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : TAS Version 3.50                                            */
/*    Fichier : visu.c                                                      */
/*                                                                          */
/*    (c) copyright 1991-1992 Laboratoire MASI equipe CAO & VLSI            */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Amjad HAJJAR et Payam KIANI           le : 28/05/1991     */
/*                                                                          */
/*    Modifie par : Payam KIANI                         le : 22/07/1992     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/
/* fichier visu.c : visualisation des parametres technologie                */
/****************************************************************************/
#include "tas_all.h"

/******************************************************************************/
/*                        function visu()                                     */
/* affichage des parametres techno.                                           */
/******************************************************************************/
void visu()
{
fprintf(stdout,"SCALE_X  = %ld\n",SCALE_X) ;
fprintf(stdout,"RN       = %le\n",RN) ;
fprintf(stdout,"RP       = %le\n",RP) ;
fprintf(stdout,"FRONT_CON = %le\n",FRONT_CON) ;
fprintf(stdout,"AN       = %le\n",AN) ;
fprintf(stdout,"BN       = %le\n",BN) ;
fprintf(stdout,"AP       = %le\n",AP) ;
fprintf(stdout,"BP       = %le\n",BP) ;
fprintf(stdout,"RNT      = %le\n",RNT) ;
fprintf(stdout,"RPT      = %le\n",RPT) ;
fprintf(stdout,"VDDmax   = %le\n",VDDmax) ;
fprintf(stdout,"VTP      = %le\n",VTP) ;
fprintf(stdout,"VTN      = %le\n",VTN) ;
fprintf(stdout,"SEUIL    = %le\n",SEUIL) ;
fprintf(stdout,"RNDD     = %le\n",RNDD) ;
fprintf(stdout,"RPDD     = %le\n",RPDD) ;
fprintf(stdout,"KNDD     = %le\n",KNDD) ;
fprintf(stdout,"KPDD     = %le\n",KPDD) ;
fprintf(stdout,"RNDF     = %le\n",RNDF) ;
fprintf(stdout,"RPDF     = %le\n",RPDF) ;
fprintf(stdout,"VSSdeg   = %le\n",VSSdeg) ;
fprintf(stdout,"VDDdeg   = %le\n",VDDdeg) ;
fprintf(stdout,"RNUD     = %le\n",RNUD) ;
fprintf(stdout,"RPUD     = %le\n",RPUD) ;
fprintf(stdout,"KNUD     = %le\n",KNUD) ;
fprintf(stdout,"KPUD     = %le\n",KPUD) ;
fprintf(stdout,"RNUF     = %le\n",RNUF) ;
fprintf(stdout,"RPUF     = %le\n",RPUF) ;
fprintf(stdout,"QN       = %le\n",QN) ;
fprintf(stdout,"QP       = %le\n",QP) ;
fprintf(stdout,"KGDD     = %le\n",KGDD) ;
fprintf(stdout,"KGUD     = %le\n",KGUD) ;
fprintf(stdout,"INFB     = %le\n",INFB) ;
fprintf(stdout,"IPFB     = %le\n",IPFB) ;
fprintf(stdout,"DLP      = %le\n",elpShrink[elpDLP]) ;
fprintf(stdout,"DLN      = %le\n",elpShrink[elpDLN]) ;
fprintf(stdout,"DWP      = %le\n",elpShrink[elpDWP]) ;
fprintf(stdout,"DWN      = %le\n",elpShrink[elpDWN]) ;
fprintf(stdout,"LMLT     = %le\n",elpShrink[elpLMLT]) ;
fprintf(stdout,"WMLT     = %le\n",elpShrink[elpWMLT]) ;
fprintf(stdout,"CGSN     = %le\n",elpCapa[elpNMOS][elpCGS]) ;
fprintf(stdout,"CGSP     = %le\n",elpCapa[elpPMOS][elpCGS]) ;
fprintf(stdout,"CGPN     = %le\n",elpCapa[elpNMOS][elpCGP]) ;
fprintf(stdout,"CGPP     = %le\n",elpCapa[elpPMOS][elpCGP]) ;
fprintf(stdout,"CDSN     = %le\n",elpCapa[elpNMOS][elpCDS]) ;
fprintf(stdout,"CDSP     = %le\n",elpCapa[elpPMOS][elpCDS]) ;
fprintf(stdout,"CDPN     = %le\n",elpCapa[elpNMOS][elpCDP]) ;
fprintf(stdout,"CDPP     = %le\n",elpCapa[elpPMOS][elpCDP]) ;
fprintf(stdout,"CDWN     = %le\n",elpCapa[elpNMOS][elpCDW]) ;
fprintf(stdout,"CDWP     = %le\n",elpCapa[elpPMOS][elpCDW]) ;
fprintf(stdout,"CSSN     = %le\n",elpCapa[elpNMOS][elpCSS]) ;
fprintf(stdout,"CSSP     = %le\n",elpCapa[elpPMOS][elpCSS]) ;
fprintf(stdout,"CSPN     = %le\n",elpCapa[elpNMOS][elpCSP]) ;
fprintf(stdout,"CSPP     = %le\n",elpCapa[elpPMOS][elpCSP]) ;
fprintf(stdout,"CSWN     = %le\n",elpCapa[elpNMOS][elpCSW]) ;
fprintf(stdout,"CSWP     = %le\n",elpCapa[elpPMOS][elpCSW]) ;
fflush(stdout) ;
}
